/*
 *	TOPPERS NonOS CAN Middleware
 *		Toyohashi Open Platform for Embedded Real-Time Systems
 *		NonOS CAN Middleware
 * 
 *	Copyright (C) 2007 Sunny Giken Inc.
 * 
 *	L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *	ɂČ\Ă GNU General Public License  Version 2 ɋL
 *	qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *	ς̂܂ށDȉjgpEEρEĔzziȉC
 *	pƌĂԁj邱Ƃ𖳏ŋD
 *	(1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *		\C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *		XR[hɊ܂܂Ă邱ƁD
 *	(2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *		pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *		҃}jAȂǁjɁCL̒쌠\C̗pщL
 *		̖ۏ؋Kfڂ邱ƁD
 *	(3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *		płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *		ƁD
 *	  (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *		  쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *	  (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *		  񍐂邱ƁD
 *	(4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *		QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *	{\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *	TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *	܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *	ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */
/*
 *@Version 1.00  2007.10.26
 */

/*
 *	CMW-COMW[
 */

/*---------------------------------------------------------------------------*/
/*  wb_t@C̃CN[h                                             */
/*---------------------------------------------------------------------------*/
/* ʃwb_ */
#include    "can_cmn.h"             /* lbg[NOSpeݒt@C      */

/* DRV֘A */
#include    "can_drv_csw.h"         /* DRV֘ARpCXCb`pt@C   */
#include    "can_drv_def.h"         /* DRV֘Aݒt@C                   */
#include    "can_drv_ext.h"         /* DRVO[o`t@C             */

/* pwb_ */
#include    "can_com_def.h"         /* COMwb_t@C                     */
#include    "can_com_api.h"         /* AvP[Vf[^̃rbg`    */
#include    "can_com_ext.h"         /* COMO[o`t@C             */
#include    "can_com.h"             /* COM`t@C                       */

/* IndirectNMp */
#ifdef CAN_COM_NM_INDIRECT
#include    "can_nm_csw.h"          /* NM֘ARpCXCb`pt@C    */
#include    "can_nm_def.h"          /* NMpUSER`t@C                */
#include    "can_nm_ext.h"          /* NMO[o`t@C              */
#endif

/*---------------------------------------------------------------------------*/
/*  ֐prototype錾                                                      */
/*---------------------------------------------------------------------------*/
/* ֘A */
static void InitAPIBufCOM(void);            /* APIMobt@                  */
static void InitSndStsCOM(void);            /* Mf[^IDf[^Xe[^X   */
static void InitSndStsNoChgSndCOM(void);    /* Cxg+M(^Cv2)MtO   */
                                            /* ȊȎMf[^Xe[^X     */
static void InitTimeCOM(void);              /* COM^C}ϐ              */
static void InitCntCOM(UINT8);              /* COMJE^                */

/* M֘A */
static void ChkTblDataCOM(void);            /* COMf[^e[u`FbN            */
static void ChkSndDataValidCOM(void);       /* Mf[^LE菈             */
static void ChkSndStopCOM(void);            /* Mr┻菈                         */
static void ScanEventCOM(UINT8);            /* CxgMbZ[WXL       */
static void ScanPeriCOM(UINT8);             /* MbZ[WXL           */
static void SetSndMsgBuf2BkupCOM(UINT8, UINT8 ,UINT8);  /* obNAbvi[         */
static void ChkSndItvTimeCOM(void);         /* MԊuۏؔ菈                     */
static void SndMsgCOM(void);                /* ML[bZ[Wǂݏo         */
static void UpdtPriCOM(void);               /* MbZ[WvCIeBXV     */
static UINT8 CmpBufandBkupCOM(UINT8);       /* CxgM̔o               */
static UINT8 ChkChgSndPeriCondCOM(UINT8);   /* Cxg+M(^Cv2)̔o */
static UINT8 CheckMsgFormat(UINT8);         /* bZ[WtH[}bg               */

static void UpdtSndIDStsCOM(UINT8, UINT8);  /* Mf[^IDXe[^XXV           */
static void UpdtDrvSndStsCOM(UINT8);        /* DRIVERMXe[^XXV             */

static void InitSndQueCOM(void);            /* ML[                     */
static void KeepEventIntvCOM(void);         /* EVENT-EVENTԎ(msec)ۏ؏          */
static void ScanWaitDataCOM(void);          /* ML[i[҂bZ[WXL */
static void SetSndMsgBkup2QueCOM(UINT8);    /* ML[i[                       */

/* M֘A */
static void ChkRcvStopCOM(void);            /* Mr┻菈                         */
static UINT8 SetRcvMsgBufCOM(const CANMsgType *, UINT8 *);  /* Mobt@i[     */
static void WrAPIRcvBuff(UINT8 n_rdtid_idx, const CANMsgType *in_ptr_rdt);  
                                                            /* APIMobt@i[  */
static void UpdtRcvIDStsCOM(UINT8, UINT8);  /* Mf[^IDXe[^XXV           */

/* DRIVERM荞ݎgp */
#if CAN_COM_USE_RCVINT == CAN_TRUE
static void InitRcvQueCOM(void);            /* ML[                         */
static void GetRcvMsgQue2BufCOM(void);      /* ML[bZ[WMobt@i[   */
/* DRIVERM荞ݖgp */
#else
static void GetRcvMsgSlot2BufCOM(void);     /* MXbgbZ[WMobt@i[ */
#endif

/* f[^Rs[p` */
static void MCpyData2BkupCOM(UINT8);        /* APIMf[^obNAbvփRs[      */
static void MCpyData2QueCOM(UINT8, UINT8);  /* obNAbvf[^𑗐ML[փRs[   */


/*---------------------------------------------------------------------------*/
/*  Oϐ                                                                 */
/*---------------------------------------------------------------------------*/
/* DRIVERM荞ݎgp */
#if CAN_COM_USE_RCVINT == CAN_TRUE
static COMRcvQueType COMRcvQue;                /* COMML[ */
#endif

/*---------------------------------------------------------------------------*/
/*  ϐ                                                                 */
/*---------------------------------------------------------------------------*/
static UINT16   C_Time;                         /* COMO[o^C}                  */
static COMStsType   C_Sts;                      /* COMXe[^X                */
                                                /* gpĂȂo邪薳 */
static COMSndDataStsType    C_SndDataSts[CAN_COM_NUM_SNDDATA];  /* Mf[^Xe[^X */
static COMRcvDataStsType    C_RcvDataSts[CAN_COM_NUM_RCVDATA];  /* Mf[^Xe[^X */
static UINT16   C_PeriCnt[CAN_COM_NUM_SNDDATA];         /* MpvJE^   */
static UINT16   C_PeriCntDef[CAN_COM_NUM_SNDDATA];      /* Mf[^i[̈   */
static UINT16   C_SndItvCnt;                            /* Mr⌟oJE^         */
static UINT16   C_RcvItvCnt[CAN_COM_NUM_RCVDATA];       /* Mr⌟oJE^         */
static UINT16   C_RcvItvCntDef[CAN_COM_NUM_RCVDATA];    /* Mr⎞ԃf[^i[̈   */
static UINT16   C_SysTime;                              /* 1msecVXe^C}          */
static UINT16   C_SysTimeCapBuf;                        /* MԊuۏؗpobt@       */
static COMSndDRVStsType     C_DrvSndSts;                /* hCoMXe[^X       */

static UINT8    C_SndQueSts;                            /* ML[󂫌obt@   */
static COMSndQueType    C_SndQue[CAN_COM_NUM_SNDQUE];   /* COMML[                */

#ifdef CAN_COM_NM_INDIRECT
static UINT8    C_OwnNode;                              /* ɰޑMtO             */
static UINT8    C_OwnNodeCnt;                           /* ɰޑMQueJEg        */
#endif
/*---------------------------------------------------------------------------*/
/*  萔                                                                     */
/*---------------------------------------------------------------------------*/

/* ML[tOA󂫂̃L[ԍ邽߂̃e[u */
static const UINT8  Q2POS_TABLE[] = {
     0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4    /* 00000000 - 00001111 */
    ,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5    /* 00010000 - 00011111 */
    ,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4    /* 00100000 - 00101111 */
    ,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6    /* 00110000 - 00111111 */
    ,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4    /* 01000000 - 01001111 */
    ,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5    /* 01010000 - 01011111 */
    ,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4    /* 01100000 - 01101111 */
    ,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7    /* 01110000 - 01111111 */
    ,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4    /* 10000000 - 10001111 */
    ,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5    /* 10010000 - 10011111 */
    ,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4    /* 10100000 - 10101111 */
    ,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6    /* 10110000 - 10111111 */
    ,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4    /* 11000000 - 11001111 */
    ,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5    /* 11010000 - 11011111 */
    ,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4    /* 11100000 - 11101111 */
    ,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,0xFF /* 11110000 - 11111111 */
};

/* ML[tO}XNp */
static const UINT8  QUE_MASK_TABLE[] = {
     0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80
};

/* ML[tTCY */
static const UINT8  QUE_MAX_TABLE[] = {
     0x01, 0x03, 0x07, 0x0F, 0x1F, 0x3F, 0x7F, 0xFF
};

/*---------------------------------------------------------------------------*/
/*  ֐                                                                     */
/*---------------------------------------------------------------------------*/
/*****************************************************************************/
/*  Function name : void InitCOM(void)                                       */
/*---------------------------------------------------------------------------*/
/*  Description : COM                                              */
/*                s^C~O:Av                          */
/*                ӎ : [U[AṽCjVŃR[邱  */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
void InitCOM(void)
{
    /************ vO ************/
    C_Sts.byte = (UINT8)CAN_CLR;

#ifdef CAN_COM_NM_INDIRECT
    C_OwnNode   = CAN_FALSE;
    C_OwnNodeCnt= (UINT8)CAN_CLR;
#endif
    InitAPIBufCOM();
    InitTimeCOM();
    InitCntCOM(CAN_COM_POWER_ON);
    InitSndStsCOM();

    InitSndQueCOM();

/* DRIVERM荞ݎgp */
#if CAN_COM_USE_RCVINT == CAN_TRUE
    InitRcvQueCOM();
#endif

    UpdtSndIDStsCOM((UINT8)CAN_CLR, CAN_COM_POWERON_INIT);
    UpdtRcvIDStsCOM((UINT8)CAN_CLR, CAN_COM_INIT);

    UpdtDrvSndStsCOM(CAN_COM_INIT);

    ChkTblDataCOM();
}
/*****************************************************************************/
/*  Function name : void InitBufferCOM(void)                                 */
/*---------------------------------------------------------------------------*/
/*  Description : APIMobt@                                */
/*                s^C~O: C                                       */
/*                ӎ : [U[AvWakeUp̂݃R[\        */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
void InitBufferCOM(void)
{
    /************ vO ************/
    InitAPIBufCOM();
    InitSndStsCOM();
    UpdtSndIDStsCOM((UINT8)CAN_CLR, CAN_COM_RFSH);
    UpdtRcvIDStsCOM((UINT8)CAN_CLR, CAN_COM_RFSH);
}
/*****************************************************************************/
/*  Function name : static void InitAPIBufCOM(void)                          */
/*---------------------------------------------------------------------------*/
/*  Description : APIMobt@l                            */
/*                s^C~O: InitCOM(),InitBufferCOM()                */
/*                ӎ : ǐ̈׃}WbNiogp                  */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void InitAPIBufCOM(void)
{
    /************ I[gϐ ************/
    UINT8 lp_dtid;          /* Mf[^ID[vϐ */

    /************ vO ************/
    /* SĂ̑Mf[^IDɁAlB */
    /* ftHglobNAbv */
    /* ftHglAPIMobt@ */
    for(lp_dtid=0; lp_dtid<CAN_COM_NUM_SNDDATA; lp_dtid++)
    {
        C_SndDataSts[lp_dtid].backup.word[0] = CANSNDDATA_TABLE[lp_dtid].def.word[0];
        C_SndDataSts[lp_dtid].backup.word[1] = CANSNDDATA_TABLE[lp_dtid].def.word[1];
        C_SndDataSts[lp_dtid].backup.word[2] = CANSNDDATA_TABLE[lp_dtid].def.word[2];
        C_SndDataSts[lp_dtid].backup.word[3] = CANSNDDATA_TABLE[lp_dtid].def.word[3];
        api_snddata[lp_dtid].word[0] = CANSNDDATA_TABLE[lp_dtid].def.word[0];
        api_snddata[lp_dtid].word[1] = CANSNDDATA_TABLE[lp_dtid].def.word[1];
        api_snddata[lp_dtid].word[2] = CANSNDDATA_TABLE[lp_dtid].def.word[2];
        api_snddata[lp_dtid].word[3] = CANSNDDATA_TABLE[lp_dtid].def.word[3];
    } /* for(lp_dtid=0; lp_dtid<CAN_COM_NUM_SNDDATA; lp_dtid++) */

    /* ftHglAPIMobt@ */
    for(lp_dtid=0; lp_dtid<CAN_COM_NUM_RCVDATA; lp_dtid++)
    {
        api_rcvdata[lp_dtid].word[0] = CANRCVDATA_TABLE[lp_dtid].def.word[0];
        api_rcvdata[lp_dtid].word[1] = CANRCVDATA_TABLE[lp_dtid].def.word[1];
        api_rcvdata[lp_dtid].word[2] = CANRCVDATA_TABLE[lp_dtid].def.word[2];
        api_rcvdata[lp_dtid].word[3] = CANRCVDATA_TABLE[lp_dtid].def.word[3];
    } /* for(lp_dtid=0; lp_dtid<CAN_COM_NUM_RCVDATA; lp_dtid++) */
}
/*****************************************************************************/
/*  Function name : static void InitSndStsCOM(void)                          */
/*---------------------------------------------------------------------------*/
/*  Description : w著Mf[^ID̃f[^Xe[^X                   */
/*                s^C~O: InitCOM(),InitBufferCOM()                  */
/*                                ,SndCOM(),ChkSndStopCOM()                */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void InitSndStsCOM(void)
{
    /************ I[gϐ ************/
    UINT8 lp_sdtid;     /* Mf[^ID[vϐ */

    /************ vO ************/
    /* SMf[^Xe[^X */
    for(lp_sdtid=0; lp_sdtid<CAN_COM_NUM_SNDDATA; lp_sdtid++)
    {
        C_SndDataSts[lp_sdtid].pri = (UINT8)CAN_CLR;
        C_SndDataSts[lp_sdtid].pre_time = C_Time;
        C_SndDataSts[lp_sdtid].chgsndperi = CAN_OFF;
        C_SndDataSts[lp_sdtid].keep_intv = CAN_OFF;
        C_SndDataSts[lp_sdtid].dummy = CAN_OFF;
    }
}

/*****************************************************************************/
/*  Function name : static void InitSndStsNoChgSndCOM(void)                  */
/*---------------------------------------------------------------------------*/
/*  Description : Cxg+M(^Cv2)MtOȊO               */
/*                Mf[^Xe[^X                                 */
/*                s^C~O: ChkSndStopCOM(),SndCOM()                 */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void InitSndStsNoChgSndCOM(void)
{
    /************ I[gϐ ************/
    UINT8 lp_sdtid;     /* Mf[^ID[vϐ */

    /************ vO ************/
    /* SMf[^Xe[^X */
    for(lp_sdtid=0; lp_sdtid<CAN_COM_NUM_SNDDATA; lp_sdtid++)
    {
        C_SndDataSts[lp_sdtid].pri = (UINT8)CAN_CLR;
        C_SndDataSts[lp_sdtid].pre_time = C_Time;
        C_SndDataSts[lp_sdtid].keep_intv = CAN_OFF;
        C_SndDataSts[lp_sdtid].dummy = CAN_OFF;
    }
}

/*****************************************************************************/
/*  Function name : static void InitTimeCOM(void)                            */
/*---------------------------------------------------------------------------*/
/*  Description : COM^C}ϐ                                */
/*                s^C~O: InitCOM(),SndCOM(),ChkSndStopCOM()       */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void InitTimeCOM(void)
{
    /************ vO ************/
    C_Time = (UINT16)CAN_CLR;
    C_SysTime = (UINT16)CAN_CLR;
    C_SysTimeCapBuf = (UINT16)CAN_CLR;
}
/*****************************************************************************/
/*  Function name : static void InitCntCOM(UINT8 in_mode)                    */
/*---------------------------------------------------------------------------*/
/*  Description : COMJE^                                  */
/*                s^C~O: InitCOM(),SndCOM(),ChkSndStopCOM()       */
/*---------------------------------------------------------------------------*/
/*  parameter : UINT8 in_modeFCAN~hEFȀ                         */
/*                        CAN_COM_POWER_ONFd                       */
/*                        CAN_COM_SLEEPFSleepڍs                         */
/*                        CAN_COM_BUSOFFFoXIt                         */
/*                        CAN_COM_SNDSTOPFMr⎞                        */
/*  result    : none                                                         */
/*****************************************************************************/
static void InitCntCOM(UINT8 in_mode)
{
    /************ I[gϐ ************/
    UINT8 lp_dtid;      /* f[^ID[vϐ */

    /************ vO ************/
    /* ̃f[^l`FbN */
    /* d̏orSleepڍs̏ */
    if(    (in_mode == CAN_COM_POWER_ON)
        || (in_mode == CAN_COM_SLEEP)
    )
    {
        /* M֘Af[^(ftHgl)̃Zbg */
        for(lp_dtid=0; lp_dtid<CAN_COM_NUM_SNDDATA; lp_dtid++)
        {
            C_PeriCntDef[lp_dtid] = (CANSNDDATA_TABLE[lp_dtid].snd_cycle / CAN_COM_MAIN_CYCLE);
            C_PeriCnt[lp_dtid] = (CANSNDDATA_TABLE[lp_dtid].offset / CAN_COM_MAIN_CYCLE);
        } /* for(lp_dtid=0; lp_dtid<CAN_COM_NUM_SNDDATA; lp_dtid++) */

        C_SndItvCnt = (UINT16)(CAN_COM_SNDITVCNT_DEFDATA - 1);

        /* M֘Af[^(ftHgl)̃Zbg */
        for(lp_dtid=0; lp_dtid<CAN_COM_NUM_RCVDATA; lp_dtid++)
        {
            C_RcvItvCntDef[lp_dtid] = (CANRCVDATA_TABLE[lp_dtid].interval / CAN_COM_MAIN_CYCLE);
            if(in_mode == CAN_COM_POWER_ON)
            {
                if(CANRCVDATA_TABLE[lp_dtid].mask >= (UINT16)CAN_ECU_INIT_TIME)
                {
                    C_RcvItvCnt[lp_dtid] 
                        = ((CANRCVDATA_TABLE[lp_dtid].mask - (UINT16)CAN_ECU_INIT_TIME)
                             / CAN_COM_MAIN_CYCLE);
                }
                else
                {
                    C_RcvItvCnt[lp_dtid] = (UINT16)CAN_CLR;
                }
            }
            else
            {
                C_RcvDataSts[lp_dtid].sts.rcvdata.pwon = CAN_OFF;
                C_RcvItvCnt[lp_dtid] = C_RcvItvCntDef[lp_dtid];
            }
        } /* for(lp_dtid=0; lp_dtid<CAN_COM_NUM_RCVDATA; lp_dtid++) */
    }
    /* oXIt̏orMr⎞̏ */
    else if(   (in_mode == CAN_COM_BUSOFF)
            || (in_mode == CAN_COM_SNDSTOP)
    )
    {
        /* M֘Af[^̓ǂݏo(e[uftHglZbg) */
        for(lp_dtid=0; lp_dtid<CAN_COM_NUM_SNDDATA; lp_dtid++)
        {
            if(C_PeriCntDef[lp_dtid] > 0)
            {
                C_PeriCnt[lp_dtid] = (C_PeriCntDef[lp_dtid] - 1);
            }
            else
            {
                C_PeriCnt[lp_dtid] = (UINT16)CAN_CLR;
            }
        }

        C_SndItvCnt = (UINT16)(CAN_COM_SNDITVCNT_DEFDATA - 1);
    }
    else if(in_mode == CAN_COM_TWBSNORMAL)
    {
        /* M֘Af[^̓ǂݏo(e[uItZbglZbg) */
        for(lp_dtid=0; lp_dtid<CAN_COM_NUM_SNDDATA; lp_dtid++)
        {
            if(C_PeriCntDef[lp_dtid] > 0)
            {
                C_PeriCnt[lp_dtid] = (CANSNDDATA_TABLE[lp_dtid].offset / CAN_COM_MAIN_CYCLE);
            }
            else
            {
                C_PeriCnt[lp_dtid] = (UINT16)CAN_CLR;
            }
        }

        C_SndItvCnt = (UINT16)(CAN_COM_SNDITVCNT_DEFDATA - 1);
    }
    /* LȊO͉ */
    else
    {
    }
}
/*****************************************************************************/
/*  Function name : static void InitSndQueCOM(void)                          */
/*---------------------------------------------------------------------------*/
/*  Description : ML[                                       */
/*                s^C~O: InitCOM(),SndCOM(),ChkSndStopCOM()       */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void InitSndQueCOM(void)
{
    /************ I[gϐ ************/
    UINT8 lp_sq;        /* ML[[vϐ */

    /************ vO ************/
    C_SndQueSts = (UINT8)CAN_CLR;

    /* S̈0NA */
    for(lp_sq=0; lp_sq<CAN_COM_NUM_SNDQUE; lp_sq++)
    {
        C_SndQue[lp_sq].msg.can_id = (UINT16)CAN_CLR;
        C_SndQue[lp_sq].msg.dlc = (UINT8)CAN_CLR;
        C_SndQue[lp_sq].msg.data.word[0] = (UINT16)CAN_CLR;
        C_SndQue[lp_sq].msg.data.word[1] = (UINT16)CAN_CLR;
        C_SndQue[lp_sq].msg.data.word[2] = (UINT16)CAN_CLR;
        C_SndQue[lp_sq].msg.data.word[3] = (UINT16)CAN_CLR;
        C_SndQue[lp_sq].snd_time = C_Time;
        C_SndQue[lp_sq].pri = (UINT8)CAN_CLR;

#ifdef CAN_COM_NM_INDIRECT
        C_SndQue[lp_sq].own_node = CAN_OFF;
#endif

        C_SndQue[lp_sq].dummy = CAN_OFF;
    }
}
/*****************************************************************************/
/*  Function name : static void InitRcvQueCOM(void)                          */
/*---------------------------------------------------------------------------*/
/*  Description : ML[                                       */
/*                s^C~O: InitCOM(),SndCOM()                       */
/*                ӎ : DRIVERM荞ݎgp̂                  */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
/* DRIVERM荞ݎgp */
#if CAN_COM_USE_RCVINT == CAN_TRUE
static void InitRcvQueCOM(void)
{
    /************ I[gϐ ************/
    UINT8 lp_rq;        /* ML[[vϐ */

    /************ vO ************/
    /* S̈0NA */
    for(lp_rq=0; lp_rq<CAN_COM_NUM_RCVQUE; lp_rq++)
    {
        COMRcvQue.msg[lp_rq].can_id = (UINT16)CAN_CLR;
        COMRcvQue.msg[lp_rq].dlc = (UINT8)CAN_CLR;
        COMRcvQue.msg[lp_rq].data.word[0] = (UINT16)CAN_CLR;
        COMRcvQue.msg[lp_rq].data.word[1] = (UINT16)CAN_CLR;
        COMRcvQue.msg[lp_rq].data.word[2] = (UINT16)CAN_CLR;
        COMRcvQue.msg[lp_rq].data.word[3] = (UINT16)CAN_CLR;
    }

    COMRcvQue.wr_ptr = (UINT8)CAN_CLR;
    COMRcvQue.rd_ptr = (UINT8)(CAN_COM_NUM_RCVQUE - 1);
}
#endif
/*****************************************************************************/
/*  Function name : void SndCOM(void)                                        */
/*---------------------------------------------------------------------------*/
/*  Description : COMM                                                */
/*                s^C~O: [U[Av                       */
/*                ӎ : @AvvÕCŃR[        */
/*                           AI[gϐm_stsGetCOMCtrlSts()l      */
/*                             ׁAKv͖            */
/*                           BI[gϐm_nm_modeGetStatus()l      */
/*                             ׁAKv͖            */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
void SndCOM(void)
{
    /************ I[gϐ ************/
    UINT8   m_com_mode = (UINT8)CAN_CLR;    /* COM샂[h         */
    COMStsType m_sts;                       /* COMXe[^X */
    UINT8 nm_sts;                           /* NMXe[^Xi[̈  */

    /************ vO ************/
    C_Sts.byte &= CAN_COM_STOPINF_MASK;
    if(GetCOMCtrlSts(&m_sts) == CAN_E_OK)
    {
        m_sts.byte &= CAN_COM_MODE_MASK;
        C_Sts.byte |= m_sts.byte;
    }

    ChkSndDataValidCOM();

    m_com_mode = (C_Sts.byte & CAN_COM_MODE_MASK);
    switch(m_com_mode)
    {
        case CAN_COM_NML:
            ChkSndStopCOM();
            KeepEventIntvCOM();
            ScanWaitDataCOM();
            ScanEventCOM(m_com_mode);
            ScanPeriCOM(m_com_mode);
            ChkSndItvTimeCOM();
            SndMsgCOM();
            UpdtPriCOM();
            break;

        case CAN_COM_WAITING:
            ScanEventCOM(m_com_mode);
            UpdtPriCOM();
            break;

        case CAN_COM_RCVONLY:
            InitTimeCOM();
            /* NMd/SleepAȊȌԂȂCOMJE^ */
            if(GetNMStatus(&nm_sts) == CAN_E_OK)
            {
                if( (nm_sts == CAN_COM_BUSOFF) || (nm_sts == CAN_COM_TWBSNORMAL) )
                {
                    InitCntCOM(nm_sts);
                }
                else
                {
                    /*  */
                }
            }
            InitSndStsNoChgSndCOM();
            InitSndQueCOM();
            UpdtSndIDStsCOM((UINT8)CAN_CLR, CAN_COM_RFSH);
            UpdtDrvSndStsCOM(CAN_COM_INIT);
            break;

        case CAN_COM_STP:
            /* break; */
        default:
            InitTimeCOM();
            InitCntCOM(CAN_COM_SLEEP);
            InitSndStsNoChgSndCOM();

            InitSndQueCOM();

/* DRIVERM荞ݎgp */
#if CAN_COM_USE_RCVINT == CAN_TRUE
            InitRcvQueCOM();
#endif
            UpdtSndIDStsCOM((UINT8)CAN_CLR, CAN_COM_INIT);
            UpdtRcvIDStsCOM((UINT8)CAN_CLR, CAN_COM_RFSH);
            UpdtDrvSndStsCOM(CAN_COM_INIT);

            ChkTblDataCOM();
    } /* switch(m_com_mode) */
}
/*****************************************************************************/
/*  Function name : static void ChkTblDataCOM(void)                          */
/*---------------------------------------------------------------------------*/
/*  Description : COMf[^e[u`FbN                              */
/*                s^C~O: InitCOM(),SndCOM()                       */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void ChkTblDataCOM(void)
{
    /************ I[gϐ ************/
    UINT8   m_mode = (UINT8)CAN_CLR;    /* M[hi[̈     */
    UINT8   lp_sdtid;                   /* Mf[^ID[vϐ */

    /************ vO ************/
    /* SMf[^ID`FbN */
    for(lp_sdtid=0; lp_sdtid<CAN_COM_NUM_SNDDATA; lp_sdtid++)
    {
        C_SndDataSts[lp_sdtid].sts.snddata.tblvalid = CAN_ON;

        /* e[uf[^l`FbN */
        /* rbgATC``FbN@(8傫͖f[^Ƃ) */
        if(CANSNDDATA_TABLE[lp_sdtid].dlc > CAN_COM_DLC_SIZE)
        {
            C_SndDataSts[lp_sdtid].sts.snddata.tblvalid = CAN_OFF;
        }
        else
        {
            /* M[h`FbN */
            /* (M[hKȊO͖̎f[^AK胂[h͍XɃ`FbNĂ) */
            m_mode = (CANSNDDATA_TABLE[lp_sdtid].snd_mode.byte & CAN_COM_SNDMODE_MASK);
            switch(m_mode)
            {
                case CAN_COM_EVENT_MODE:
                case CAN_COM_PERIODIC_MODE:
                case CAN_COM_EVENT_PERIODIC_MODE:
                case CAN_COM_CHGSND_PERIODIC_MODE:
                    /* MԊumۏ`FbN */
                    /* (CxgM[hуCxg+M(^Cv2)[hȊO */
                    /* MԊuۏ؂͐NG) */
                    if(    (CANSNDDATA_TABLE[lp_sdtid].use_keep_intv == CAN_ON)
                        && ((CANSNDDATA_TABLE[lp_sdtid].snd_mode.bit.event == CAN_OFF)
                        && (CANSNDDATA_TABLE[lp_sdtid].snd_mode.bit.chgsnd == CAN_OFF))
                    )
                    {
                        C_SndDataSts[lp_sdtid].sts.snddata.tblvalid = CAN_OFF;
                    }
                    /* Mf[^`FbN@(Mf[^CTCN菬NG) */
                    else if(   ((CANSNDDATA_TABLE[lp_sdtid].snd_mode.bit.peri == CAN_ON)
                            || (CANSNDDATA_TABLE[lp_sdtid].snd_mode.bit.chgsnd == CAN_ON))
                            && (CANSNDDATA_TABLE[lp_sdtid].snd_cycle < CAN_COM_MAIN_CYCLE)
                    )
                    {
                        C_SndDataSts[lp_sdtid].sts.snddata.tblvalid = CAN_OFF;
                    }
                    /* LȊO͉ */
                    else
                    {
                    }
                    break;
                case CAN_COM_NO_MODE:
                default:
                    C_SndDataSts[lp_sdtid].sts.snddata.tblvalid = CAN_OFF;
            } /* switch(m_mode) */
        }
    } /* for(lp_sdtid=0; lp_sdtid<CAN_COM_NUM_SNDDATA; lp_sdtid++) */
}
/*****************************************************************************/
/*  Function name : static void ChkSndDataValidCOM(void)                     */
/*---------------------------------------------------------------------------*/
/*  Description : MID̗LE菈                                 */
/*                s^C~O: SndCOM()                                   */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void ChkSndDataValidCOM(void)
{
    /************ I[gϐ ************/
    UINT8 lp_sdtid;     /* Mf[^ID[vϐ */

    /************ vO ************/
    /* M֎~bNrbgݒ菈 */
    for(lp_sdtid=0; lp_sdtid<CAN_COM_NUM_SNDDATA; lp_sdtid++)
    {

        /* e[uf[^lAM֎~bNrbgݒ */
        if(  (C_SndDataSts[lp_sdtid].sts.snddata.cond == CAN_ON)
          && (C_SndDataSts[lp_sdtid].sts.snddata.tblvalid == CAN_ON) )
        {
            C_SndDataSts[lp_sdtid].sts.snddata.locked = CAN_OFF;
        }
        else
        {
            C_SndDataSts[lp_sdtid].sts.snddata.locked = CAN_ON;
            if(C_PeriCntDef[lp_sdtid] > 0)
            {
                C_PeriCnt[lp_sdtid] 
                    = (CANSNDDATA_TABLE[lp_sdtid].offset / CAN_COM_MAIN_CYCLE);
            }
            else
            {
                C_PeriCnt[lp_sdtid] = (UINT16)CAN_CLR;
            }
        }
    } /* for(lp_sdtid=0; lp_sdtid<CAN_COM_NUM_SNDDATA; lp_sdtid++) */
}

/*****************************************************************************/
/*  Function name : static void ChkSndStopCOM(void)                          */
/*---------------------------------------------------------------------------*/
/*  Description : Mr┻菈                                           */
/*                s^C~O: SndCOM()                                 */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void ChkSndStopCOM(void)
{
    /************ I[gϐ ************/
    UINT8 m_infdrv = CAN_DRV_WAIT;    /* DRV擾i[̈ */

    /************ vO ************/
     FncGetCOMSndStsDRV(&m_infdrv);
    /* hCoMȂAMr𔻒肷 */
    if(m_infdrv == CAN_DRV_WAIT)
    {
        if(C_SndItvCnt > 0)
        {
            C_SndItvCnt--;
        }
        else
        {
            C_Sts.bit.sndstop = CAN_ON;

#ifdef CAN_COM_NM_INDIRECT
#if CAN_NM_MONITOR == CAN_NM_OMT
            C_OwnNode = CAN_FALSE;
            if(C_OwnNodeCnt != (UINT8)CAN_CLR)
            {
                (void)FncCANMsgTimeout(CAN_COM_OWN_NODE_IDX);
                C_OwnNodeCnt = (UINT8)CAN_CLR;
            }
#endif
#endif
        }
    }
    else
    {
        C_Sts.bit.sndstop = CAN_OFF;
        C_SndItvCnt = (UINT16)(CAN_COM_SNDITVCNT_DEFDATA - 1);
    }
}

/*****************************************************************************/
/*  Function name : StatusType ResetSndCOM(void)                             */
/*---------------------------------------------------------------------------*/
/*  Description : Mr⎞CANRg[                            */
/*                s^C~O: Mr⎞                                 */
/*                ӎF߂l`FbN̕Kv֐voidLXggp */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : CAN_E_OK      :                                          */
/*              CAN_E_NG      : ُ                                         */
/*****************************************************************************/
StatusType ResetSndCOM(void)
{
    /* ϐ */
    StatusType m_sts = CAN_E_NG;
    UINT8 m_com_mode;
    
    /* vO */
    m_com_mode = (C_Sts.byte & CAN_COM_MODE_MASK);
    if (m_com_mode == CAN_COM_NML)
    {
        InitTimeCOM();
        InitCntCOM(CAN_COM_SNDSTOP);
        InitSndStsNoChgSndCOM();
        InitSndQueCOM();
        UpdtSndIDStsCOM((UINT8)CAN_CLR, CAN_COM_SNDSTP);
        UpdtDrvSndStsCOM(CAN_COM_INIT);

        if(FncChgModCAN(CAN_DRV_CAN_RESET) == CAN_E_OK)
        {
            if(FncChgModCAN(CAN_DRV_CAN_RUN) == CAN_E_OK)
            {
                (void)FncDisCANWkupInt();
                (void)FncEnCANRcvInt();
                (void)FncEnCANSndInt();
                (void)FncEnCANErrInt();

                C_Sts.bit.sndstop = CAN_OFF;
                m_sts = CAN_E_OK;
            }
        }
    }
    
    return m_sts;
}

/*****************************************************************************/
/*  Function name : static void KeepEventIntvCOM(void)                       */
/*---------------------------------------------------------------------------*/
/*  Description : EVENT-EVENTԎ([U`(msec))ۏ؏                */
/*                s^C~O: SndCOM()                                 */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void KeepEventIntvCOM(void)
{
    /************ I[gϐ ************/
    UINT8 lp_sdtid;     /* Mf[^ID[vϐ */

    /************ vO ************/
    for(lp_sdtid=0; lp_sdtid<CAN_COM_NUM_SNDDATA; lp_sdtid++)
    {
        /* MԊuۏؒȂAoXAChɂȂǂ`FbN */
        if(    ( C_SndDataSts[lp_sdtid].keep_intv == CAN_ON )
            && ( C_Time == (C_SndDataSts[lp_sdtid].pre_time 
                + (CAN_COM_EVNT_ITV_CNTDATA / CAN_COM_MAIN_CYCLE)) )
        )
        {
            C_SndDataSts[lp_sdtid].keep_intv = CAN_OFF;
        }
    }
}

/*****************************************************************************/
/*  Function name : static void ScanWaitDataCOM(void)                        */
/*---------------------------------------------------------------------------*/
/*  Description : ML[i[҂f[^i[                           */
/*                s^C~O: SndCOM()                                 */
/*                ӎ : @ML[gp̂                          */
/*                           AswitchȊOAbreakgp                 */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void ScanWaitDataCOM(void)
{
    /************ I[gϐ ************/
    UINT8 m_maxpri;             /* D揇ʂĂꍇ̍ōD揇 */
    UINT8 m_sdtid;              /* MIDf[^ */
    UINT8 lp_limit;             /* [v񐔃~b^ϐ */
    UINT8 lp_sdtid;             /* Mf[^ID[vϐ */

    /************ vO ************/
    for(lp_limit=0; (lp_limit<CAN_COM_NUM_SNDDATA) 
                    && ( C_SndQueSts < QUE_MAX_TABLE[(CAN_COM_NUM_SNDQUE-1)] ); lp_limit++)
    {
        m_maxpri = (UINT8)CAN_CLR;
        m_sdtid = CAN_COM_NUM_SNDDATA;

        /* ML[ւ̊i[f[^ */
        for(lp_sdtid=0; lp_sdtid<CAN_COM_NUM_SNDDATA; lp_sdtid++)
        {
            /* obNAbv̈ɑO񑗐ML[Ɋi[oȂf[^邩H */
            if(C_SndDataSts[lp_sdtid].sts.snddata.backup == CAN_ON)
            {
                /* vCIeBL[v */
                if(C_SndDataSts[lp_sdtid].pri > m_maxpri)
                {
                    m_maxpri = C_SndDataSts[lp_sdtid].pri;
                    m_sdtid = lp_sdtid;
                }
                /* vCIeBƓ́ACAN-ID̑召`FbNAL[v */
                else if(C_SndDataSts[lp_sdtid].pri == m_maxpri)
                {
                    if(m_sdtid < CAN_COM_NUM_SNDDATA)
                    {
                        /* CAN-ID̑召`FbN */
                        if(CANSNDDATA_TABLE[lp_sdtid].can_id < CANSNDDATA_TABLE[m_sdtid].can_id)
                        {
                            m_sdtid = lp_sdtid;
                        }
                    }
                    else
                    {
                        m_sdtid = lp_sdtid;
                    }
                }
                else
                {
                    /* vCIeB菬͉ȂB */
                }
            }
        } /* for(lp_sdtid=0; lp_sdtid<CAN_COM_NUM_SNDDATA; lp_sdtid++) */

        if(m_sdtid < CAN_COM_NUM_SNDDATA)
        {
            SetSndMsgBkup2QueCOM(m_sdtid);
            UpdtSndIDStsCOM(m_sdtid, CAN_COM_SNDQUE);
        }
        else
        {
            break;
        }
    } /* for(lp_limit=0; lp_limit<CAN_COM_NUM_SNDDATA; lp_limit++) */
}

/*****************************************************************************/
/*  Function name : static void ScanEventCOM(UINT8 in_com_mode)              */
/*---------------------------------------------------------------------------*/
/*  Description : Cxgo                                       */
/*                s^C~O: SndCOM()                                 */
/*---------------------------------------------------------------------------*/
/*  parameter : UINT8 in_com_modeFCOM                               */
/*                        CAN_COM_NML    FCOMS                       */
/*                        CAN_COM_WAITINGFCOMM֎~                     */
/*  result    : none                                                         */
/*****************************************************************************/
static void ScanEventCOM(UINT8 in_com_mode)
{
    /************ I[gϐ ************/
    UINT8  lp_sdtid;           /* Mf[^ID[vϐ */
    UINT16 m_cntdt = (UINT16)CAN_CLR;
    UINT8  m_event = CAN_COM_NO_EVENT;

    /************ vO ************/
    /* ̃f[^l`FbN */
    if(    (in_com_mode == CAN_COM_NML)
        || (in_com_mode == CAN_COM_WAITING)
    )
    {
        /* SMf[^IDACxg̔ */
        for(lp_sdtid=0; lp_sdtid<CAN_COM_NUM_SNDDATA; lp_sdtid++)
        {
            /* Cxg[horCxg+M[horCxg+M(^Cv2) */
            /*   łΑM̔𔻒                                          */
            if(    ((CANSNDDATA_TABLE[lp_sdtid].snd_mode.bit.event == CAN_ON) 
                    || (CANSNDDATA_TABLE[lp_sdtid].snd_mode.bit.chgsnd == CAN_ON))
                && (C_SndDataSts[lp_sdtid].sts.snddata.locked == CAN_OFF)
            )
            {
                /* Cxg[horCxg+M[h̑MIDł΃Cxg̔𔻒 */
                if(CANSNDDATA_TABLE[lp_sdtid].snd_mode.bit.event == CAN_ON)
                {
                    /* APIƃobNAbvvĂȂ΁ACxgL */
                    if(CmpBufandBkupCOM(lp_sdtid) == (UINT8)CAN_FALSE)
                    {
                        m_event = CAN_COM_CNG_EVENT;
                    }
                }
                /* Cxg+M(^Cv2)[h̑MIDłON/OFFCxg̔𔻒 */
                else if(CANSNDDATA_TABLE[lp_sdtid].snd_mode.bit.chgsnd == CAN_ON)
                {
                    if(ChkChgSndPeriCondCOM(lp_sdtid) == (UINT8)CAN_FALSE)
                    {
                        C_SndDataSts[lp_sdtid].chgsndperi = CAN_OFF;
                    }
                    else
                    {
                        C_SndDataSts[lp_sdtid].chgsndperi = CAN_ON;
                    }

                    /* APIƃobNAbvvĂȂ΁ACxgL */
                    if(CmpBufandBkupCOM(lp_sdtid) == (UINT8)CAN_FALSE)
                    {
                        m_event = CAN_COM_CNG_EVENT;
                    }
                }
                else
                {
                    /*  */
                }

                if(m_event != CAN_COM_NO_EVENT)
                {
                    /* obNAbvɑMbZ[W邩H */
                    if(C_SndDataSts[lp_sdtid].sts.snddata.backup == CAN_ON)
                    {
                        UpdtSndIDStsCOM(lp_sdtid, CAN_COM_LIMIT);
                    }
                    else
                    {
                        SetSndMsgBuf2BkupCOM(lp_sdtid, CAN_COM_EVENT_MODE, in_com_mode);

                        /* ML[ɋ󂫂邩H */
                        if(C_SndQueSts < QUE_MAX_TABLE[(CAN_COM_NUM_SNDQUE-1)])
                        {
                            SetSndMsgBkup2QueCOM(lp_sdtid);
                            UpdtSndIDStsCOM(lp_sdtid, CAN_COM_SNDQUE);
                        }
                        else
                        {
                            UpdtSndIDStsCOM(lp_sdtid, CAN_COM_BKUP);
                        }
                        /* MJE^tbV */
                        /* NMInitԎ */
                        if(in_com_mode == CAN_COM_WAITING)
                        {
                            m_cntdt = C_SndDataSts[lp_sdtid].pre_time;
                            if(m_cntdt > (CAN_LIMIT16 - C_PeriCntDef[lp_sdtid]))
                            {
                                C_PeriCnt[lp_sdtid] = CAN_LIMIT16;
                            }
                            else
                            {
                                C_PeriCnt[lp_sdtid] = (C_PeriCntDef[lp_sdtid] + m_cntdt);
                            }
                        }
                        /* ʏEvent-EventԊmێ */
                        else if(C_SndDataSts[lp_sdtid].keep_intv == CAN_ON)
                        {
                            m_cntdt = (C_SndDataSts[lp_sdtid].pre_time - C_Time);
                            if(m_cntdt > (CAN_LIMIT16 - C_PeriCntDef[lp_sdtid]))
                            {
                                C_PeriCnt[lp_sdtid] = CAN_LIMIT16;
                            }
                            else
                            {
                                C_PeriCnt[lp_sdtid] = (C_PeriCntDef[lp_sdtid] + m_cntdt);
                            }
                        }
                        /* ʏEvent-EventԊmۖ */
                        else
                        {
                            C_PeriCnt[lp_sdtid] = C_PeriCntDef[lp_sdtid];
                        }
                    }
                }
                m_event = CAN_COM_NO_EVENT;
            }
        } /* for(lp_sdtid=0; lp_sdtid<CAN_COM_NUM_SNDDATA; lp_sdtid++) */
    }
}

/*****************************************************************************/
/*  Function name : static void ScanPeriCOM(UINT8 in_com_mode)               */
/*---------------------------------------------------------------------------*/
/*  Description : Mo                                       */
/*                s^C~O: SndCOM()                                 */
/*---------------------------------------------------------------------------*/
/*  parameter :  UINT8 in_com_mode                                           */
/*                        CAN_COM_NMLFCOMS쒆                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void ScanPeriCOM(UINT8 in_com_mode)
{
    /************ I[gϐ ************/
    UINT8 lp_sdtid;         /* Mf[^ID[vϐ */

    /************ vO ************/
    /* ̃f[^l`FbN */
    if(in_com_mode == CAN_COM_NML)
    {
        /* SMf[^IDAM̗v */
        for(lp_sdtid=0; lp_sdtid<CAN_COM_NUM_SNDDATA; lp_sdtid++)
        {
            /* MorCxg+M(^Cv2)łΑM̔𔻒 */
            if(    ((CANSNDDATA_TABLE[lp_sdtid].snd_mode.bit.peri == CAN_ON) 
                    || (CANSNDDATA_TABLE[lp_sdtid].snd_mode.bit.chgsnd == CAN_ON))
                && (C_SndDataSts[lp_sdtid].sts.snddata.locked == CAN_OFF)
            )
            {
                /* M[horCxg+M(^Cv2)Mł */
                /*   pJE^fNg                       */
                if(    (CANSNDDATA_TABLE[lp_sdtid].snd_mode.bit.peri == CAN_ON)
                    || (C_SndDataSts[lp_sdtid].chgsndperi == CAN_ON)
                )
                {
                    if(C_PeriCnt[lp_sdtid] > 0)
                    {
                        C_PeriCnt[lp_sdtid]--;
                    }
                    else
                    {
                        /* obNAbvɑMbZ[W邩H */
                        if(C_SndDataSts[lp_sdtid].sts.snddata.backup == CAN_ON)
                        {
                            UpdtSndIDStsCOM(lp_sdtid, CAN_COM_LIMIT);
                            C_PeriCnt[lp_sdtid] = (UINT16)CAN_CLR;
                        }
                        else
                        {
                            SetSndMsgBuf2BkupCOM(lp_sdtid, CAN_COM_PERIODIC_MODE, in_com_mode);

                            /* ML[ɋ󂫂邩H */
                            if(C_SndQueSts < QUE_MAX_TABLE[CAN_COM_NUM_SNDQUE-1])
                            {
                                SetSndMsgBkup2QueCOM(lp_sdtid);
                                UpdtSndIDStsCOM(lp_sdtid, CAN_COM_SNDQUE);
                            }
                            else
                            {
                                UpdtSndIDStsCOM(lp_sdtid, CAN_COM_BKUP);
                            }

                            if(C_PeriCntDef[lp_sdtid] > 0)
                            {
                                C_PeriCnt[lp_sdtid] = (C_PeriCntDef[lp_sdtid] - 1);
                            }
                            else
                            {
                                C_PeriCnt[lp_sdtid] = (UINT16)CAN_CLR;
                            }
                        }
                    }
                }
                
            }
        } /* for(lp_sdtid=0; lp_sdtid<CAN_COM_NUM_SNDDATA; lp_sdtid++) */
    }
}

/*****************************************************************************/
/*  Function name : static void ChkSndItvTimeCOM(void)                       */
/*---------------------------------------------------------------------------*/
/*  Description : MԊuۏؔ菈                                       */
/*                s^C~O: SndCOM(),SendMessage()                     */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void ChkSndItvTimeCOM(void)
{
    /************ I[gϐ ************/
    UINT8  m_infdrv = CAN_DRV_WAIT;             /* DRV擾i[̈         */
    UINT16 m_systime = (UINT16)CAN_CLR;         /* C_SysTimei[̈       */
    UINT16 m_systimecapbuf = (UINT16)CAN_CLR;   /* C_SysTimeCapBufi[̈ */
    UINT16 m_snditv = (UINT16)CAN_CLR;

    /************ vO ************/
    if(C_DrvSndSts.bit.idle == CAN_OFF)
    {
        FncGetCOMSndStsDRV(&m_infdrv);
        /* M */
        if(m_infdrv == CAN_DRV_COMP)
        {
            m_systime = C_SysTime;
            m_systimecapbuf = C_SysTimeCapBuf;

            m_snditv = (m_systime - m_systimecapbuf);

            if(m_snditv >= CAN_COM_SND_IVL)
            {
                UpdtDrvSndStsCOM(CAN_COM_IDLE);
            }
        }
        /* M */
        else if(m_infdrv == CAN_DRV_EMPTY)
        {
            UpdtDrvSndStsCOM(CAN_COM_IDLE);
        }
        /* LȊO͑M */
        else
        {
            UpdtDrvSndStsCOM(CAN_COM_SND);
        }
    }
}

/*****************************************************************************/
/*  Function name : static void SndMsgCOM(void)                              */
/*---------------------------------------------------------------------------*/
/*  Description : ML[bZ[WM                               */
/*                s^C~O: SndCOM()                                 */
/*                ӎ : @ǐ̈׃}WbNiogp                */
/*                           AswitchȊOAbreakgp                 */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void SndMsgCOM(void)
{
    /************ I[gϐ ************/
    UINT8 m_maxpri = (UINT8)CAN_CLR;    /* D揇ʂĂꍇ̍ōD揇 */
    UINT8 lp_sdtid;                     /* Mf[^ID[vϐ                 */
    UINT8 m_n_sq = CAN_COM_NUM_SNDQUE;  /* ML[ԍ                     */
    UINT8 lp_sq;                        /* ML[[vϐ                   */

    /************ vO ************/
    /* ML[ɃbZ[WāAMԊuۏ؎Ԉȏ󂢂Ă΁AM */
    if(    (C_SndQueSts > 0)
        && (C_DrvSndSts.bit.idle == CAN_ON)
    )
    {
        /* MbZ[Wi[ĂL[AԂɃ[vB */
        /* ܂AōvCIeB擾 */
        for(lp_sq = 0; lp_sq<CAN_COM_NUM_SNDQUE; lp_sq++)
        {
            /* bZ[W̊i[`FbN */
            if((C_SndQueSts & (UINT8)(0x01<<lp_sq)) > 0)
            {
                /* bZ[Wi[ĂāÃvCIeBL[v */
                if(C_SndQue[lp_sq].pri > m_maxpri)
                {
                    m_maxpri = C_SndQue[lp_sq].pri;
                    m_n_sq = lp_sq;
                }
                /* bZ[Wi[ĂāÃvCIeBȂBBB */
                else if(C_SndQue[lp_sq].pri == m_maxpri)
                {
                    /* vCIeB0  Mł͂ȂH */
                    if((C_SndQue[lp_sq].pri == 0) && (C_SndQue[lp_sq].snd_time != C_Time))
                    {
                        /* M^C~Oł͂Ȃ */
                    }
                    /* ML[󂢂Ă  CAN-IDL[vCAN-ID傫H */
                    else if(   (m_n_sq < CAN_COM_NUM_SNDQUE) 
                            && (C_SndQue[lp_sq].msg.can_id >= C_SndQue[m_n_sq].msg.can_id))
                    {
                        /* M^C~Oł͂Ȃ */
                    }
                    else
                    {
                        m_n_sq = lp_sq;
                    }
                }
                else
                {
                    /* vCIeB͉ȂB */
                }
            }
        } /* for(lp_sq = 0; lp_sq<C_N_Sqlimit; lp_sq++) */

        /* MXbgԍlADRIVERɃbZ[Wn */
        if(m_n_sq < CAN_COM_NUM_SNDQUE)
        {
            if(FncWrCOMMsgDRV((UINT32)(C_SndQue[m_n_sq].msg.can_id),
                C_SndQue[m_n_sq].msg.dlc, C_SndQue[m_n_sq].msg.data.byte) == CAN_E_OK)
            {

#ifdef CAN_COM_NM_INDIRECT
                if( C_SndQue[m_n_sq].own_node == CAN_ON )
                {
                    C_OwnNode = CAN_TRUE;
                }
#endif
                C_SndQueSts &= (UINT8)(~((UINT8)(0x01<<m_n_sq)));
                C_SndQue[m_n_sq].pri = (UINT8)CAN_CLR;
                UpdtDrvSndStsCOM(CAN_COM_EVENT);
                for(lp_sdtid=0; lp_sdtid<CAN_COM_NUM_SNDDATA; lp_sdtid++)
                {
                    if(C_SndQue[m_n_sq].msg.can_id == CANSNDDATA_TABLE[lp_sdtid].can_id)
                    {
                        UpdtSndIDStsCOM(lp_sdtid, CAN_COM_SND_OK);
                        break;
                    }
                } /* for(lp_sdtid=0; lp_sdtid<CAN_COM_NUM_SNDDATA; lp_sdtid++) */
            }
            else
            {
                for(lp_sdtid=0; lp_sdtid<CAN_COM_NUM_SNDDATA; lp_sdtid++)
                {
                    if(C_SndQue[m_n_sq].msg.can_id == CANSNDDATA_TABLE[lp_sdtid].can_id)
                    {
                        UpdtSndIDStsCOM(lp_sdtid, CAN_COM_SND_NG);
                        break;
                    }
                } /* for(lp_sdtid=0; lp_sdtid<CAN_COM_NUM_SNDDATA; lp_sdtid++) */
            }
        }
    }
}

/*****************************************************************************/
/*  Function name : static void UpdtPriCOM(void)                             */
/*---------------------------------------------------------------------------*/
/*  Description : MvCIeBXV                                 */
/*                s^C~O: SndCOM()                                 */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void UpdtPriCOM(void)
{
    /************ I[gϐ ************/
    UINT8 lp_dt;     /* ML[AMf[^ID[vϐ */

    /************ vO ************/
    /* ML[̃bZ[W`FbN(L[8iȉ̏ꍇ) */
    if(C_SndQueSts > 0)
    {
        for(lp_dt=0; lp_dt<CAN_COM_NUM_SNDQUE; lp_dt++)
        {
            /* bZ[W̗L`FbN */
            if((C_SndQueSts & (UINT8)(0x01<<lp_dt)) > 0)
            {
                /* bZ[W̑MԂƃvCIeB`FbN */
                if(    (C_SndQue[lp_dt].pri > 0)
                    || (C_SndQue[lp_dt].snd_time == C_Time)
                )
                {
                    if(C_SndQue[lp_dt].pri < CAN_LIMIT8)
                    {
                        C_SndQue[lp_dt].pri++;
                    }
                }
            }
        } /* for(lp_dt=0; lp_dt<CAN_COM_NUM_SNDQUE; lp_dt++) */
    }

    /* obNAbv̈̃bZ[W`FbN */
    for(lp_dt=0; lp_dt<CAN_COM_NUM_SNDDATA; lp_dt++)
    {
        /* bZ[W̗L`FbN */
        if(C_SndDataSts[lp_dt].sts.snddata.backup == CAN_ON)
        {
            /* bZ[W̑MԂƃvCIeB`FbN */
            if(    (C_SndDataSts[lp_dt].pri > 0)
                || (C_SndDataSts[lp_dt].pre_time == C_Time)
            )
            {
                if(C_SndDataSts[lp_dt].pri < CAN_LIMIT8)
                {
                    C_SndDataSts[lp_dt].pri++;
                }
            }
        }
    } /* for(lp_dt=0; lp_dt<CAN_COM_NUM_SNDDATA; lp_dt++) */
}

/*******************************************************************************/
/*  Function name : static void SetSndMsgBuf2BkupCOM                           */
/*                  (UINT8 in_sdtid_idx, UINT8 in_snd_mode, UINT8 in_com_mode) */
/*-----------------------------------------------------------------------------*/
/*  Description : MbZ[WobNAbvi[(Lobt@BKUP)       */
/*                s^C~O: ScanEventCOM(),ScanPeriCOM()               */
/*-----------------------------------------------------------------------------*/
/*  parameter : UINT8 in_sdtid_idx         FMf[^IDCfbNX          */
/*              UINT8 in_snd_mode          FCOMM[h                     */
/*                    CAN_COM_EVENT_MODE   FCxgM                      */
/*                    CAN_COM_PERIODIC_MODEFM                          */
/*              UINT8 in_com_mode          FCOM                       */
/*                    CAN_COM_NML          FS쒆                        */
/*                    CAN_COM_WAITING      FM֎~                        */
/*  result    : none                                                           */
/*******************************************************************************/
static void SetSndMsgBuf2BkupCOM(UINT8 in_sdtid_idx, UINT8 in_snd_mode, UINT8 in_com_mode)
{
    /************ I[gϐ ************/
    UINT8 lp_dlc;                   /* Mf[^DLC[vϐ */

    /************ vO ************/
    /* ̃f[^l`FbN */
    if(    (in_sdtid_idx < CAN_COM_NUM_SNDDATA)
        && ((in_snd_mode == CAN_COM_EVENT_MODE) || (in_snd_mode == CAN_COM_PERIODIC_MODE))
        && ((in_com_mode == CAN_COM_NML) || (in_com_mode == CAN_COM_WAITING))
    )
    {
        MCpyData2BkupCOM(in_sdtid_idx);

        if(CheckMsgFormat(in_sdtid_idx) == CAN_COM_DATAID_IS_DATA)
        {
            C_SndDataSts[in_sdtid_idx].backup.byte[CAN_COM_MSG_ID]
                = CANSNDDATA_TABLE[in_sdtid_idx].def.byte[CAN_COM_MSG_ID];
        }
        
        /* rbgATC`8ȂA0Ń}XN */
        if(CANSNDDATA_TABLE[in_sdtid_idx].dlc < CAN_COM_DLC_SIZE)
        {
            for(lp_dlc=CANSNDDATA_TABLE[in_sdtid_idx].dlc; lp_dlc<CAN_COM_DLC_SIZE; lp_dlc++)
            {
                C_SndDataSts[in_sdtid_idx].backup.byte[lp_dlc] = (UINT8)CAN_CLR;
            }
        }
        /* MZo */
        /* COMMԊuۏ؎̃Cxg[hȂlKv */
        if(    (CANSNDDATA_TABLE[in_sdtid_idx].use_keep_intv == CAN_ON)
            && (in_snd_mode == CAN_COM_EVENT_MODE)
        )
        {
            /* MԊuۏؒȂAO񂩂瑗MԊu([U`)ɑM\ */
            if(C_SndDataSts[in_sdtid_idx].keep_intv == CAN_ON)
            {

                if(in_com_mode == CAN_COM_WAITING)
                {
                    C_SndDataSts[in_sdtid_idx].pre_time
                        = CAN_COM_EVNT_ITV_CNTDATA / CAN_COM_MAIN_CYCLE;
                }
                else
                {
                    C_SndDataSts[in_sdtid_idx].pre_time 
                        = ( C_SndDataSts[in_sdtid_idx].pre_time
                          + (CAN_COM_EVNT_ITV_CNTDATA / CAN_COM_MAIN_CYCLE) );
                }
            }
            /* ۏؒłȂȂAɑM\ */
            else
            {
                C_SndDataSts[in_sdtid_idx].pre_time = C_Time;
                C_SndDataSts[in_sdtid_idx].keep_intv = CAN_ON;
            }
        }
        else
        {
            C_SndDataSts[in_sdtid_idx].pre_time = C_Time;
            C_SndDataSts[in_sdtid_idx].keep_intv = CAN_OFF;
        }
    }
}

/*****************************************************************************/
/*  Function name : static void SetSndMsgBkup2QueCOM(UINT8 in_sdtid_idx)     */
/*---------------------------------------------------------------------------*/
/*  Description : MbZ[WML[i[(BKUPSNDQUE)             */
/*                s^C~O: ScanWaitDataCOM(),ScanEventCOM(),          */
/*                                  ScanPeriCOM()                          */
/*                ӎ : ML[gp̂                            */
/*---------------------------------------------------------------------------*/
/*  parameter : UINT8 in_sdtid_idxFMf[^IDCfbNX                 */
/*  result    : none                                                         */
/*****************************************************************************/
static void SetSndMsgBkup2QueCOM(UINT8 in_sdtid_idx)
{
    /************ I[gϐ ************/
    UINT8   m_n_sq = (UINT8)CAN_CLR;        /* i[L[ԍ */

    /************ vO ************/
    /* ML[i[ */
    /* ̃f[^l`FbN */
    if(in_sdtid_idx < CAN_COM_NUM_SNDDATA)
    {
        m_n_sq = Q2POS_TABLE[C_SndQueSts];
        if(m_n_sq < CAN_COM_NUM_SNDQUE)
        {
            C_SndQue[m_n_sq].msg.can_id = CANSNDDATA_TABLE[in_sdtid_idx].can_id;
            C_SndQue[m_n_sq].msg.dlc = CANSNDDATA_TABLE[in_sdtid_idx].dlc;
            MCpyData2QueCOM(m_n_sq, in_sdtid_idx);
            C_SndQue[m_n_sq].snd_time = C_SndDataSts[in_sdtid_idx].pre_time;
            C_SndQue[m_n_sq].pri = C_SndDataSts[in_sdtid_idx].pri;
            C_SndDataSts[in_sdtid_idx].pri = (UINT8)CAN_CLR;
            C_SndQueSts |= QUE_MASK_TABLE[m_n_sq];

#ifdef CAN_COM_NM_INDIRECT
            if(C_SndQue[m_n_sq].msg.can_id == CAN_COM_OWN_NODE_CANID )
            {
                C_SndQue[m_n_sq].own_node = CAN_ON;
                if(C_OwnNodeCnt < CAN_LIMIT8)
                {
                    C_OwnNodeCnt++;
                }
            }
            else
            {
                C_SndQue[m_n_sq].own_node = CAN_OFF;
            }
#endif
        }
    }
}

/*****************************************************************************/
/*  Function name : static void MCpyData2BkupCOM(UINT8 in_sdtid_idx)         */
/*---------------------------------------------------------------------------*/
/*  Description : MbZ[WobNAbvi[(Lobt@BKUP)     */
/*                s^C~O: SetSndMsgBuf2BkupCOM()                   */
/*                ӎ : ǐ̈׃}WbNiogp                  */
/*---------------------------------------------------------------------------*/
/*  parameter : UINT8 in_sdtid_idxFMf[^IDCfbNX                 */
/*  result    : none                                                         */
/*****************************************************************************/
static void MCpyData2BkupCOM(UINT8 in_sdtid_idx)
{
    /************ vO ************/
    /* ̃f[^l`FbN */
    if(in_sdtid_idx < CAN_COM_NUM_SNDDATA)
    {
        C_SndDataSts[in_sdtid_idx].backup.word[0] = api_snddata[in_sdtid_idx].word[0];
        C_SndDataSts[in_sdtid_idx].backup.word[1] = api_snddata[in_sdtid_idx].word[1];
        C_SndDataSts[in_sdtid_idx].backup.word[2] = api_snddata[in_sdtid_idx].word[2];
        C_SndDataSts[in_sdtid_idx].backup.word[3] = api_snddata[in_sdtid_idx].word[3];
    }
}

/*****************************************************************************/
/*  Function name : static void MCpyData2QueCOM                              */
/*                  (UINT8 in_n_sq, UINT8 in_sdtid_idx)                      */
/*---------------------------------------------------------------------------*/
/*  Description : MbZ[WobNAbvi[(Lobt@BKUP)     */
/*                s^C~O: SetSndMsgBuf2BkupCOM()                   */
/*                ӎ : @ML[gp̂                          */
/*                           Aǐ̈׃}WbNiogp                */
/*---------------------------------------------------------------------------*/
/*  parameter : UINT8 in_n_sqFML[                                    */
/*              UINT8 in_sdtid_idxFMf[^IDCfbNX                 */
/*  result    : none                                                         */
/*****************************************************************************/
static void MCpyData2QueCOM(UINT8 in_n_sq, UINT8 in_sdtid_idx)
{
    /************ vO ************/
    /* ̃f[^l`FbN */
    if(    (in_n_sq < CAN_COM_NUM_SNDQUE)
        && (in_sdtid_idx < CAN_COM_NUM_SNDDATA)
    )
    {
        C_SndQue[in_n_sq].msg.data.word[0] = C_SndDataSts[in_sdtid_idx].backup.word[0];
        C_SndQue[in_n_sq].msg.data.word[1] = C_SndDataSts[in_sdtid_idx].backup.word[1];
        C_SndQue[in_n_sq].msg.data.word[2] = C_SndDataSts[in_sdtid_idx].backup.word[2];
        C_SndQue[in_n_sq].msg.data.word[3] = C_SndDataSts[in_sdtid_idx].backup.word[3];
    }
}

/*****************************************************************************/
/*  Function name : static UINT8 CmpBufandBkupCOM(UINT8 in_sdtid_idx)        */
/*---------------------------------------------------------------------------*/
/*  Description : Cxgo                                       */
/*                s^C~O: ScanEventCOM()                           */
/*                ӎ : switchȊOAbreakgp                   */
/*---------------------------------------------------------------------------*/
/*  parameter : UINT8 in_sdtid_idxFMf[^IDCfbNX                 */
/*  result    : UINT8                                                        */
/*                  CAN_TRUE : Cxg                              */
/*                  CAN_FALSE : CxgL                             */
/*****************************************************************************/
static UINT8 CmpBufandBkupCOM(UINT8 in_sdtid_idx)
{
    /************ I[gϐ ************/
    UINT8 result = (UINT8)CAN_TRUE;
    UINT8 lp_dlc;                    /* Mf[^DLC[vϐ */
    UINT8 m_lp_str = (UINT8)CAN_CLR; /* Jnʒuϐ        */

    /************ vO ************/
    /* ̃f[^l`FbN */
    if(in_sdtid_idx < CAN_COM_NUM_SNDDATA)
    {
        /* łA[FALSE]Ԃ */
        if(CheckMsgFormat(in_sdtid_idx) == CAN_COM_DATAID_IS_DATA)
        {
            m_lp_str = CAN_COM_DLC_1;
        }
        else
        {
            m_lp_str = (UINT8)CAN_CLR;
        }

        /* rbgATC`2ȉȂf[^ꍇAI */
        if(CANSNDDATA_TABLE[in_sdtid_idx].dlc > m_lp_str)
        {
            for(lp_dlc=m_lp_str; lp_dlc<CANSNDDATA_TABLE[in_sdtid_idx].dlc; lp_dlc++)
            {
                if( api_snddata[in_sdtid_idx].byte[lp_dlc] 
                    != C_SndDataSts[in_sdtid_idx].backup.byte[lp_dlc])
                {
                    result = (UINT8)CAN_FALSE;
                    break;
                }
            } /* for(lp_dlc=m_lp_str; lp_dlc<CANSNDDATA_TABLE[in_sdtid_idx].dlc; lp_dlc++) */
        }
    }
    return result;
}

/*****************************************************************************/
/*  Function name : static UINT8 ChkChgSndPeriCondCOM(UINT8 in_sdtid_idx)    */
/*---------------------------------------------------------------------------*/
/*  Description : Cxg+M(^Cv2)o                     */
/*                s^C~O: ScanPeriCOM()                            */
/*                ӎ: switchȊOAbreakgp                    */
/*---------------------------------------------------------------------------*/
/*  parameter : UINT8 in_sdtidFMf[^IDCfbNX                     */
/*  result    : UINT8                                                        */
/*                  CAN_TRUE : L                                  */
/*                  CAN_FALSE :                                  */
/*****************************************************************************/
static UINT8 ChkChgSndPeriCondCOM(UINT8 in_sdtid_idx)
{
    /************ I[gϐ ************/
    UINT8 result = (UINT8)CAN_FALSE;
    UINT8 lp_dlc;                    /* Mf[^DLC[vϐ */
    UINT8 m_lp_str = (UINT8)CAN_CLR; /* Jnʒuϐ        */

    /************ vO ************/
    /* ̃f[^l`FbN */
    if(in_sdtid_idx < CAN_COM_NUM_SNDDATA)
    {
        /* ЂƂł'CLR'łȂ΁A[TRUE]Ԃ */
        if(CheckMsgFormat(in_sdtid_idx) == CAN_COM_DATAID_IS_DATA)
        {
            m_lp_str = CAN_COM_DLC_1;
        }
        else
        {
            m_lp_str = (UINT8)CAN_CLR;
        }

        if(CANSNDDATA_TABLE[in_sdtid_idx].dlc > m_lp_str)
        {
            for(lp_dlc=m_lp_str; lp_dlc<CANSNDDATA_TABLE[in_sdtid_idx].dlc; lp_dlc++)
            {
                if(api_snddata[in_sdtid_idx].byte[lp_dlc] != (UINT8)CAN_CLR)
                {
                    result = (UINT8)CAN_TRUE;
                    break;
                }
            } /* for(lp_dlc=m_lp_str; lp_dlc<CANSNDDATA_TABLE[in_sdtid_idx].dlc; lp_dlc++) */
        }
    }
    return result;
}

/*****************************************************************************/
/*  Function name : static UINT8 CheckMsgFormat(UINT8 in_sdtid_idx)          */
/*---------------------------------------------------------------------------*/
/*  Description : bZ[WtH[}bg                                 */
/*                s^C~O: CmpBufandBkupCOM֐                       */
/*                                SetSndMsgBuf2BkupCOM֐s             */
/*                ӎ: switchȊOAbreakgp                    */
/*---------------------------------------------------------------------------*/
/*  parameter : UINT8 in_sdtid_idxFMf[^IDCfbNX                 */
/*  result    : UINT8  bZ[WtH[}bg                                */
/*                  CAN_COM_DATAID_IS_CANID 1                            */
/*                  CAN_COM_DATAID_IS_DATA  2                            */
/*****************************************************************************/
static UINT8 CheckMsgFormat(UINT8 in_sdtid_idx)
{
    UINT8 m_format = CAN_COM_DATAID_IS_CANID;  /* bZ[WtH[}bg(ftHg͏1Ƃ) */
    UINT8 lp_cnt;
    

    for (lp_cnt = (UINT8)CAN_CLR; lp_cnt < CAN_COM_NUM_CANID; lp_cnt++)
    {
        if (CANSNDDATA_TABLE[in_sdtid_idx].can_id == CANID_TABLE[lp_cnt].can_id)
        {
            m_format = CANID_TABLE[lp_cnt].pos;
            break;
        }
    }
    
    return m_format;
}

/*****************************************************************************/
/*  Function name : void SetSndUseReqCOM(UINT16 in_sdtid, UINT8 sts)         */
/*---------------------------------------------------------------------------*/
/*  Description : M/֎~v                                      */
/*                s^C~O: C                                       */
/*                ӎ: switchȊOAbreakgp                    */
/*---------------------------------------------------------------------------*/
/*  parameter : UINT16 in_sdtidFMf[^ID                                */
/*              UINT8  sts: M/֎~Xe[^X                          */
/*                        CAN_COM_SND_OFF  M֎~                      */
/*                        CAN_COM_SND_ON   M                      */
/*  result    : CAN_E_OK Mf[^IDY                                */
/*              CAN_E_NG Mf[^IDYȂ                                */
/*****************************************************************************/
StatusType SetSndUseReqCOM(UINT16 in_sdtid, UINT8 sts)
{
    /************ I[gϐ ************/
    StatusType result = CAN_E_NG;       /* ߂li[̈         */
    UINT8 lp_sdtid;                     /* Mf[^ID[vϐ */

    /************ vO ************/
    /* w肳ꂽMf[^ID */
    for(lp_sdtid=0; lp_sdtid < CAN_COM_NUM_SNDDATA; lp_sdtid++)
    {
        if(in_sdtid == CANSNDDATA_TABLE[lp_sdtid].data_id)
        {
            /* M */
            if (sts == CAN_COM_SND_ON)
            {
                C_SndDataSts[lp_sdtid].sts.snddata.cond = CAN_ON;
                result = CAN_E_OK;
            }
            /* M֎~ */
            else if  (sts == CAN_COM_SND_OFF)
            {
                C_SndDataSts[lp_sdtid].sts.snddata.cond = CAN_OFF;
                result = CAN_E_OK;
            }
            /* M/֎~̂łȂꍇ */
            else
            {
                result = CAN_E_NG;
            }
            break;
        }
    }
    
    return result;
}

/*********************************************************************************/
/*  Function name : StatusType SendMessage                                       */
/*                  (UINT16 in_canid, UINT8 in_dlc, const UINT8 far *in_ptr_sdt) */
/*-------------------------------------------------------------------------------*/
/*  Description : ځAML[i[                                       */
/*                s^C~O: ScanPeriCOM()                                */
/*                ӎ: @KARcvCOM()`SndCOM()ԂŃR[邱ƁI       */
/*                          Aǐ̈׃}WbNiogp                     */
/*                          BswitchȊOAbreakgp                      */
/*-------------------------------------------------------------------------------*/
/*  parameter : UINT16 in_canidFCAN-ID                                          */
/*              UINT8  in_dlcFDLC(rbgATC`)                         */
/*                     far UINT8 *in_ptr_sdtFMf[^                         */
/*  result    :  StatusType                                                      */
/*                  CAN_E_OK : ML[ւ̊i[AM                  */
/*                  CAN_E_NG : ML[ւ̊i[sAMs                  */
/*********************************************************************************/
StatusType SendMessage(UINT16 in_canid, UINT8 in_dlc, const UINT8 far *in_ptr_sdt)
{
    /************ I[gϐ ************/
    StatusType result = CAN_E_NG;       /* ߂li[̈ */
    UINT8 lp_dlc;                       /* Mf[^DLC[vϐ */
    UINT8 m_n_sq = (UINT8)CAN_CLR;      /* ML[ԍ */

    /************ vO ************/
    /* MDLC`FbN */
    if(in_dlc <= CAN_COM_DLC_SIZE)
    {
        /* ML[󂢂ĂAbZ[Wi[B */
        if(C_SndQueSts < QUE_MAX_TABLE[(CAN_COM_NUM_SNDQUE-1)])
        {
            /* ML[ւ̃bZ[Wi[ */
            m_n_sq = Q2POS_TABLE[C_SndQueSts];
            if(m_n_sq < CAN_COM_NUM_SNDQUE)
            {
                C_SndQue[m_n_sq].msg.can_id = in_canid;
                C_SndQue[m_n_sq].msg.dlc = in_dlc;
                C_SndQue[m_n_sq].msg.data.byte[0] = in_ptr_sdt[0];
                C_SndQue[m_n_sq].msg.data.byte[1] = in_ptr_sdt[1];
                C_SndQue[m_n_sq].msg.data.byte[2] = in_ptr_sdt[2];
                C_SndQue[m_n_sq].msg.data.byte[3] = in_ptr_sdt[3];
                C_SndQue[m_n_sq].msg.data.byte[4] = in_ptr_sdt[4];
                C_SndQue[m_n_sq].msg.data.byte[5] = in_ptr_sdt[5];
                C_SndQue[m_n_sq].msg.data.byte[6] = in_ptr_sdt[6];
                C_SndQue[m_n_sq].msg.data.byte[7] = in_ptr_sdt[7];
                /* rbgATC`8ȂAf[^0Ń}XN(g) */
                if(in_dlc < CAN_COM_DLC_SIZE)
                {
                    for(lp_dlc=in_dlc; lp_dlc<CAN_COM_DLC_SIZE; lp_dlc++)
                    {
                        C_SndQue[m_n_sq].msg.data.byte[lp_dlc] = (UINT8)CAN_CLR;
                    }
                }

                C_SndQue[m_n_sq].snd_time = C_Time;
                C_SndQueSts |= QUE_MASK_TABLE[m_n_sq];
                result = CAN_E_OK;
            }
            else
            {
                /* CAN_E_NGԂ̂ */
            }
        }
        else
        {
            /* CAN_E_NGԂ̂ */
        }
    }
    
    return result;
}

/*****************************************************************************/
/*  Function name : void RcvCOM(void)                                        */
/*---------------------------------------------------------------------------*/
/*  Description : COMM                                                */
/*                s^C~O: [U[Av                       */
/*                ӎ : AvvÕCŃR[邱  */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
void RcvCOM(void)
{
    /************ I[gϐ ************/
    UINT8 m_com_mode = (UINT8)CAN_CLR;      /* COM샂[h */

    /************ vO ************/
    C_Time++;

    m_com_mode = (C_Sts.byte & CAN_COM_MODE_MASK);
    switch(m_com_mode)
    {
        case CAN_COM_NML:
        case CAN_COM_WAITING:
        case CAN_COM_RCVONLY:

/* DRIVERM荞ݎgp */
#if CAN_COM_USE_RCVINT == CAN_TRUE
            GetRcvMsgQue2BufCOM();

/* DRIVERM荞ݖgp */
#else
            GetRcvMsgSlot2BufCOM();
#endif
            ChkRcvStopCOM();
            break;
        case CAN_COM_STP:
            /* break; */
        default:
            break;
    } /* switch(m_com_mode) */
}

/*****************************************************************************/
/*  Function name : static void GetRcvMsgQue2BufCOM(void)                    */
/*---------------------------------------------------------------------------*/
/*  Description : MbZ[Wo(RCVQUECOM)                    */
/*                s^C~O: RcvCOM()                                 */
/*                ӎ : @M荞ݎgp̂                        */
/*                           AswitchȊOAbreakgp                 */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
/* DRIVERM荞ݎgp */
#if CAN_COM_USE_RCVINT == CAN_TRUE
static void GetRcvMsgQue2BufCOM(void)
{
    /************ I[gϐ ************/
    UINT8   m_ptr_rd = (UINT8)CAN_CLR;      /* ǂݏo|C^        */
    UINT8 m_n_rdtid = (UINT8)CAN_CLR;       /* Mf[^IDԍ          */
    UINT8 m_inf = (UINT8)CAN_E_COM_NORCV;   /* SetRcvMsgBufCOM()̖߂l */
    UINT8 lp_rdtid;                         /* Mf[^ID[vϐ    */
    UINT8 lp_limit;                         /* ǂݏo񐔃K[h        */

    /************ vO ************/
    /* SMIDAMLtONA */
    for(lp_rdtid=0; lp_rdtid<CAN_COM_NUM_RCVDATA; lp_rdtid++)
    {
        C_RcvDataSts[lp_rdtid].sts.rcvdata.newdata = CAN_OFF;
    }

    m_ptr_rd = COMRcvQue.rd_ptr;

    /* L[TCYǂݏo񐔂̃~b^lƂ */
    for(lp_limit=0; lp_limit<CAN_COM_NUM_RCVQUE; lp_limit++)
    {
        m_ptr_rd++;
        if(m_ptr_rd >= CAN_COM_NUM_RCVQUE)
        {
            m_ptr_rd = (UINT8)CAN_CLR;
        }

        /* MbZ[W̗L */
        if(m_ptr_rd == COMRcvQue.wr_ptr)
        {
            break;
        }

        m_inf = SetRcvMsgBufCOM(&COMRcvQue.msg[m_ptr_rd], &m_n_rdtid);
        if(m_inf == (UINT8)CAN_E_COM_OKRCV)
        {
            UpdtRcvIDStsCOM(m_n_rdtid, CAN_COM_RCV_OK);
            C_RcvItvCnt[m_n_rdtid] = C_RcvItvCntDef[m_n_rdtid];
        }
        else if(m_inf == (UINT8)CAN_E_COM_NGRCV)
        {
            UpdtRcvIDStsCOM(m_n_rdtid, CAN_COM_RCV_NG);
        }
        else
        {
            /* LȊO͉̎ȂB */
        }

        COMRcvQue.rd_ptr = m_ptr_rd;
    } /* for(lp_limit=0; lp_limit<CAN_COM_NUM_RCVQUE; lp_limit++) */
}
#endif

/*****************************************************************************/
/*  Function name : static void GetRcvMsgSlot2BufCOM(void)                   */
/*---------------------------------------------------------------------------*/
/*  Description : MbZ[Wo(RCVSLOTCOM)                   */
/*                s^C~O: RcvCOM()                                 */
/*                ӎ : @M荞ݖgp̂                      */
/*                           Am_rmsg͒lĂgpׁA          */
/*                             Kv͖                          */
/*                           BswitchȊOAbreakgp                 */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
/* DRIVERM荞ݖgp */
#if CAN_COM_USE_RCVINT != CAN_TRUE
static void GetRcvMsgSlot2BufCOM(void)
{
    /************ I[gϐ ************/
    StatusType m_infdrv = CAN_E_NG;         /* FncRdCOMMsgDRV()̖߂l   */
    UINT8 m_inf = (UINT8)CAN_E_COM_NORCV;   /* SetRcvMsgBufCOM()̖߂l  */
    UINT8 m_n_rdtid = (UINT8)CAN_CLR;       /* Mf[^IDԍ           */
    CANMsgType m_rmsg;                      /* MbZ[Wi[obt@ */
    UINT8 lp_rdtid;                         /* Mf[^ID[vϐ     */
    UINT8 lp_limit;                         /* ǂݏo񐔃K[h         */
    UINT32 m_can_id;                        /* CAN-ID */

    /************ vO ************/
    /* SMIDAMLtONA */
    for(lp_rdtid=0; lp_rdtid<CAN_COM_NUM_RCVDATA; lp_rdtid++)
    {
        C_RcvDataSts[lp_rdtid].sts.rcvdata.newdata = CAN_OFF;
    }

    /* bZ[W̎MmF́AXbg܂ */
    for(lp_limit=0; lp_limit<CAN_COM_NUM_RCVDATA; lp_limit++)
    {
        /* bZ[W̎MA߂l֌WlȂ瑦I */
        m_infdrv = FncRdCOMMsgDRV(&m_can_id, &m_rmsg.dlc, m_rmsg.data.byte);

        if(m_infdrv == CAN_E_OK)
        {
            m_rmsg.can_id = (UINT16)m_can_id;
            m_inf = SetRcvMsgBufCOM(&m_rmsg, &m_n_rdtid);
            if(m_inf == (UINT8)CAN_E_COM_OKRCV)
            {
                UpdtRcvIDStsCOM(m_n_rdtid, CAN_COM_RCV_OK);
                C_RcvItvCnt[m_n_rdtid] = C_RcvItvCntDef[m_n_rdtid];
            }
            else if(m_inf == (UINT8)CAN_E_COM_NGRCV)
            {
                UpdtRcvIDStsCOM(m_n_rdtid, CAN_COM_RCV_NG);
            }
            else
            {
                /* e[uɂȂIDM͉ȂB */
            }
        }
        else
        {
            break;
        }
    } /* for(lp_limit=0; lp_limit<CAN_NUM_MAX_SLOT; lp_limit++) */
}
#endif

/*****************************************************************************/
/*  Function name : static UINT8 SetRcvMsgBufCOM                             */
/*                  (const CANMsgType *in_ptr_rdt, UINT8 *out_rdtid)         */
/*---------------------------------------------------------------------------*/
/*  Description : MbZ[WMobt@i[(COMRCVAPI)        */
/*                s^C~O: GetRcvMsgQue2BufCOM(),                     */
/*                                GetRcvMsgSlot2BufCOM()                   */
/*                ӎ : @ǐ̈׃}WbNiogp                */
/*                           AswitchȊOAbreakgp                 */
/*---------------------------------------------------------------------------*/
/*  parameter : CANMsgType *in_ptr_rdtFMbZ[W                       */
/*              UINT8      *out_rdtid FMf[^ID                         */
/*  result    : UINT8                                                        */
/*                 CAN_E_COM_OKRCVF֘AIDA탁bZ[WM             */
/*                 CAN_E_COM_NGRCVF֘AIDAُ탁bZ[WM             */
/*                 CAN_E_COM_NORCVF֘AIDȊÕbZ[WM             */
/*****************************************************************************/
static UINT8 SetRcvMsgBufCOM(const CANMsgType *in_ptr_rdt, UINT8 *out_rdtid)
{
    /************ I[gϐ ************/
    UINT8  result = (UINT8)CAN_E_COM_NORCV;  /* ߂l                  */
    UINT16 m_dtid = (UINT16)CAN_CLR;         /* f[^IDi[̈        */
    UINT8  m_n_rdtid = CAN_COM_NUM_RCVDATA;  /* f[^IDi[̈        */
    UINT8  lp_canid;                         /* CAN-ID[vϐ        */
    UINT8  lp_rdtid;                         /* Mf[^ID[vϐ  */
    UINT8  lp_dlc;                           /* Mf[^DLC[vϐ */

    /************ vO ************/
    /* MbZ[W̎Mf[^ID菈 */
    for(lp_canid=0; lp_canid<CAN_COM_NUM_CANID; lp_canid++)
    {
        if(in_ptr_rdt->can_id  == CANID_TABLE[lp_canid].can_id)
        {
            /* f[^IDo */
            if(CANID_TABLE[lp_canid].pos == CAN_COM_DATAID_IS_DATA)
            {
                m_dtid = (UINT16)in_ptr_rdt->data.byte[CAN_COM_MSG_ID];
            }
            else
            {
                m_dtid = in_ptr_rdt->can_id;
            }

            /* MbZ[W̃f[^IDo^Ă邩ǂH */
            for(lp_rdtid=0; lp_rdtid<CAN_COM_NUM_RCVDATA; lp_rdtid++)
            {
                /* f[^IDe[u`FbN */
                if(m_dtid == CANRCVDATA_TABLE[lp_rdtid].data_id)
                {
                    m_n_rdtid = lp_rdtid;
                    result = (UINT8)CAN_E_COM_NGRCV;
                    break;
                }
            } /* for(lp_rdtid=0; lp_rdtid<CAN_COM_NUM_RCVDATA; lp_rdtid++) */

            if(result == (UINT8)CAN_E_COM_NGRCV)
            {
                break;
            }
        }
    } /* for(lp_canid=0; lp_canid<CAN_COM_NUM_CANID; lp_canid++) */

    if(     (m_n_rdtid < CAN_COM_NUM_RCVDATA)
        &&  (result == (UINT8)CAN_E_COM_NGRCV)
    )
    {
        /* DLCTCY8oCg𒴂鎞ُ͈ */
        if(in_ptr_rdt->dlc <= CAN_COM_DLC_SIZE)
        {
            /* ݒ肳ꂽDLCDLCv鎞 */
            if (in_ptr_rdt->dlc == CANRCVDATA_TABLE[m_n_rdtid].dlc)
            {
                WrAPIRcvBuff(m_n_rdtid, in_ptr_rdt);
                
                result = (UINT8)CAN_E_COM_OKRCV;
            }
            /* ݒ肳ꂽDLCDLC傫 */
            else if (in_ptr_rdt->dlc > CANRCVDATA_TABLE[m_n_rdtid].dlc)
            {
                /* Sf[^擾 */
                if (CANRCVDATA_TABLE[m_n_rdtid].dlc_size_over == CAN_COM_GET_DATA_8BYTE)
                {
                    WrAPIRcvBuff(m_n_rdtid, in_ptr_rdt);
                    
                    result = (UINT8)CAN_E_COM_OKRCV;
                }
            }
            /* ݒ肳ꂽDLCDLC  */
            else  /* (in_ptr_rdt->dlc < CANRCVDATA_TABLE[m_n_rdtid].dlc) */
            {
                /* Mf[^ȍ~0pbfBO */
                if (CANRCVDATA_TABLE[m_n_rdtid].dlc_size_under == CAN_COM_GET_DATA_AND_0)
                {
                    WrAPIRcvBuff(m_n_rdtid, in_ptr_rdt);
                    
                    for(lp_dlc = in_ptr_rdt->dlc; lp_dlc < CAN_COM_DLC_SIZE; lp_dlc++)
                    {
                        api_rcvdata[m_n_rdtid].byte[lp_dlc] = (UINT8)CAN_CLR;
                    }
                    
                    result = (UINT8)CAN_E_COM_OKRCV;
                }
                /* Mf[^̂ݎ荞 */
                else if (CANRCVDATA_TABLE[m_n_rdtid].dlc_size_under == CAN_COM_GET_DATA_ONLY)
                {
                    for(lp_dlc = 0; lp_dlc < in_ptr_rdt->dlc; lp_dlc++)
                    {
                        api_rcvdata[m_n_rdtid].byte[lp_dlc] = in_ptr_rdt->data.byte[lp_dlc];
                    }
                    
                    result = (UINT8)CAN_E_COM_OKRCV;
                }
                /* Mf[^jׁ̈AȂ */
                else
                {
                    ;
                }
            }
#ifdef CAN_COM_NM_INDIRECT
            if( result == CAN_E_COM_OKRCV )
            {
                if( CAN_RCV_IDX_TBL[m_n_rdtid] != CAN_COM_NO_USE )
                {
                    (void)FncCANMsgTransfer(CAN_RCV_IDX_TBL[m_n_rdtid]);
                }
            }
#endif
        }
        
        *out_rdtid = m_n_rdtid;
    }
    return  result;
}
/*****************************************************************************/
/*  Function name : static void WrAPIRcvBuff                                 */
/*                  (UINT8 n_rdtid_idx, const CANMsgType *in_ptr_rdt)        */
/*---------------------------------------------------------------------------*/
/*  Description : MbZ[WAPIMobt@i[                      */
/*                s^C~O: SetRcvMsgBufCOM()                        */
/*                ӎ : ǐ̈׃}WbNiogp                  */
/*---------------------------------------------------------------------------*/
/*  parameter : UINT8 n_rdtid_idx      : f[^IDi[CfbNX            */
/*              CANMsgType *in_ptr_rdt : MbZ[W                      */
/*  result    : none                                                         */
/*****************************************************************************/
static void WrAPIRcvBuff(UINT8 n_rdtid_idx, const CANMsgType *in_ptr_rdt)
{
    /* MbZ[WMobt@֊i[ */
    api_rcvdata[n_rdtid_idx].word[0] = in_ptr_rdt->data.word[0];
    api_rcvdata[n_rdtid_idx].word[1] = in_ptr_rdt->data.word[1];
    api_rcvdata[n_rdtid_idx].word[2] = in_ptr_rdt->data.word[2];
    api_rcvdata[n_rdtid_idx].word[3] = in_ptr_rdt->data.word[3];
}

/*****************************************************************************/
/*  Function name : void CallCOMRcvMsgDRV                                    */
/*                  (UINT32 can_id, UINT8 dlc, const UINT8 *buff)            */
/*---------------------------------------------------------------------------*/
/*  Description : DRIVER̎Mf[^󂯓n                         */
/*                s^C~O: f[^M荞ݎ                       */
/*                ӎ : ǐ̈׃}WbNiogp                  */
/*---------------------------------------------------------------------------*/
/*  parameter : UINT32   CAN-ID                                              */
/*              UINT8    DLC                                                 */
/*              UINT8 *  Mf[^i[pobt@                            */
/*  result    : none                                                         */
/*****************************************************************************/
#if CAN_COM_USE_RCVINT == CAN_TRUE
void CallCOMRcvMsgDRV(UINT32 can_id, UINT8 dlc, const UINT8 *buff)
{
    /* ----- ϐ ----- */
    UINT8 lp_cnt;
    
    /* ----- ----- */
    if (COMRcvQue.rd_ptr != COMRcvQue.wr_ptr)
    {
        COMRcvQue.msg[COMRcvQue.wr_ptr].can_id = (UINT16)can_id;
        COMRcvQue.msg[COMRcvQue.wr_ptr].dlc    = dlc;
        COMRcvQue.msg[COMRcvQue.wr_ptr].data.byte[0] = buff[0];
        COMRcvQue.msg[COMRcvQue.wr_ptr].data.byte[1] = buff[1];
        COMRcvQue.msg[COMRcvQue.wr_ptr].data.byte[2] = buff[2];
        COMRcvQue.msg[COMRcvQue.wr_ptr].data.byte[3] = buff[3];
        COMRcvQue.msg[COMRcvQue.wr_ptr].data.byte[4] = buff[4];
        COMRcvQue.msg[COMRcvQue.wr_ptr].data.byte[5] = buff[5];
        COMRcvQue.msg[COMRcvQue.wr_ptr].data.byte[6] = buff[6];
        COMRcvQue.msg[COMRcvQue.wr_ptr].data.byte[7] = buff[7];

        COMRcvQue.wr_ptr++;
        if(COMRcvQue.wr_ptr >= CAN_COM_NUM_RCVQUE)
        {
            COMRcvQue.wr_ptr = (UINT8)CAN_CLR;
        }
    }
}
#endif

/*****************************************************************************/
/*  Function name : static void ChkRcvStopCOM(void)                          */
/*---------------------------------------------------------------------------*/
/*  Description : Mr┻菈                                           */
/*                s^C~O: RcvCOM()                                 */
/*                ӎ : @ǐ̈׃}WbNiogp                */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
#ifndef CAN_COM_NM_INDIRECT
static void ChkRcvStopCOM(void)
{
    /************ I[gϐ ************/
    UINT8 lp_rdtid;     /* Mf[^ID[vϐ */

    /************ vO ************/
    C_Sts.bit.rcvstop = CAN_OFF;
    /* SMf[^IDAr`FbN */
    for(lp_rdtid=0; lp_rdtid<CAN_COM_NUM_RCVDATA; lp_rdtid++)
    {
        /* Mr⒆ȂÃf[^ID */
        if(C_RcvDataSts[lp_rdtid].sts.rcvdata.silent == CAN_ON)
        {
            C_Sts.bit.rcvstop = CAN_ON;
        }
        else
        {
            /* Mr⎞ԌvȂÃf[^ID */
            if(C_RcvItvCnt[lp_rdtid] > 0)
            {
                C_RcvItvCnt[lp_rdtid]--;
            }
            else
            {
                /* d̃}XNԒ̔ */
                if(C_RcvDataSts[lp_rdtid].sts.rcvdata.pwon == CAN_ON)
                {
                    C_RcvDataSts[lp_rdtid].sts.rcvdata.pwon = CAN_OFF;
                    C_RcvItvCnt[lp_rdtid] = C_RcvItvCntDef[lp_rdtid];
                }
                else
                {
                    C_Sts.bit.rcvstop = CAN_ON;
                    UpdtRcvIDStsCOM(lp_rdtid, CAN_COM_RCVSTP);
                }
            }
        }
    } /* for(lp_rdtid=0; lp_rdtid<NUM_RCVDATA; lp_rdtid++) */
}
#else
static void ChkRcvStopCOM(void)
{
    /************ I[gϐ ************/
    UINT8 lp_rdtid;     /* Mf[^ID[vϐ */

    /************ vO ************/
    C_Sts.bit.rcvstop = CAN_OFF;
    /* SMf[^IDAr`FbN */
    for(lp_rdtid=0; lp_rdtid<CAN_COM_NUM_RCVDATA; lp_rdtid++)
    {
        /* Mr⒆ȂÃf[^ID */
#if CAN_NM_MONITOR == CAN_NM_OMT
        if((C_RcvDataSts[lp_rdtid].sts.rcvdata.silent == CAN_ON) 
            && ( CAN_RCV_IDX_TBL[lp_rdtid] == CAN_COM_NO_USE ))
#else
        if(C_RcvDataSts[lp_rdtid].sts.rcvdata.silent == CAN_ON)
#endif
        {
            C_Sts.bit.rcvstop = CAN_ON;
        }
        else
        {
            /* Mr⎞ԌvȂÃf[^ID */
            if(C_RcvItvCnt[lp_rdtid] > 0)
            {
                C_RcvItvCnt[lp_rdtid]--;
            }
            else
            {
                /* d̃}XNԒ̔ */
                if(C_RcvDataSts[lp_rdtid].sts.rcvdata.pwon == CAN_ON)
                {
                    C_RcvDataSts[lp_rdtid].sts.rcvdata.pwon = CAN_OFF;
                    C_RcvItvCnt[lp_rdtid] = (C_RcvItvCntDef[lp_rdtid] - 1);
                }
                else
                {
                    C_Sts.bit.rcvstop = CAN_ON;
                    UpdtRcvIDStsCOM(lp_rdtid, CAN_COM_RCVSTP);

#if CAN_NM_MONITOR == CAN_NM_OMT
                    if( CAN_RCV_IDX_TBL[lp_rdtid] != CAN_COM_NO_USE )
                    {
                        C_RcvItvCnt[lp_rdtid] = (C_RcvItvCntDef[lp_rdtid] - 1);
                        (void)FncCANMsgTimeout(CAN_RCV_IDX_TBL[lp_rdtid]);
                    }
#endif

                }
            }
        }
    } /* for(lp_rdtid=0; lp_rdtid<NUM_RCVDATA; lp_rdtid++) */
}
#endif /* #ifndef CAN_COM_NM_INDIRECT */

/*****************************************************************************/
/*  Function name : static void UpdtSndIDStsCOM                              */
/*  (UINT8 in_sdtid_idx, UINT8 in_mode)                                      */
/*---------------------------------------------------------------------------*/
/*  Description : @FMf[^IDXe[^XXV(N)         */
/*                 C_SndDataSts.sts.snddata.locked = CAN_ON                  */
/*                 C_SndDataSts.sts.snddata.ok = CAN_OFF                     */
/*                 C_SndDataSts.sts.snddata.backup = CAN_OFF                 */
/*                 C_SndDataSts.sts.snddata.limit = CAN_OFF                  */
/*                 C_SndDataSts.sts.snddata.ng = CAN_OFF                     */
/*                 C_SndDataSts.sts.snddata.cond = CAN_OFF                   */
/*                 C_SndDataSts.sts.snddata.tblvalid = CAN_OFF               */
/*                 C_SndDataSts.sts.snddata.dummy = CAN_OFF                  */
/*                AFMf[^IDXe[^XXV()               */
/*                 C_SndDataSts.sts.snddata.locked = CAN_ON                  */
/*                 C_SndDataSts.sts.snddata.ok = CAN_OFF                     */
/*                 C_SndDataSts.sts.snddata.backup = CAN_OFF                 */
/*                 C_SndDataSts.sts.snddata.limit = CAN_OFF                  */
/*                 C_SndDataSts.sts.snddata.ng = CAN_OFF                     */
/*                 C_SndDataSts.sts.snddata.cond = -                         */
/*                 C_SndDataSts.sts.snddata.tblvalid = CAN_OFF               */
/*                 C_SndDataSts.sts.snddata.dummy = CAN_OFF                  */
/*                BFMf[^IDXe[^XXV(tbV)         */
/*                 C_SndDataSts.sts.snddata.locked = CAN_ON                  */
/*                 C_SndDataSts.sts.snddata.ok = CAN_OFF                     */
/*                 C_SndDataSts.sts.snddata.backup = CAN_OFF                 */
/*                 C_SndDataSts.sts.snddata.limit = CAN_OFF                  */
/*                 C_SndDataSts.sts.snddata.ng = CAN_OFF                     */
/*                 C_SndDataSts.sts.snddata.cond = -                         */
/*                 C_SndDataSts.sts.snddata.tblvalid = -                     */
/*                 C_SndDataSts.sts.snddata.dummy = CAN_OFF                  */
/*                CFMf[^IDXe[^XXV(Mr⎞)             */
/*                 C_SndDataSts.sts.snddata.locked = -                       */
/*                 C_SndDataSts.sts.snddata.ok = CAN_OFF                     */
/*                 C_SndDataSts.sts.snddata.backup = CAN_OFF                 */
/*                 C_SndDataSts.sts.snddata.limit = CAN_OFF                  */
/*                 C_SndDataSts.sts.snddata.ng = CAN_OFF                     */
/*                 C_SndDataSts.sts.snddata.cond = -                         */
/*                 C_SndDataSts.sts.snddata.tblvalid = -                     */
/*                 C_SndDataSts.sts.snddata.dummy = CAN_OFF                  */
/*                DFMf[^IDXe[^XXV(ML[֊i[)     */
/*                 C_SndDataSts.sts.snddata.locked = -                       */
/*                 C_SndDataSts.sts.snddata.ok = CAN_ON                      */
/*                 C_SndDataSts.sts.snddata.backup = CAN_OFF                 */
/*                 C_SndDataSts.sts.snddata.limit = CAN_OFF                  */
/*                 C_SndDataSts.sts.snddata.ng = -                           */
/*                 C_SndDataSts.sts.snddata.cond = -                         */
/*                 C_SndDataSts.sts.snddata.tblvalid = -                     */
/*                 C_SndDataSts.sts.snddata.dummy = CAN_OFF                  */
/*                EFMf[^IDXe[^XXV(obNAbv֊i[)   */
/*                 C_SndDataSts.sts.snddata.locked = -                       */
/*                 C_SndDataSts.sts.snddata.ok = CAN_OFF                     */
/*                 C_SndDataSts.sts.snddata.backup = CAN_ON                  */
/*                 C_SndDataSts.sts.snddata.limit = CAN_OFF                  */
/*                 C_SndDataSts.sts.snddata.ng = -                           */
/*                 C_SndDataSts.sts.snddata.cond = -                         */
/*                 C_SndDataSts.sts.snddata.tblvalid = -                     */
/*                 C_SndDataSts.sts.snddata.dummy = CAN_OFF                  */
/*                FFMf[^IDXe[^XXV(i[s\)             */
/*                 C_SndDataSts.sts.snddata.locked = -                       */
/*                 C_SndDataSts.sts.snddata.ok = CAN_OFF                     */
/*                 C_SndDataSts.sts.snddata.backup = CAN_ON                  */
/*                 C_SndDataSts.sts.snddata.limit = CAN_ON                   */
/*                 C_SndDataSts.sts.snddata.ng = -                           */
/*                 C_SndDataSts.sts.snddata.cond = -                         */
/*                 C_SndDataSts.sts.snddata.tblvalid = -                     */
/*                 C_SndDataSts.sts.snddata.dummy = CAN_OFF                  */
/*                GFMf[^IDXe[^XXV(M)             */
/*                 C_SndDataSts.sts.snddata.locked = -                       */
/*                 C_SndDataSts.sts.snddata.ok = -                           */
/*                 C_SndDataSts.sts.snddata.backup = -                       */
/*                 C_SndDataSts.sts.snddata.limit = -                        */
/*                 C_SndDataSts.sts.snddata.ng = CAN_OFF                     */
/*                 C_SndDataSts.sts.snddata.cond = -                         */
/*                 C_SndDataSts.sts.snddata.tblvalid = -                     */
/*                 C_SndDataSts.sts.snddata.dummy = -                        */
/*                HFMf[^IDXe[^XXV(Ms)             */
/*                 C_SndDataSts.sts.snddata.locked = -                       */
/*                 C_SndDataSts.sts.snddata.ok = -                           */
/*                 C_SndDataSts.sts.snddata.backup = -                       */
/*                 C_SndDataSts.sts.snddata.limit = -                        */
/*                 C_SndDataSts.sts.snddata.ng = CAN_ON                      */
/*                 C_SndDataSts.sts.snddata.cond = -                         */
/*                 C_SndDataSts.sts.snddata.tblvalid = -                     */
/*                 C_SndDataSts.sts.snddata.dummy = -                        */
/*                IFMf[^IDXe[^XXV(LȊO)               */
/*                 C_SndDataSts.sts.snddata.locked = -                       */
/*                 C_SndDataSts.sts.snddata.ok = CAN_OFF                     */
/*                 C_SndDataSts.sts.snddata.backup = CAN_OFF                 */
/*                 C_SndDataSts.sts.snddata.limit = CAN_OFF                  */
/*                 C_SndDataSts.sts.snddata.ng = -                           */
/*                 C_SndDataSts.sts.snddata.cond = -                         */
/*                 C_SndDataSts.sts.snddata.tblvalid = -                     */
/*                 C_SndDataSts.sts.snddata.dummy = CAN_OFF                  */
/*                s^C~O: InitCOM(),InitBufferCOM(),SndCOM(),        */
/*                                ChkSndStopCOM(),ScanWaitDataCOM(),         */
/*                                ScanEventCOM(),ScanPeriCOM(),              */
/*                                SndMsgCOM(),SendMessage()                */
/*---------------------------------------------------------------------------*/
/*  parameter : UINT8 in_sdtid_idxFMf[^IDCfbNX                 */
/*              UINT8 in_mode                                                */
/*                  CAN_COM_POWERON_INIT : N                    */
/*                  CAN_COM_INITF                                   */
/*                  CAN_COM_RFSHFtbV                             */
/*                  CAN_COM_SNDSTPFMr⎞                               */
/*                  CAN_COM_SNDQUEFbZ[WML[i[               */
/*                  CAN_COM_BKUPFbZ[WobNAbvi[               */
/*                  CAN_COM_LIMITFbZ[Wi[s\                      */
/*                  CAN_COM_SND_OKFM                               */
/*                  CAN_COM_SND_NGFMs                               */
/*  result    : none                                                         */
/*****************************************************************************/
static void UpdtSndIDStsCOM(UINT8 in_sdtid_idx, UINT8 in_mode)
{
    /************ I[gϐ ************/
    UINT8 lp_sdtid;     /* Mf[^ID[vϐ */

    /************ vO ************/
    /* ̃f[^l`FbN */
    if(in_sdtid_idx < CAN_COM_NUM_SNDDATA)
    {
        if (in_mode == CAN_COM_POWERON_INIT)
        {
            for(lp_sdtid=0; lp_sdtid<CAN_COM_NUM_SNDDATA; lp_sdtid++)
            {
                C_SndDataSts[lp_sdtid].sts.byte = CAN_COM_SNDSTS_PWON_INIT;
            }
        }
        else if(in_mode == CAN_COM_INIT)
        {
            for(lp_sdtid=0; lp_sdtid<CAN_COM_NUM_SNDDATA; lp_sdtid++)
            {
                C_SndDataSts[lp_sdtid].sts.byte &= CAN_COM_SNDSTS_INIT_MASK;
                C_SndDataSts[lp_sdtid].sts.byte |= CAN_COM_SNDSTS_INIT;
            }
        }
        else if(in_mode == CAN_COM_RFSH)
        {
            for(lp_sdtid=0; lp_sdtid<CAN_COM_NUM_SNDDATA; lp_sdtid++)
            {
                C_SndDataSts[lp_sdtid].sts.byte &= CAN_COM_SNDSTS_RFSH_MASK;
                C_SndDataSts[lp_sdtid].sts.byte |= CAN_COM_SNDSTS_RFSH;
            }
        }
        else if(in_mode == CAN_COM_SNDSTP)
        {
            for(lp_sdtid=0; lp_sdtid<CAN_COM_NUM_SNDDATA; lp_sdtid++)
            {
                C_SndDataSts[lp_sdtid].sts.byte &= CAN_COM_SNDSTS_SNDSTP;
            }
        }
        else if(in_mode == CAN_COM_SND_OK)
        {
            C_SndDataSts[in_sdtid_idx].sts.byte &= CAN_COM_SNDSTS_SND_OK;
        }
        else if(in_mode == CAN_COM_SND_NG)
        {
            C_SndDataSts[in_sdtid_idx].sts.byte |= CAN_COM_SNDSTS_SND_NG;
        }
        else
        {
            C_SndDataSts[in_sdtid_idx].sts.byte &= CAN_COM_SNDSTS_MASK;
            if(in_mode == CAN_COM_SNDQUE)
            {
                C_SndDataSts[in_sdtid_idx].sts.byte |= CAN_COM_SNDSTS_SNDQUE;
            }
            else if(in_mode == CAN_COM_BKUP)
            {
                C_SndDataSts[in_sdtid_idx].sts.byte |= CAN_COM_SNDSTS_BKUP;
            }
            else if(in_mode == CAN_COM_LIMIT)
            {
                C_SndDataSts[in_sdtid_idx].sts.byte |= CAN_COM_SNDSTS_LIMIT;
            }
            else
            {
                /* LȊO͉̎ȂB */
            }
        }
    }
}

/*****************************************************************************/
/*  Function name : static void UpdtRcvIDStsCOM                              */
/*                  (UINT8 in_rdtid ,UINT8 in_mode)                          */
/*---------------------------------------------------------------------------*/
/*  Description : @FMf[^IDXe[^XXV()               */
/*                 C_RcvDataSts.sts.rcvdata.rcv = CAN_OFF                    */
/*                 C_RcvDataSts.sts.rcvdata.newdata = CAN_OFF                */
/*                 C_RcvDataSts.sts.rcvdata.silent = CAN_OFF                 */
/*                 C_RcvDataSts.sts.rcvdata.ng = CAN_OFF                     */
/*                 C_RcvDataSts.sts.rcvdata.pwon = CAN_ON                    */
/*                 C_RcvDataSts.sts.rcvdata.dummy = CAN_OFF                  */
/*                AFMf[^IDXe[^XXV(tbV)         */
/*                 C_RcvDataSts.sts.rcvdata.rcv = -                          */
/*                 C_RcvDataSts.sts.rcvdata.newdata = CAN_OFF                */
/*                 C_RcvDataSts.sts.rcvdata.silent = CAN_OFF                 */
/*                 C_RcvDataSts.sts.rcvdata.ng = CAN_OFF                     */
/*                 C_RcvDataSts.sts.rcvdata.pwon = -                         */
/*                 C_RcvDataSts.sts.rcvdata.dummy = CAN_OFF                  */
/*                BFMf[^IDXe[^XXV(탁bZ[WM)   */
/*                 C_RcvDataSts.sts.rcvdata.rcv = CAN_ON                     */
/*                 C_RcvDataSts.sts.rcvdata.newdata = CAN_ON                 */
/*                 C_RcvDataSts.sts.rcvdata.silent = CAN_OFF                 */
/*                 C_RcvDataSts.sts.rcvdata.ng = CAN_OFF                     */
/*                 C_RcvDataSts.sts.rcvdata.pwon = CAN_OFF                   */
/*                 C_RcvDataSts.sts.rcvdata.dummy = CAN_OFF                  */
/*                CFMf[^IDXe[^XXV(ُ탁bZ[WM)   */
/*                 C_RcvDataSts.sts.rcvdata.rcv = -                          */
/*                 C_RcvDataSts.sts.rcvdata.newdata = -                      */
/*                 C_RcvDataSts.sts.rcvdata.silent = -                       */
/*                 C_RcvDataSts.sts.rcvdata.ng = CAN_ON                      */
/*                 C_RcvDataSts.sts.rcvdata.pwon = -                         */
/*                 C_RcvDataSts.sts.rcvdata.dummy = -                        */
/*                DFMf[^IDXe[^XXV(Mr⎞)             */
/*                 C_RcvDataSts.sts.rcvdata.rcv = -                          */
/*                 C_RcvDataSts.sts.rcvdata.newdata = -                      */
/*                 C_RcvDataSts.sts.rcvdata.silent = CAN_ON                  */
/*                 C_RcvDataSts.sts.rcvdata.ng = -                           */
/*                 C_RcvDataSts.sts.rcvdata.pwon = -                         */
/*                 C_RcvDataSts.sts.rcvdata.dummy = -                        */
/*                EFMf[^IDXe[^XXV(LȊO)               */
/*                 C_RcvDataSts.sts.rcvdata.rcv = -                          */
/*                 C_RcvDataSts.sts.rcvdata.newdata = -                      */
/*                 C_RcvDataSts.sts.rcvdata.silent = -                       */
/*                 C_RcvDataSts.sts.rcvdata.ng = -                           */
/*                 C_RcvDataSts.sts.rcvdata.pwon = -                         */
/*                 C_RcvDataSts.sts.rcvdata.dummy = -                        */
/*                s^C~O: InitCOM(),InitBufferCOM(),SndCOM(),        */
/*                                GetRcvMsgQue2BufCOM(),                     */
/*                                GetRcvMsgSlot2BufCOM(),ChkRcvStopCOM()   */
/*---------------------------------------------------------------------------*/
/*  parameter : UINT8 in_rdtidFMf[^ID                                 */
/*              UINT8 in_mode                                                */
/*                  CAN_COM_INITF                                   */
/*                  CAN_COM_RFSHFtbV                             */
/*                  CAN_COM_RCV_OKF탁bZ[WM                     */
/*                  CAN_COM_RCV_NGFُ탁bZ[WM                     */
/*                  CAN_COM_RCVSTPFMr⎞                               */
/*  result    : none                                                         */
/*****************************************************************************/
static void UpdtRcvIDStsCOM(UINT8 in_rdtid ,UINT8 in_mode)
{
    /************ I[gϐ ************/
    UINT8 lp_rdtid;         /* Mf[^ID[vϐ */

    /************ vO ************/
    /* ̃f[^l`FbN */
    if(in_rdtid < CAN_COM_NUM_RCVDATA)
    {
        if(in_mode == CAN_COM_INIT)
        {
            for(lp_rdtid=0; lp_rdtid<CAN_COM_NUM_RCVDATA; lp_rdtid++)
            {
                C_RcvDataSts[lp_rdtid].sts.byte = CAN_COM_RCVSTS_INIT;
            }
        }
        else if(in_mode == CAN_COM_RFSH)
        {
            for(lp_rdtid=0; lp_rdtid<CAN_COM_NUM_RCVDATA; lp_rdtid++)
            {
                C_RcvDataSts[lp_rdtid].sts.byte &= CAN_COM_RCVSTS_RFSH;
            }
        }
        else if(in_mode == CAN_COM_RCV_OK)
        {
            C_RcvDataSts[in_rdtid].sts.byte = CAN_COM_RCVSTS_RCV_OK;
        }
        else if(in_mode == CAN_COM_RCV_NG)
        {
            C_RcvDataSts[in_rdtid].sts.byte |= CAN_COM_RCVSTS_RCV_NG;
        }
        else if(in_mode == CAN_COM_RCVSTP)
        {
            C_RcvDataSts[in_rdtid].sts.byte |= CAN_COM_RCVSTS_RCVSTP;
        }
        else
        {
            /* LȊO͉̎ȂB */
        }
    }
}

/*****************************************************************************/
/*  Function name : static void UpdtDrvSndStsCOM(UINT8 in_mode)              */
/*---------------------------------------------------------------------------*/
/*  Description : @FDRIVERMXe[^XXV()                 */
/*                 C_DrvSndSts.bit.event = CAN_OFF                           */
/*                 C_DrvSndSts.bit.peri = CAN_OFF                            */
/*                 C_DrvSndSts.bit.idle = CAN_ON                             */
/*                 C_DrvSndSts.bit.dummy = CAN_OFF                           */
/*                AFDRIVERMXe[^XXV(CxgbZ[WM) */
/*                 C_DrvSndSts.bit.event = CAN_ON                            */
/*                 C_DrvSndSts.bit.peri = CAN_OFF                            */
/*                 C_DrvSndSts.bit.idle = CAN_OFF                            */
/*                 C_DrvSndSts.bit.dummy = CAN_OFF                           */
/*                BFDRIVERMXe[^XXV(MbZ[WM) */
/*                 C_DrvSndSts.bit.event = CAN_OFF                           */
/*                 C_DrvSndSts.bit.peri = CAN_ON                             */
/*                 C_DrvSndSts.bit.idle = CAN_OFF                            */
/*                 C_DrvSndSts.bit.dummy = CAN_OFF                           */
/*                CFDRIVERMXe[^XXV(MԊuۏ؊m莞)       */
/*                 C_DrvSndSts.bit.event = -                                 */
/*                 C_DrvSndSts.bit.peri = -                                  */
/*                 C_DrvSndSts.bit.idle = CAN_ON                             */
/*                 C_DrvSndSts.bit.dummy = CAN_OFF                           */
/*                DFDRIVERMXe[^XXV(M)                 */
/*                 C_DrvSndSts.bit.event = -                                 */
/*                 C_DrvSndSts.bit.peri = -                                  */
/*                 C_DrvSndSts.bit.idle = CAN_OFF                            */
/*                 C_DrvSndSts.bit.dummy = CAN_OFF                           */
/*                EFDRIVERMXe[^XXV(LȊO)                 */
/*                 C_DrvSndSts.bit.event = CAN_OFF                           */
/*                 C_DrvSndSts.bit.peri = CA_OFF                             */
/*                 C_DrvSndSts.bit.idle = CAN_OFF                            */
/*                 C_DrvSndSts.bit.dummy = CAN_OFF                           */
/*                s^C~O: InitCOM(),SndCOM(),ChkSndStopCOM(),        */
/*                                ChkSndItvTimeCOM(),SndMsgCOM()           */
/*---------------------------------------------------------------------------*/
/*  parameter : UINT8 in_mode                                                */
/*                  CAN_COM_INITF                                   */
/*                  CAN_COM_EVENTFCxgbZ[WM                  */
/*                  CAN_COM_PERIFMbZ[WM                   */
/*                  CAN_COM_IDLEFbZ[WMԊuۏ؊m莞               */
/*                  CAN_COM_SNDFbZ[WM                          */
/*  result    : none                                                         */
/*****************************************************************************/
static void UpdtDrvSndStsCOM(UINT8 in_mode)
{
    /************ vO ************/
    if(in_mode == CAN_COM_INIT)
    {
        C_DrvSndSts.byte = CAN_COM_DRVSNDSTS_IDLE;
    }
    else if(in_mode == CAN_COM_IDLE)
    {
        C_DrvSndSts.byte &= CAN_COM_DRVSNDSTS_MASK;
        C_DrvSndSts.byte |= CAN_COM_DRVSNDSTS_IDLE;
    }
    else if(in_mode == CAN_COM_EVENT)
    {
        C_DrvSndSts.byte = CAN_COM_DRVSNDSTS_EVENT;
    }
    else if(in_mode == CAN_COM_PERI)
    {
        C_DrvSndSts.byte = CAN_COM_DRVSNDSTS_PERI;
    }
    else if(in_mode == CAN_COM_SND)
    {
        C_DrvSndSts.byte &= CAN_COM_DRVSNDSTS_SND;
    }
    else
    {
        C_DrvSndSts.byte = (UINT8)CAN_CLR;
    }
}

/*****************************************************************************/
/*  Function name : StatusType GetStsCOM(COMStsType *out_sts)                */
/*---------------------------------------------------------------------------*/
/*  Description : COMXe[^X擾                                      */
/*                s^C~O: C                                       */
/*---------------------------------------------------------------------------*/
/*  parameter : COMStatusType *stsFCOMXe[^X                        */
/*  result    : StatusType                                                   */
/*                  CAN_E_OKF펞                                         */
/*                  CAN_E_NGFُ펞                                         */
/*****************************************************************************/
StatusType GetStsCOM(COMStsType *out_sts)
{
    /************ I[gϐ ************/
    StatusType result = CAN_E_NG;   /* ߂li[̈ */

    /************ vO ************/
    out_sts->byte = C_Sts.byte;
    result = CAN_E_OK;

    return  result;
}

/*****************************************************************************/
/*  Function name : StatusType GetSndMsgStsCOM                               */
/*                  (UINT16 in_sdtid, CANAPIDataStsType *out_sts)            */
/*---------------------------------------------------------------------------*/
/*  Description : COMMf[^Xe[^X擾                            */
/*                s^C~O: C                                       */
/*---------------------------------------------------------------------------*/
/*  parameter : UINT16 in_sdtidFMf[^ID                                */
/*                 CANAPIDataStsType *out_stsFMf[^IDXe[^X        */
/*  result    : StatusType                                                   */
/*                  CAN_E_OKF펞                                         */
/*                  CAN_E_NGFُ펞                                         */
/*****************************************************************************/
StatusType GetSndMsgStsCOM(UINT16 in_sdtid, CANAPIDataStsType *out_sts)
{
    /************ I[gϐ ************/
    StatusType result = CAN_E_NG;   /* ߂li[̈ */
    UINT8 lp_sdtid;                     /* Mf[^ID[vϐ */

    /************ vO ************/
    /* w肳ꂽMf[^IDÃf[^ID̃f[^Xe[^XԂ */
    for(lp_sdtid=0; lp_sdtid<CAN_COM_NUM_SNDDATA; lp_sdtid++)
    {
        if(in_sdtid == CANSNDDATA_TABLE[lp_sdtid].data_id)
        {
            out_sts->byte = C_SndDataSts[lp_sdtid].sts.byte;
            result = CAN_E_OK;
            break;
        }
    }

    return result;
}

/*****************************************************************************/
/*  Function name : StatusType GetRcvMsgStsCOM                               */
/*                  (UINT16 in_rdtid, CANAPIDataStsType *out_sts)            */
/*---------------------------------------------------------------------------*/
/*  Description : COMMf[^Xe[^X擾                            */
/*                s^C~O: C                                       */
/*                ӎ : switchȊOAbreakgp                   */
/*---------------------------------------------------------------------------*/
/*  parameter : UINT16 in_rdtidFMf[^ID                                */
/*                 CANAPIDataStsType *out_stsFMf[^IDXe[^X        */
/*  result    : StatusType                                                   */
/*                  CAN_E_OKF펞                                         */
/*                  CAN_E_NGFُ펞                                         */
/*****************************************************************************/
StatusType GetRcvMsgStsCOM(UINT16 in_rdtid, CANAPIDataStsType *out_sts)
{
    /************ I[gϐ ************/
    StatusType result = CAN_E_NG;   /* ߂li[̈ */
    UINT8 lp_rdtid;                 /* Mf[^ID[vϐ */

    /************ vO ************/
    /* w肳ꂽMf[^IDÃf[^ID̃f[^Xe[^XԂ */
    for(lp_rdtid=0; lp_rdtid<CAN_COM_NUM_RCVDATA; lp_rdtid++)
    {
        if(in_rdtid == CANRCVDATA_TABLE[lp_rdtid].data_id)
        {
            out_sts->byte = C_RcvDataSts[lp_rdtid].sts.byte;
            result = CAN_E_OK;
            break;
        }
    }

    return result;
}

/*****************************************************************************/
/*  Function name : StatusType GetRcvAllMsgStsCOM                            */
/*                  (COMRcvDataStsType **out_sts_adr)                        */
/*---------------------------------------------------------------------------*/
/*  Description : COMMf[^Xe[^X擾                            */
/*                s^C~O: C                                       */
/*---------------------------------------------------------------------------*/
/*  parameter : COMRcvDataStsType **out_stsFMf[^Xe[^XAhX    */
/*  result    : StatusType                                                   */
/*                  CAN_E_OKF펞                                         */
/*                  CAN_E_NGFُ펞                                         */
/*****************************************************************************/
StatusType GetRcvAllMsgStsCOM(COMRcvDataStsType **out_sts_adr)
{
    /************ I[gϐ ************/
    StatusType result = CAN_E_NG;   /* ߂li[̈ */

    /************ vO ************/
    *out_sts_adr = &C_RcvDataSts[0];
    result = CAN_E_OK;

    return result;
}

/*****************************************************************************/
/*  Function name : void CntCOM(void)                                        */
/*---------------------------------------------------------------------------*/
/*  Description : 1msecVXe^C}JEg                            */
/*                s^C~O: [U[Av1msec荞ݏ        */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/

void CntCOM(void)
{
    /************ vO ************/
    C_SysTime++;
}

/*****************************************************************************/
/*  Function name : void CallCOMSndMsgDRV(void)                              */
/*---------------------------------------------------------------------------*/
/*  Description : M̃^C}lLv`                         */
/*                s^C~O: DRIVEȒM荞݊             */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
void CallCOMSndMsgDRV(void)
{
    /************ vO ************/
    C_SysTimeCapBuf = C_SysTime;

#ifdef CAN_COM_NM_INDIRECT
    if( C_OwnNode == CAN_TRUE )
    {
        if(C_OwnNodeCnt != (UINT8)CAN_CLR)
        {
            C_OwnNodeCnt--;
        }
        C_OwnNode = CAN_FALSE;
        (void)FncCANMsgTransfer(CAN_COM_OWN_NODE_IDX);
    }
#endif

}
