/*
 *	TOPPERS NonOS CAN Middleware
 *		Toyohashi Open Platform for Embedded Real-Time Systems
 *		NonOS CAN Middleware
 * 
 *	Copyright (C) 2007 Sunny Giken Inc.
 * 
 *	L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *	ɂČ\Ă GNU General Public License  Version 2 ɋL
 *	qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *	ς̂܂ށDȉjgpEEρEĔzziȉC
 *	pƌĂԁj邱Ƃ𖳏ŋD
 *	(1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *		\C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *		XR[hɊ܂܂Ă邱ƁD
 *	(2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *		pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *		҃}jAȂǁjɁCL̒쌠\C̗pщL
 *		̖ۏ؋Kfڂ邱ƁD
 *	(3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *		płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *		ƁD
 *	  (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *		  쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *	  (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *		  񍐂邱ƁD
 *	(4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *		QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *	{\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *	TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *	܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *	ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */
/*
 *@Version 1.00  2007.10.26
 */

/*
 *	CMW-NMW[
 */

/*---------------------------------------------------------------------------*/
/*  wb_t@C̃CN[h                                             */
/*---------------------------------------------------------------------------*/
/* ʃwb_ */
#include    "can_cmn.h"             /* lbg[NOSpeݒt@C      */

/* DRV֘A */
#include    "can_drv_csw.h"         /* DRV֘ARpCXCb`pt@C   */
#include    "can_drv_def.h"         /* DRV֘Aݒt@C                   */
#include    "can_drv_ext.h"         /* DRVO[o`t@C             */

/* pwb_ */
#include    "can_nm_def.h"          /* NMpUSER`t@C                */
#include    "can_nm_ext.h"          /* NMO[o`t@C              */
#include    "can_nm.h"              /* NM`t@C                        */

/*---------------------------------------------------------------------------*/
/*  ^`                                                                   */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/*  }N                                                                   */
/*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*/
/*  Jϐ                                                                 */
/*---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*/
/*  ϐ                                                                 */
/*---------------------------------------------------------------------------*/
/* eԕϐ */
static NMModeStsType    N_ModeSts;                          /* NM        */
static NetStsType       N_NetSts;                           /* NMȯܰð */
static NMCtlStsType     N_CtlSts;                           /* NM      */
static NMStsType        N_NMSts;                            /* NMM  */
static NMCOMStsType     N_COMSts;                           /* COMM */
static ECUStsType       N_ECUSts;                           /* ݂ECU */

static NMCntTimerType   N_CntTimer;                         /* ϐ       */
static NMTimeOutType    N_TimeOut;                          /* ѱČo    */

/* ްۑޯ̧ */
static NMMsgType        N_SndDataBuf;                       /* Mްޯ̧ */
static NMMsgType        N_RcvDataBuf;                       /* Mްޯ̧ */

/* e϶ */
static UINT16           N_CntTwbs;                          /* Twbs϶   */
                                                            /*       ϶ */
static UINT8            N_CntTtyp;                          /* Ttyp϶   */
static UINT16           N_CntTmax;                          /* Tmax϶   */
static UINT16           N_CntTerr;                          /* Terr϶   */

/* M */
static UINT8            N_rxcount;                          /* M      */
static UINT8            N_txcount;                          /* M      */

/* ڑɰID֘A */
static UINT8            N_LogScs;                           /* _      */

static UINT8            N_CntRcvRingMsg;                    /* ݸүގM*/
                                                            /*           */
static UINT8            N_CntRcvNumNode;                    /* _ݸލ\  */
                                                            /* ðيi[ */
static UINT8            N_CntLogRingNode;                   /* _ݸލ\p*/
                                                            /* үގM*/
static UINT8            N_LogRingNodeTbl[CAN_ECU_NUM_NODE]; /* _ݸ      */
                                                            /*     \ð */

static CANMsgType       N_SndMsg;                           /* Mf[^    */
                                                            /*  obNAbv */
/* OSEKǫ̇ܰڰݎdlǉ */
static CfgRefType N_Cfg_Prsnt[(CAN_NM_SOURCE_ID_MASK >> CAN_NM_DIV8)+1];
static CfgRefType N_Cfg_LmpHm[(CAN_NM_SOURCE_ID_MASK >> CAN_NM_DIV8)+1];

/* M֘A */
static NMSndQueType     NMSndQue;

static NMRcvQueType     NMRcvQue;

/*---------------------------------------------------------------------------*/
/*  ֐prototype錾                                                      */
/*---------------------------------------------------------------------------*/
/* NMԊ֐ */
static void NMOffMode(void);                        /* NMOff             */
static void NMInitMode(void);                       /* NMInit            */
static void NMResetMode(void);                      /* NMReset           */
static void NMNormalMode(void);                     /* NMNormal          */
static void NMLimpHomeMode(void);                   /* NMLimpHome        */
static void NMLimpHomePrepBusSleepMode(void);       /* NMLimpHomeBusSleep*/
static void NMTwbsMode(void);                       /* TwbsNormal,           */
                                                    /*      TwbsLimpHome */
static void NMBusSleepMode(void);                   /* NMBusSleep        */
static void NMOtherMode(void);                      /* ̑̏          */

/* NMԑJڊ֐ */
static void TrnsNMMode(void);                       /* NMeԑJڏ      */
static StatusType GoToNMInitMode(void);             /* NMInitԑJ        */
static StatusType GoToNMResetMode(void);            /* NMResetԑJ       */
static StatusType GoToNMNormalMode(void);           /* NMNormalԑJ      */
static StatusType GoToNMLimpHomeMode(void);         /* NMLimpHomeԑJ    */
static StatusType GoToNMPrepBusSleepMode(void);     /* NMLimpHome            */
                                                    /*  PrepBusSleepԑJ */
static StatusType GoToNMTwbsMode(void);             /* TwbsNormal,           */
                                                    /*  TwbsLimpHomeԑJ */
static StatusType GoToNMBusSleepMode(void);         /* NMBusSleepԑJ    */
static void ShiftNMLimpHomeMode(void);              /* NMLimpHomeԑJڏ*/
static void ShiftNMBusSleepMode(void);              /* NMBusSleepԑJڏ*/
static void StrWkupSeq(void);                       /* WakeUpݽJn   */

/* eϊ֐ */
static void SetAlarm(NMTimerType);                  /* eϊJn֐       */
static void CancelAlarm(NMTimerType);               /* eϒ~֐       */
static void RunTimer(void);                         /* eϊǗ֐       */
static void SetTimeOutTtyp(void);                   /* Ttypѱ׸޾Ċ֐ */
static void SetTimeOutTmax(void);                   /* Tmaxѱ׸޾Ċ֐ */
static void SetTimeOutTerr(void);                   /* Terrѱ׸޾Ċ֐ */
static void SetTimeOutTwbs(void);                   /* Twbsѱ׸޾Ċ֐ */
static void ClrTimeOut(void);                       /* ѱ׸޸ر֐     */
static void TimerTtyp(void);                        /* Ttyp               */
static void TimerTmax(void);                        /* Tmax               */
static void TimerTerr(void);                        /* LimpHomeMsgMԊu*/
static void TimerTwbs(void);                        /* NMBusSleepڍsԊu */

/* ֐ */
static void InitIntrData(void);                     /* eϐ          */
static void InitNMDataBuf(void);                    /* Mޯ̧̏   */
static void InitNMQue(void);                        /* M̏     */
static void InitLogRingNodeTbl(void);               /* _ݸލ\ðق   */
                                                    /*                 */
/* үޑM֘A */
static StatusType SetSndBufNMMsg(UINT8);            /* Mޯ̧ւNMү */
                                                    /*              ߊi[ */
static void SetSndQueNMMsg(void);                   /* Mޯ̧ް     */
static void SetDRVNMMsg(void);                      /* MްDRIVER */
                                                    /*                ֊i[ */
/* үގM֘A */
static void GetRcvDataNMQue(void);                  /* M̊l */
static void ChkRcvNMMsg(void);                      /* MMsg̏       */
static void ChkRcvSlpMark(void);                    /* ȯܰSleep     */
                                                    /*         /֎~ */
static StatusType ChkAppSlpReq(void);               /* AppSleep     */
                                                    /*         /֎~ */

static void SetLogScs(void);                        /* _          */
static StatusType SkipOwnNode(void);                /* ɰ޽ߌ       */

static StatusType BldLogRingNet(void);              /* _ݸލ\z          */
static StatusType ChkRingNetStable(void);           /* _ݸȯܰ蔻*/
static StatusType SetConfig(CfgKndName, UINT8);     /* ǫ̇ܰڰݓo^ */
static void InitConfig(CfgKndName);                 /*ǫ̇ܰڰݏ*/

/*---------------------------------------------------------------------------*/
/*  ֐                                                                     */
/*---------------------------------------------------------------------------*/
/*****************************************************************************/
/*  Function name : void InitNM(void)                                        */
/*---------------------------------------------------------------------------*/
/*  Description : RAM                                              */
/*                s^C~O:d                                  */
/*                ӎF߂l`FbN̕Kv֐voidLXggp */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
void InitNM(void)
{
    /************ ۸ ************/
    InitIntrData();

    (void)FncDisCANWkupInt();
    (void)FncDisCANRcvInt();
    (void)FncDisCANSndInt();
    (void)FncDisCANErrInt();
    (void)FncChgModCAN(CAN_DRV_CAN_RESET);

    (void)GoToMode(CAN_NM_AWAKE);

    N_ModeSts = CAN_NMOff;
}

/*****************************************************************************/
/*  Function name : void TickNM(void)                                        */
/*---------------------------------------------------------------------------*/
/*  Description : C                                             */
/*                s^C~O:C֐                            */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
void TickNM(void)
{
    /************ ۸ ************/
    RunTimer();

    GetRcvDataNMQue();

    SetDRVNMMsg();
}

/*****************************************************************************/
/*  Function name : static void TrnsNMMode(void)                             */
/*---------------------------------------------------------------------------*/
/*  Description : NMeԏ                                               */
/*                s^C~O:C֐                            */
/*                ӎF߂l`FbN̕Kv֐voidLXggp */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void TrnsNMMode(void)
{
    /************  ϐ   ************/
    UINT8 m_snd_sts = CAN_DRV_WAIT; /* MԎ擾p */
    
    /************ ۸ ************/
    /* NM̏Ԃ𔻒肵ĊeԏɈڍs */
    switch(N_ModeSts)
    {
        case(CAN_NMNormal):
        case(CAN_NMNormalPrepBusSleep):
            NMNormalMode();
            /* ԑJڔ */
            if(GoToNMTwbsMode() == CAN_E_OK)
            {
                N_ModeSts = CAN_NMTwbs;
                N_COMSts.byte = CAN_NM_RCVONLY;
                CancelAlarm(CAN_NM_TTYP);
                CancelAlarm(CAN_NM_TMAX);
                SetAlarm(CAN_NM_TWBS);
            }
            else if(GoToNMResetMode() == CAN_E_OK)
            {
                N_ModeSts = CAN_NMReset;
                CancelAlarm(CAN_NM_TMAX);
            }
            else if(GoToNMLimpHomeMode() == CAN_E_OK)
            {
                N_ModeSts = CAN_NMLimpHome;
                if(N_NetSts.bit.StatusBusError == CAN_ON)
                {
                    N_COMSts.byte = CAN_NM_RCVONLY;
                }
                CancelAlarm(CAN_NM_TTYP);
                CancelAlarm(CAN_NM_TMAX);
                SetAlarm(CAN_NM_TERR);
            }
            else if(GoToNMPrepBusSleepMode() == CAN_E_OK)
            {
                N_ModeSts = CAN_NMNormalPrepBusSleep;
            }
            else if(GoToNMNormalMode() == CAN_E_OK)
            {
                N_ModeSts = CAN_NMNormal;
            }
            else
            {
                /* Ԃێ */
            }
            break;

        case(CAN_NMReset):
            NMResetMode();
            /* ԑJڔ */
            if(GoToNMLimpHomeMode() == CAN_E_OK)
            {
                N_ModeSts = CAN_NMLimpHome;
                CancelAlarm(CAN_NM_TMAX);
                SetAlarm(CAN_NM_TERR);
            }
            else /* if(GoToNMNormalMode() == CAN_E_OK) */
            {
                N_ModeSts = CAN_NMNormal;

                N_COMSts.byte = CAN_NM_NML;
                SetAlarm(CAN_NM_TTYP);
            }
            break;

        case(CAN_NMLimpHome):
            NMLimpHomeMode();
            /* ԑJڔ */
            if(GoToNMResetMode() == CAN_E_OK)
            {
                N_ModeSts = CAN_NMReset;
                N_txcount = (UINT8)CAN_CLR;
                N_rxcount = (UINT8)CAN_CLR;
                CancelAlarm(CAN_NM_TERR);
            }
            else if(GoToNMPrepBusSleepMode() == CAN_E_OK)
            {
                N_ModeSts = CAN_NMLimpHomePrepBusSleep;
                N_COMSts.byte = CAN_NM_NML;
                CancelAlarm(CAN_NM_TERR);
                SetAlarm(CAN_NM_TMAX);
            }
            else if(GoToNMTwbsMode() == CAN_E_OK)
            {
                N_ModeSts = CAN_NMTwbs;
                N_COMSts.byte = CAN_NM_RCVONLY;
                CancelAlarm(CAN_NM_TERR);
                SetAlarm(CAN_NM_TWBS);
                FncAbtAllSndMsgDRV();
                NMSndQue.wr_ptr = (UINT8)CAN_CLR;
                NMSndQue.rd_ptr = (UINT8)(CAN_NM_NUM_SNDQUE - 1);
            }
            else
            {
                /* Ԃێ */
                if(N_TimeOut.bit.terr == CAN_ON)
                {
                    N_COMSts.byte = CAN_NM_NML;
                }
                else if(N_NetSts.bit.StatusBusError == CAN_ON)
                {
                    FncGetNMSndStsDRV(&m_snd_sts);
                    if(m_snd_sts == CAN_DRV_EMPTY)
                    {
                        N_COMSts.byte = CAN_NM_RCVONLY;
                    }
                }
                else
                {
                    /* Ȃ */
                }
            }
            break;

        case(CAN_NMBusSleep):
            NMBusSleepMode();
            /* ԑJڔ */
            if(GoToNMInitMode() == CAN_E_OK)
            {
                N_ModeSts = CAN_NMInit;
                N_COMSts.byte = CAN_NM_WAITING;
                N_txcount = (UINT8)CAN_CLR;
                N_rxcount = (UINT8)CAN_CLR;
            }
            break;

        case(CAN_NMLimpHomePrepBusSleep):
            NMLimpHomePrepBusSleepMode();
            /* ԑJڔ */
            if(GoToNMResetMode() == CAN_E_OK)
            {
                N_ModeSts = CAN_NMReset;
                N_txcount = (UINT8)CAN_CLR;
                N_rxcount = (UINT8)CAN_CLR;
                CancelAlarm(CAN_NM_TMAX);
            }
            else if(GoToNMTwbsMode() == CAN_E_OK)
            {
                N_ModeSts = CAN_NMTwbs;
                N_COMSts.byte = CAN_NM_RCVONLY;
                CancelAlarm(CAN_NM_TMAX);
                SetAlarm(CAN_NM_TWBS);
                FncAbtAllSndMsgDRV();
                NMSndQue.wr_ptr = (UINT8)CAN_CLR;
                NMSndQue.rd_ptr = (UINT8)(CAN_NM_NUM_SNDQUE - 1);
            }
            else if(GoToNMLimpHomeMode() == CAN_E_OK)
            {
                N_ModeSts = CAN_NMLimpHome;
                if(N_NetSts.bit.StatusBusError == CAN_ON)
                {
                    FncGetNMSndStsDRV(&m_snd_sts);
                    if(m_snd_sts == CAN_DRV_EMPTY)
                    {
                        N_COMSts.byte = CAN_NM_RCVONLY;
                    }
                }
                CancelAlarm(CAN_NM_TMAX);
                SetAlarm(CAN_NM_TERR);
            }
            else
            {
                /* Ԃێ */
                if(N_NetSts.bit.StatusBusError == CAN_ON)
                {
                    FncGetNMSndStsDRV(&m_snd_sts);
                    if(m_snd_sts == CAN_DRV_EMPTY)
                    {
                        N_COMSts.byte = CAN_NM_RCVONLY;
                    }
                }
            }
            break;

        case(CAN_NMTwbs):
            NMTwbsMode();
            /* ԑJڔ */
            if(GoToNMBusSleepMode() == CAN_E_OK)
            {
                N_ModeSts = CAN_NMBusSleep;
                ShiftNMBusSleepMode();
                N_COMSts.byte = CAN_NM_STP;
                CancelAlarm(CAN_NM_TWBS);
            }
            else if(GoToNMInitMode() == CAN_E_OK)
            {
                N_ModeSts = CAN_NMInit;
                N_COMSts.byte = CAN_NM_WAITING;
                N_txcount = (UINT8)CAN_CLR;
                N_rxcount = (UINT8)CAN_CLR;

                CancelAlarm(CAN_NM_TWBS);
            }
            else if(GoToNMLimpHomeMode() == CAN_E_OK)
            {
                N_ModeSts = CAN_NMLimpHome;
                N_COMSts.byte = CAN_NM_NML;
                CancelAlarm(CAN_NM_TWBS);
                SetAlarm(CAN_NM_TERR);
            }
            else
            {
                /* Ԃێ */
            }
            break;

        case(CAN_NMInit):
            NMInitMode();
            /* ԑJڔ */
            if(GoToNMResetMode() == CAN_E_OK)
            {
                N_ModeSts = CAN_NMReset;
            }
            break;

        case(CAN_NMOff):
            NMOffMode();
            if(GoToNMInitMode() == CAN_E_OK)
            {
                (void)FncDisCANWkupInt();
                
                if(FncChgModCAN(CAN_DRV_CAN_RUN) == CAN_E_OK)
                {
                    (void)FncEnCANRcvInt();
                    (void)FncEnCANSndInt();
                    (void)FncEnCANErrInt();
                }
                
                N_ModeSts = CAN_NMInit;
                N_COMSts.byte = CAN_NM_WAITING;
            }
            break;

        default:
            NMOtherMode();
            if(GoToNMBusSleepMode() == CAN_E_OK)
            {
                N_ModeSts = CAN_NMBusSleep;
                ShiftNMBusSleepMode();
                N_COMSts.byte = CAN_NM_STP;
                CancelAlarm(CAN_NM_TALL);
            }
            else /* if(GoToNMInitMode() == CAN_E_OK) */
            {
                N_ModeSts = CAN_NMInit;
                N_COMSts.byte = CAN_NM_WAITING;
                (void)FncDisCANWkupInt();
                if(FncChgModCAN(CAN_DRV_CAN_RUN) == CAN_E_OK)
                {
                    (void)FncEnCANRcvInt();
                    (void)FncEnCANSndInt();
                    (void)FncEnCANErrInt();
                }
                N_NetSts.byte = CAN_NM_WKUP_NETSTS;
            }
            break;
    }
    ClrTimeOut();
    N_CtlSts.bit.rcv_comp = CAN_OFF;
}

/*****************************************************************************/
/*  Function name : static void NMOffMode(void)                              */
/*---------------------------------------------------------------------------*/
/*  Description : NMOff                                                  */
/*                s^C~O:NMOffԎ                                 */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void NMOffMode(void)
{
    /************ ۸ ************/
    N_NetSts.bit.StatusNMActive = CAN_ON;
}

/*****************************************************************************/
/*  Function name : static void NMInitMode(void)                             */
/*---------------------------------------------------------------------------*/
/*  Description : NMInit                                                 */
/*                s^C~O:NMInitԎ                                */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void NMInitMode(void)
{
    /************ ۸ ************/
    N_NMSts.sndstop = CAN_OFF;
    N_NMSts.rcvstop = CAN_OFF;
    N_NMSts.dummy = CAN_CLR;

    InitNMDataBuf();
    InitConfig(CAN_LimpHome);
}

/*****************************************************************************/
/*  Function name : static void NMResetMode(void)                            */
/*---------------------------------------------------------------------------*/
/*  Description : NMReset                                                */
/*                s^C~O:NMResetԎ                               */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void NMResetMode(void)
{
    /************ ۸ ************/
    N_NetSts.bit.StatusRingStable = CAN_OFF;
    N_NetSts.bit.StatusBusSleepInd = CAN_OFF;
    N_SndDataBuf.opcode.bit.sleepind = CAN_OFF;

    N_CntRcvRingMsg = (UINT8)CAN_CLR;
    N_CntLogRingNode = (UINT8)CAN_CLR;
    N_CntRcvNumNode = (UINT8)CAN_CLR;
    NMSndQue.wr_ptr = (UINT8)CAN_CLR;
    NMSndQue.rd_ptr = (UINT8)(CAN_NM_NUM_SNDQUE - 1);

    InitConfig(CAN_Normal);
    N_LogScs = CAN_ALL_MYSELF;
    /* NMrxcount͋N+1ĂB̑ɰAliveMsgMɂĶްނ */
    if(N_rxcount < CAN_LIMIT8)
    {
        N_rxcount++;
    }

    if(N_rxcount <= CAN_NM_RX_LIMIT)
    {
        /* NMResetԏ */
        if(SetSndBufNMMsg(CAN_ALIVEMSG) == CAN_E_OK)
        {
            SetSndQueNMMsg();
            if(N_txcount < CAN_LIMIT8)
            {
                N_txcount++;
            }
        } /* Mޯ̧Ɋi[ްL̂ */

        if(N_CtlSts.bit.wkup_seq == CAN_ON)
        {
            N_CtlSts.bit.wkup_seq = CAN_OFF;
            N_CtlSts.bit.wkup_fct = CAN_OFF;
        }
    }
    else
    {
        N_NMSts.rcvstop = CAN_ON;
        ShiftNMLimpHomeMode();
    }

}

/*****************************************************************************/
/*  Function name : static void NMNormalMode(void)                           */
/*---------------------------------------------------------------------------*/
/*  Description : NMNormal                                               */
/*                s^C~O:NMNormalԎ                              */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void NMNormalMode(void)
{
    /************ ĕϐ ************/
    UINT8 m_drv_sts = CAN_DRV_BUSOFF;
    UINT8 m_snd_sts = CAN_DRV_WAIT;   /* MԎ擾p */
    
    /************ ۸ ************/
    if(N_CtlSts.bit.rcv_comp == CAN_ON)
    {
        ChkRcvNMMsg();
        if(N_SndDataBuf.opcode.bit.sleepind == CAN_ON)
        {
            /* RingMsgMOɓɎMRingMsg͖ */
            if((N_CtlSts.bit.dis_ring == CAN_OFF)
            || (N_RcvDataBuf.opcode.bit.ring == CAN_OFF))
            {
                ChkRcvSlpMark();
            }
        }
    }

    FncGetBusoffStsDRV(&m_drv_sts);

    if(m_drv_sts == CAN_DRV_NORMAL)
    {
        FncGetNMSndStsDRV(&m_snd_sts);
        if(m_snd_sts == CAN_DRV_COMP)
        {
            N_txcount = (UINT8)CAN_CLR;
        }
        if(N_CtlSts.bit.rcv_comp == CAN_ON)
        {
            N_rxcount = (UINT8)CAN_CLR;
        }
        /* RingMsgM */
        if(N_TimeOut.bit.ttyp == CAN_ON)
        {
            if(N_txcount <= CAN_NM_TX_LIMIT)
            {
                if(ChkAppSlpReq() == CAN_E_OK)
                {
                    if(N_SndDataBuf.opcode.bit.sleepack == CAN_ON)
                    {
                        N_NetSts.bit.StatusBusSleepInd = CAN_OFF;
                        N_NetSts.bit.StatusWaitBusSleep = CAN_ON;
                        N_NetSts.bit.StatusRingStable = CAN_OFF;
                        N_CtlSts.bit.cnt_ring = CAN_OFF;
                    }
                    else if(N_NetSts.bit.StatusWaitBusSleep == CAN_OFF)
                    {
                        N_NetSts.bit.StatusBusSleepInd = CAN_ON;
                    }
                    else
                    {
                        /* Ȃ */
                    }
                }
                /* Mޯ̧ްi[ */
                if(SetSndBufNMMsg(CAN_RINGMSG) == CAN_E_OK)
                {
                    /* M֑Mޯ̧ްi[ */
                    if(N_txcount < CAN_LIMIT8)
                    {
                        N_txcount++;
                    }
                    SetSndQueNMMsg();
                } /* Mޯ̧Ɋi[ްL̂ */

                /* RingMsg𑗐MɊi[xȯܰ肵Ă邩mF */
                if(N_NetSts.bit.StatusRingStable == CAN_ON)
                {
                    /* ȯܰ㎩ɰRingMsgMݸނRingMsgċ */
                    if(N_CtlSts.bit.cnt_ring == CAN_ON)
                    {
                        if(ChkRingNetStable() == CAN_E_NG)
                        {
                            N_NetSts.bit.StatusRingStable = CAN_OFF;
                            N_CtlSts.bit.cnt_ring = CAN_OFF;
                        } /* ȯܰšô */
                    }
                    else
                    {
                        N_CtlSts.bit.cnt_ring = CAN_ON;
                    }
                }
                CancelAlarm(CAN_NM_TTYP);
                CancelAlarm(CAN_NM_TMAX);
                SetAlarm(CAN_NM_TMAX);
            }
            else /* if(N_txcount > CAN_NM_TX_LIMIT) */
            {
                N_NMSts.sndstop = CAN_ON;
                ShiftNMLimpHomeMode();
            }
        } /* ɰނ̑MłȂꍇAȂ */
    }
    else /* if(m_drv_sts == CAN_E_DRV_BUSOFF) */
    {
        N_NMSts.sndstop = CAN_ON;
        N_NetSts.bit.StatusBusError = CAN_ON;
        ShiftNMLimpHomeMode();
    }
}

/*****************************************************************************/
/*  Function name : static void NMLimpHomeMode(void)                         */
/*---------------------------------------------------------------------------*/
/*  Description : NMLimpHome                                             */
/*                s^C~O: NMLimpHomeԎ                           */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void NMLimpHomeMode(void)
{
    /************ ĕϐ ************/
    UINT8 m_drv_sts = CAN_DRV_BUSOFF;
    UINT8 m_snd_sts = CAN_DRV_WAIT;  /* MԎ擾p */
    /************ ۸ ************/
    if(N_CtlSts.bit.rcv_comp == CAN_ON)
    {
        if(N_SndDataBuf.opcode.bit.sleepind == CAN_ON)
        {
            /* RingMsgMOɓɎMRingMsg͖ */
            if((N_CtlSts.bit.dis_ring == CAN_OFF)
            || (N_RcvDataBuf.opcode.bit.ring == CAN_OFF))
            {
                ChkRcvSlpMark();
            }
        }
    }
    FncGetBusoffStsDRV(&m_drv_sts);

    if(m_drv_sts == CAN_DRV_BUSOFF)
    {
        N_NMSts.sndstop = CAN_ON;
        N_NetSts.bit.StatusBusError = CAN_ON;
        CancelAlarm(CAN_NM_TERR);
        SetAlarm(CAN_NM_TERR);
        ShiftNMLimpHomeMode();
    }

    FncGetNMSndStsDRV(&m_snd_sts);
    if(m_snd_sts == CAN_DRV_COMP)
    {
        N_NMSts.sndstop = CAN_OFF;
        N_NetSts.bit.StatusBusError = CAN_OFF;
    }

    /* NMLimpHomeԂ̕A */
    /* NMүގMLimpHomeMsgM(Sleepݒ薳) */
    /* sleep.ack=OFFNMүގMLimpHomeMsgM(SleepݒL) */
    if(((N_NMSts.sndstop == CAN_OFF) && (N_SndDataBuf.opcode.bit.limphome == CAN_ON))
    && (((N_SndDataBuf.opcode.bit.sleepind == CAN_OFF) && (N_NMSts.rcvstop == CAN_OFF))
    || ((N_SndDataBuf.opcode.bit.sleepind == CAN_ON) && (N_NMSts.rcvstop == CAN_OFF) 
        && (N_RcvDataBuf.opcode.bit.sleepack == CAN_OFF))))
    {
        N_NetSts.bit.StatusLimpHome = CAN_OFF;
    }
    else if((N_TimeOut.bit.terr == CAN_ON)
         && (N_NetSts.bit.StatusWaitBusSleep == CAN_OFF))
    {
        NMSndQue.wr_ptr = (UINT8)CAN_CLR;
        NMSndQue.rd_ptr = (UINT8)(CAN_NM_NUM_SNDQUE - 1);

        if(N_SndDataBuf.opcode.bit.sleepind == CAN_ON)
        {
            N_NetSts.bit.StatusBusSleepInd = CAN_ON;
        }
        /* Mޯ̧ްi[ */
        if(SetSndBufNMMsg(CAN_LIMPHOMEMSG) == CAN_E_OK)
        {
            SetSndQueNMMsg();
        } /* Mޯ̧Ɋi[ްL̂ */
    }
    else
    {
        /* LimpHomeMsgMAA͉Ȃ */
    }
}

/*****************************************************************************/
/*  Function name : static void NMLimpHomePrepBusSleepMode(void)             */
/*---------------------------------------------------------------------------*/
/*  Description : NMLimpHomePrepBusSleep                                 */
/*                s^C~O:NMLimpHomePrepBusSleepԎ                */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void NMLimpHomePrepBusSleepMode(void)
{
    /************ ĕϐ ************/
    UINT8 m_drv_sts = CAN_DRV_BUSOFF;
    UINT8 m_snd_sts = CAN_DRV_WAIT;  /* MԎ擾p */
    
    /************ ۸ ************/
    if(N_CtlSts.bit.rcv_comp == CAN_ON)
    {
        if(N_SndDataBuf.opcode.bit.sleepind == CAN_ON)
        {
            /* RingMsgMOɓɎMRingMsg͖ */
            if((N_CtlSts.bit.dis_ring == CAN_OFF)
            || (N_RcvDataBuf.opcode.bit.ring == CAN_OFF))
            {
                ChkRcvSlpMark();
            }
        }
    }
    FncGetBusoffStsDRV(&m_drv_sts);
    if(m_drv_sts == CAN_DRV_BUSOFF)
    {
        N_NMSts.sndstop = CAN_ON;
        N_NetSts.bit.StatusBusError = CAN_ON;
        ShiftNMLimpHomeMode();
    }

    FncGetNMSndStsDRV(&m_snd_sts);
    if(m_snd_sts == CAN_DRV_COMP)
    {
        N_NMSts.sndstop = CAN_OFF;
        N_NetSts.bit.StatusBusError = CAN_OFF;
    }

    /* NMLimpHomeԂ̕A */
    /* NMүގMLimpHomeMsgM(Sleepݒ薳) */
    /* sleep.ack=OFFNMүގMLimpHomeMsgM(SleepݒL) */
    if(((N_NMSts.sndstop == CAN_OFF) && (N_SndDataBuf.opcode.bit.limphome == CAN_ON))
    && (((N_SndDataBuf.opcode.bit.sleepind == CAN_OFF) && (N_NMSts.rcvstop == CAN_OFF))
    || ((N_SndDataBuf.opcode.bit.sleepind == CAN_ON) && (N_NMSts.rcvstop == CAN_OFF) 
        && (N_RcvDataBuf.opcode.bit.sleepack == CAN_OFF))))
    {
        N_NetSts.bit.StatusLimpHome = CAN_OFF;
    }
    else if((N_TimeOut.bit.tmax == CAN_ON)
         && (N_NetSts.bit.StatusBusSleepInd == CAN_ON))
    {
        N_NetSts.bit.StatusBusSleepInd = CAN_OFF;
        N_NetSts.bit.StatusWaitBusSleep = CAN_ON;
    }
    else
    {
        /* Tmaxoߑ҂ */
    }
}

/*****************************************************************************/
/*  Function name : static void NMTwbsMode(void)                             */
/*---------------------------------------------------------------------------*/
/*  Description : NMTwbs                                                 */
/*                s^C~O:NMTwbsԎ                                */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void NMTwbsMode(void)
{
    /************ ۸ ************/
    if(N_CtlSts.bit.rcv_comp == CAN_ON)
    {
        if(N_SndDataBuf.opcode.bit.sleepind == CAN_ON)
        {
            /* RingMsgMOɓɎMRingMsg͖ */
            if((N_CtlSts.bit.dis_ring == CAN_OFF)
            || (N_RcvDataBuf.opcode.bit.ring == CAN_OFF))
            {
                ChkRcvSlpMark();
            }
        }
    }
    if(N_NetSts.bit.StatusWaitBusSleep == CAN_OFF)
    {
        /* ؂Sleep֎~ALimpHomeMsgȊO */
        /*                  sleep.ind=OFFNMүގM */
        if(N_NetSts.bit.StatusLimpHome == CAN_OFF)
        {
            StrWkupSeq();
        }
    }
    else if(N_TimeOut.bit.twbs == CAN_ON)
    {
        N_NetSts.byte = CAN_NM_SLP_NETSTS;
    }
    else
    {
        /* Twbs(1.5s)oߑ҂ */
    }
}

/*****************************************************************************/
/*  Function name : static void NMBusSleepMode(void)                         */
/*---------------------------------------------------------------------------*/
/*  Description : NMBusSleep                                             */
/*                s^C~O:NMBusSleepԎ                            */
/*                ӎF߂l`FbN̕Kv֐voidLXggp */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void NMBusSleepMode(void)
{
    /************ ۸ ************/
    if(((ChkAppSlpReq() == CAN_E_NG)
    || (N_CtlSts.bit.wkup_fct == CAN_ON))
    || ((N_CtlSts.bit.rcv_comp == CAN_ON) && (N_RcvDataBuf.opcode.bit.sleepind == CAN_OFF)))
    {
        (void)FncDisCANWkupInt();
        /* CAN۰ד */
        if(FncChgModCAN(CAN_DRV_CAN_RUN) == CAN_E_OK)
        {
            (void)FncEnCANRcvInt();
            (void)FncEnCANSndInt();
            (void)FncEnCANErrInt();
        }
        else/* if(ChgModCAN(CAN_DRV_CAN_RUN) == CAN_E_NG) */
        {
            (void)FncDisCANWkupInt();
            (void)FncDisCANRcvInt();
            (void)FncDisCANSndInt();
            (void)FncDisCANErrInt();
        }
        StrWkupSeq();
        N_NetSts.bit.StatusBusSleep = CAN_OFF;
    }
}

/*****************************************************************************/
/*  Function name : static void NMBusSleepMode(void)                         */
/*---------------------------------------------------------------------------*/
/*  Description : `Ԍo                                         */
/*                s^C~O: `Ԏ                               */
/*                ӎ: Sleep  :NMBusSleepԂ֑J           */
/*                          Sleep֎~  :NMInitԂ֑J               */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void NMOtherMode(void)
{
    /************ ۸ ************/
    InitIntrData();

    /* Sleep/֎~𔻒肵đJڂԂ肷 */
    if(ChkAppSlpReq() == CAN_E_OK)
    {
        N_NetSts.byte = CAN_NM_SLP_NETSTS;
    }
    else
    {
        /* Sleep֎~̏ꍇ͉Ȃ */
    }
}

/*****************************************************************************/
/*  Function name : static StatusType GoToNMInitMode(void)                   */
/*---------------------------------------------------------------------------*/
/*  Description : NMInitԈڍs                                         */
/*                s^C~O: NMOff,NMTwbsNormal,NMBusSleepԎ*/
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : StatusType  CAN_E_OK:ԑJڋ                            */
/*                          CAN_E_NG:ԑJڋ֎~                            */
/*****************************************************************************/
static StatusType GoToNMInitMode(void)
{
    /************ ĕϐ ************/
    StatusType m_result = CAN_E_NG;
    
    /************ ۸ ************/
    switch(N_ModeSts)
    {
        case(CAN_NMBusSleep):
        case(CAN_NMTwbs):
            if(N_CtlSts.bit.wkup_seq == CAN_ON)
            {
                m_result = CAN_E_OK;
            }
            break;

        case(CAN_NMOff):
            m_result = CAN_E_OK;
            break;

        default:
            /* NMInitԂֈڍsNMԂł͂Ȃ */
            break;
    }
    return m_result;
}

/*****************************************************************************/
/*  Function name : static StatusType GoToNMResetMode(void)                  */
/*---------------------------------------------------------------------------*/
/*  Description : NMResetԈڍs                                        */
/*                s^C~O: NMInit,NMNormal,NMLimpHome,    */
/*                                NMNormalPrepBusSleep,                  */
/*                                NMLimpHomePrepBusSleepԎ               */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : StatusType  CAN_E_OK:ԑJڋ                            */
/*                          CAN_E_NG:ԑJڋ֎~                            */
/*****************************************************************************/
static StatusType GoToNMResetMode(void)
{
    /************ ĕϐ ************/
    StatusType m_result = CAN_E_NG;
    
    /************ ۸ ************/
    switch(N_ModeSts)
    {
        case(CAN_NMNormal):
        case(CAN_NMNormalPrepBusSleep):
            if(N_TimeOut.bit.tmax == CAN_ON)
            {
                m_result = CAN_E_OK;
            }
            break;

        case(CAN_NMInit):
            m_result = CAN_E_OK;
            break;

        case(CAN_NMLimpHome):
        case(CAN_NMLimpHomePrepBusSleep):
            if(N_NetSts.bit.StatusLimpHome == CAN_OFF)
            {
                m_result = CAN_E_OK;
            }
            break;

        default:
            /* NMResetԂֈڍsNMԂł͂Ȃ */
            break;
    }
    return m_result;
}

/*****************************************************************************/
/*  Function name : static StatusType GoToNMNormalMode(void)                 */
/*---------------------------------------------------------------------------*/
/*  Description : NMNormalԈڍs                                       */
/*                s^C~O: NMReset,NMNormalPrepBusSleepԎ     */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : StatusType  CAN_E_OK:ԑJڋ                            */
/*                          CAN_E_NG:ԑJڋ֎~                            */
/*****************************************************************************/
static StatusType GoToNMNormalMode(void)
{
    /************ ĕϐ ************/
    StatusType m_result;

    /************ ۸ ************/
    m_result = CAN_E_OK;

    return m_result;
}

/*****************************************************************************/
/*  Function name : static StatusType GoToNMLimpHomeMode(void)               */
/*---------------------------------------------------------------------------*/
/*  Description : NMLimpHomeԈڍs                                     */
/*                s^C~O: NMReset,NMNormal,                  */
/*                                NMLimpHomePrepBusSleep,                */
/*                                NMTwbsLimpHomeԎ                       */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : StatusType  CAN_E_OK:ԑJڋ                            */
/*                          CAN_E_NG:ԑJڋ֎~                            */
/*****************************************************************************/
static StatusType GoToNMLimpHomeMode(void)
{
    /************ ĕϐ ************/
    StatusType m_result = CAN_E_NG;

    /************ ۸ ************/
    switch(N_ModeSts)
    {
        case(CAN_NMReset):
        case(CAN_NMNormal):
        case(CAN_NMNormalPrepBusSleep):
            if(N_NetSts.bit.StatusLimpHome == CAN_ON)
            {
                m_result = CAN_E_OK;
            }
            break;

        case(CAN_NMTwbs):
            if(N_NetSts.bit.StatusWaitBusSleep == CAN_OFF)
            {
                m_result = CAN_E_OK;
            }
            break;

        case(CAN_NMLimpHomePrepBusSleep):
            if(N_NetSts.bit.StatusBusSleepInd == CAN_OFF)
            {
                m_result = CAN_E_OK;
            }
            break;

        default:
            /* NMLimpHomeԂֈڍsNMԂł͂Ȃ */
            break;
    }
    return m_result;
}

/*****************************************************************************/
/*  Function name : static StatusType GoToNMPrepBusSleepMode(void)           */
/*---------------------------------------------------------------------------*/
/*  Description : NM(Normal,LimpHome)PrepBusSleepԈڍs                */
/*                s^C~O: NMNorma,NMLimpHomeԎ               */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : StatusType  CAN_E_OK:ԑJڋ                            */
/*                          CAN_E_NG:ԑJڋ֎~                            */
/*****************************************************************************/
static StatusType GoToNMPrepBusSleepMode(void)
{
    /************ ĕϐ ************/
    StatusType m_result = CAN_E_NG;

    /************ ۸ ************/
    if(N_NetSts.bit.StatusBusSleepInd == CAN_ON)
    {
        m_result = CAN_E_OK;
    }
    return m_result;
}

/*****************************************************************************/
/*  Function name : static StatusType GoToNMTwbsMode(void)                   */
/*---------------------------------------------------------------------------*/
/*  Description : NMTwbs(Normal,LimpHome)Ԉڍs                        */
/*                s^C~O: NMNormal,NMLimpHome,               */
/*                                NMNormalPrepBusSleep,                  */
/*                                NMLimpHomePrepBusSleepԎ               */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : StatusType  CAN_E_OK:ԑJڋ                            */
/*                          CAN_E_NG:ԑJڋ֎~                            */
/*****************************************************************************/
static StatusType GoToNMTwbsMode(void)
{
    /************ ĕϐ ************/
    StatusType m_result = CAN_E_NG;

    /************ ۸ ************/
    if(N_NetSts.bit.StatusWaitBusSleep == CAN_ON)
    {
        m_result = CAN_E_OK;
    }
    return m_result;
}

/*****************************************************************************/
/*  Function name : static StatusType GoToNMBusSleepMode(void)               */
/*---------------------------------------------------------------------------*/
/*  Description : NMBusSleepԈڍs                                     */
/*                s^C~O: NMOff,NMTwbsNormal,                */
/*                                NMTwbsLimpHomeԎ                       */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : StatusType  CAN_E_OK:ԑJڋ                            */
/*                          CAN_E_NG:ԑJڋ֎~                            */
/*****************************************************************************/
static StatusType GoToNMBusSleepMode(void)
{
    /************ ĕϐ ************/
    StatusType m_result = CAN_E_NG;

    /************ ۸ ************/
    if((N_NetSts.bit.StatusBusSleep == CAN_ON) && (N_CtlSts.bit.wkup_fct == CAN_OFF))
    {
        m_result = CAN_E_OK;
    }

    return m_result;
}

/*****************************************************************************/
/*  Function name : static void InitIntrData(void)                           */
/*---------------------------------------------------------------------------*/
/*  Description : ޯ؋N̏֐                                    */
/*                s^C~O: d                                 */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void InitIntrData(void)
{
    /************ ۸ ************/
    N_LogScs = CAN_ALL_MYSELF;

    InitNMDataBuf();
    InitNMQue();

    ClrTimeOut();
    CancelAlarm(CAN_NM_TALL);

    InitConfig(CAN_Normal);
    InitConfig(CAN_LimpHome);

    N_NMSts.sndstop = CAN_OFF;
    N_NMSts.rcvstop = CAN_OFF;
    N_NMSts.dummy = CAN_CLR;

    N_txcount = (UINT8)CAN_CLR;
    N_rxcount = (UINT8)CAN_CLR;

    InitLogRingNodeTbl();

    N_NetSts.byte = CAN_NM_INIT_NETSTS;
    N_COMSts.byte = CAN_NM_STP;
    N_CtlSts.byte = CAN_NM_INIT_PWRON;
}

/*****************************************************************************/
/*  Function name : static void InitLogRingNodeTbl(void)                     */
/*---------------------------------------------------------------------------*/
/*  Description : _ݸȯܰ\ðق̏                            */
/*                s^C~O: d                                 */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void InitLogRingNodeTbl(void)
{
    /************ ĕϐ ************/
    UINT8 lp_data;

    /************ ۸ ************/
    for(lp_data = 0;lp_data < CAN_ECU_NUM_NODE;lp_data++)
    {
        N_LogRingNodeTbl[lp_data] = (UINT8)CAN_CLR;
    }
    N_CntRcvRingMsg = (UINT8)CAN_CLR;
    N_CntRcvNumNode = (UINT8)CAN_CLR;
    N_CntLogRingNode = (UINT8)CAN_CLR;
}


/*****************************************************************************/
/*  Function name : static void InitNMDataBuf(void)                          */
/*---------------------------------------------------------------------------*/
/*  Description : NMMޯ̧̏                                      */
/*                s^C~O: d                                 */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void InitNMDataBuf(void)
{
    /************ ĕϐ ************/

    /************ ۸ ************/
    N_SndDataBuf.canid = CAN_NM_MY_CAN_ID;
    N_SndDataBuf.destid = (UINT8)CAN_CLR;

    N_SndDataBuf.opcode.byte = (UINT8)CAN_CLR;

    N_RcvDataBuf.canid = (UINT16)CAN_CLR;
    N_RcvDataBuf.destid = (UINT8)CAN_CLR;

    N_RcvDataBuf.opcode.byte = (UINT8)CAN_CLR;
}

/*****************************************************************************/
/*  Function name : static void InitNMQue(void)                              */
/*---------------------------------------------------------------------------*/
/*  Description : NMM̏                                        */
/*                s^C~O: d                                 */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void InitNMQue(void)
{
    /************ ĕϐ ************/
    UINT8       lp_que;
    UINT8       lp_data;

    /************ ۸ ************/
    /* M̏ */
    for(lp_que = 0;lp_que < CAN_NM_NUM_SNDQUE;lp_que++)
    {
        NMSndQue.msg[lp_que].can_id = (UINT16)CAN_CLR;
        NMSndQue.msg[lp_que].dlc = (UINT8)CAN_CLR;
        for(lp_data = 0;lp_data < CAN_NM_DLC_SIZE;lp_data++)
        {
            NMSndQue.msg[lp_que].data.byte[lp_data] = (UINT8)CAN_CLR;
        }
    }
    NMSndQue.wr_ptr = (UINT8)CAN_CLR;
    NMSndQue.rd_ptr = (UINT8)(CAN_NM_NUM_SNDQUE - 1);

    /* M̏ */
    for(lp_que = 0;lp_que < CAN_NM_NUM_RCVQUE;lp_que++)
    {
        NMRcvQue.msg[lp_que].can_id = (UINT16)CAN_CLR;
        NMRcvQue.msg[lp_que].dlc = (UINT8)CAN_CLR;
        for(lp_data = 0;lp_data < CAN_NM_DLC_SIZE;lp_data++)
        {
            NMRcvQue.msg[lp_que].data.byte[lp_data] = (UINT8)CAN_CLR;
        }
    }
    NMRcvQue.wr_ptr = (UINT8)CAN_CLR;
    NMRcvQue.rd_ptr = (UINT8)(CAN_NM_NUM_RCVQUE - 1);
}

/*****************************************************************************/
/*  Function name : static void SetAlarm(NMTimerType in_m_timer)             */
/*---------------------------------------------------------------------------*/
/*  Description : e϶ĊJn                                        */
/*                s^C~O: e϶ĊJn                            */
/*---------------------------------------------------------------------------*/
/*  parameter : NMTimerType CAN_NM_TTYP  :Ttyp϶ĊJn                    */
/*                          CAN_NM_TMAX  :Tmax϶ĊJn                    */
/*                          CAN_NM_TERR  :Terr϶ĊJn                    */
/*                          CAN_NM_TWBS  :Twbs϶ĊJn                    */
/*  result    : none                                                         */
/*****************************************************************************/
static void SetAlarm(NMTimerType in_m_timer)
{
    /************ ۸ ************/
    switch(in_m_timer)
    {
        case(CAN_NM_TTYP):
            N_CntTimer.bit.ttyp = CAN_ON;
            break;

        case(CAN_NM_TMAX):
            N_CntTimer.bit.tmax = CAN_ON;
            break;

        case(CAN_NM_TERR):
            N_CntTimer.bit.terr = CAN_ON;
            break;

        case(CAN_NM_TWBS):
            N_CntTimer.bit.twbs = CAN_ON;
            break;
        default:
            N_CntTwbs = (UINT16)CAN_CLR;
            N_CntTerr = (UINT16)CAN_CLR;
            N_CntTmax = (UINT16)CAN_CLR;
            N_CntTtyp = (UINT8)CAN_CLR;
            
            N_CntTimer.byte = (UINT8)CAN_CLR;
            break;
    }
}

/*****************************************************************************/
/*  Function name : static void CancelAlarm(NMTimerType in_m_timer)          */
/*---------------------------------------------------------------------------*/
/*  Description : e϶Ē~                                        */
/*                s^C~O: e϶Ē~                            */
/*---------------------------------------------------------------------------*/
/*  parameter : NMTimerType CAN_NM_TTYP  :Ttyp϶Ē~                    */
/*                          CAN_NM_TMAX  :Tmax϶Ē~                    */
/*                          CAN_NM_TERR  :Terr϶Ē~                    */
/*                          CAN_NM_TWBS  :Twbs϶Ē~                    */
/*                          CAN_NM_TALL  :S϶Ē~(default)             */
/*  result    : none                                                         */
/*****************************************************************************/
static void CancelAlarm(NMTimerType in_m_timer)
{
    /************ ۸ ************/
    switch(in_m_timer)
    {
        case(CAN_NM_TTYP):
            N_CntTtyp = (UINT8)CAN_CLR;
            N_CntTimer.bit.ttyp = CAN_OFF;
            break;

        case(CAN_NM_TMAX):
            N_CntTmax = (UINT16)CAN_CLR;
            N_CntTimer.bit.tmax = CAN_OFF;
            break;

        case(CAN_NM_TERR):
            N_CntTerr = (UINT16)CAN_CLR;
            N_CntTimer.bit.terr = CAN_OFF;
            break;

        case(CAN_NM_TWBS):
            N_CntTwbs = (UINT16)CAN_CLR;
            N_CntTimer.bit.twbs = CAN_OFF;
            break;

        case(CAN_NM_TALL):
        default:
            N_CntTwbs = (UINT16)CAN_CLR;
            N_CntTerr = (UINT16)CAN_CLR;
            N_CntTmax = (UINT16)CAN_CLR;
            N_CntTtyp = (UINT8)CAN_CLR;
        
            N_CntTimer.byte = (UINT8)CAN_CLR;
            break;
    }
}

/*****************************************************************************/
/*  Function name : static void SetTimeOutTtyp(void)                         */
/*---------------------------------------------------------------------------*/
/*  Description : Ttyp϶Ē~                                        */
/*                s^C~O: TtypѱĎ                               */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void SetTimeOutTtyp(void)
{
    /************ ۸ ************/
    N_TimeOut.bit.ttyp = CAN_ON;
}

/*****************************************************************************/
/*  Function name : static void SetTimeOutTmax(void)                         */
/*---------------------------------------------------------------------------*/
/*  Description : Tmax϶Ē~                                        */
/*                s^C~O: TmaxѱĎ                               */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void SetTimeOutTmax(void)
{
    /************ ۸ ************/
    N_TimeOut.bit.tmax = CAN_ON;
}

/*****************************************************************************/
/*  Function name : static void SetTimeOutTerr(void)                         */
/*---------------------------------------------------------------------------*/
/*  Description : Terr϶Ē~                                        */
/*                s^C~O: TerrѱĎ                               */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void SetTimeOutTerr(void)
{
    /************ ۸ ************/
    N_TimeOut.bit.terr = CAN_ON;
}

/*****************************************************************************/
/*  Function name : static void SetTimeOutTwbs(void)                         */
/*---------------------------------------------------------------------------*/
/*  Description : Twbs϶Ē~                                        */
/*                s^C~O: TwbsѱĎ                               */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void SetTimeOutTwbs(void)
{
    /************ ۸ ************/
    N_TimeOut.bit.twbs = CAN_ON;
}

/*****************************************************************************/
/*  Function name : static void ClrTimeOut(void)                             */
/*---------------------------------------------------------------------------*/
/*  Description : eѱĸر                                         */
/*                s^C~O: C                                 */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void ClrTimeOut(void)
{
    /************ ۸ ************/
    N_TimeOut.byte = (UINT8)CAN_CLR;
}

/*****************************************************************************/
/*  Function name : static void RunTimer(void)                               */
/*---------------------------------------------------------------------------*/
/*  Description : e϶ď                                            */
/*                s^C~O: C                                 */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void RunTimer(void)
{
    /************ ۸ ************/
    
    if(N_CntTimer.bit.ttyp == CAN_ON)
    {
        TimerTtyp();
    }
    else if(N_CntTimer.bit.tmax == CAN_ON)
    {
        TimerTmax();
    }
    else if(N_CntTimer.bit.terr == CAN_ON)
    {
        TimerTerr();
    }
    else if(N_CntTimer.bit.twbs == CAN_ON)
    {
        TimerTwbs();
    }
    else
    {
         /* OSEKKϖgp̏͂Ȃ */
    }
}

/*****************************************************************************/
/*  Function name : static void TimerTtyp(void)                              */
/*---------------------------------------------------------------------------*/
/*  Description : Ttypď                                               */
/*                s^C~O: C                                 */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void TimerTtyp(void)
{
    /************ ۸ ************/
    if(N_CntTimer.bit.ttyp == CAN_ON)
    {
        N_CntTtyp++;
        if(N_CntTtyp >= (CAN_NM_TTYP_LIMIT / CAN_NM_MAIN_CYCLE))
        {
            SetTimeOutTtyp();
            N_CntTtyp = (UINT8)CAN_CLR;
        }
    }
    else
    {
        N_CntTtyp = (UINT8)CAN_CLR;
    }
}

/*****************************************************************************/
/*  Function name : static void TimerTmax(void)                              */
/*---------------------------------------------------------------------------*/
/*  Description : Tmaxď                                               */
/*                s^C~O: C                                 */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void TimerTmax(void)
{
    /************ ۸ ************/
    if(N_CntTimer.bit.tmax == CAN_ON)
    {
        N_CntTmax++;
        if(N_CntTmax >= (CAN_NM_TMAX_LIMIT / CAN_NM_MAIN_CYCLE))
        {
            SetTimeOutTmax();
            N_CntTmax = (UINT16)CAN_CLR;
        }
    }
    else
    {
        N_CntTmax = (UINT16)CAN_CLR;
    }
}

/*****************************************************************************/
/*  Function name : static void TimerTerr(void)                              */
/*---------------------------------------------------------------------------*/
/*  Description : Terrorď                                             */
/*                s^C~O: C                                 */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void TimerTerr(void)
{
    /************ ۸ ************/
    if(N_CntTimer.bit.terr == CAN_ON)
    {
        N_CntTerr++;
        if(N_CntTerr >= (CAN_NM_TERR_LIMIT / CAN_NM_MAIN_CYCLE))
        {
            SetTimeOutTerr();
            N_CntTerr = (UINT16)CAN_CLR;
        }
    }
    else
    {
        N_CntTerr = (UINT16)CAN_CLR;
    }
}

/*****************************************************************************/
/*  Function name : static void TimerTwbs(void)                              */
/*---------------------------------------------------------------------------*/
/*  Description : TwaitBusSleepď                                      */
/*                s^C~O: C                                 */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void TimerTwbs(void)
{
    /************ ۸ ************/
    if(N_CntTimer.bit.twbs == CAN_ON)
    {
        N_CntTwbs++;
        if(N_CntTwbs >= (CAN_NM_TWBS_LIMIT / CAN_NM_MAIN_CYCLE))
        {
            SetTimeOutTwbs();
            N_CntTwbs = (UINT16)CAN_CLR;
        }
    }
    else
    {
        N_CntTwbs = (UINT16)CAN_CLR;
    }
}

/*****************************************************************************/
/*  Function name : static StatusType ChkAppSlpReq(void)                     */
/*---------------------------------------------------------------------------*/
/*  Description : ؂SleepݒLE                      */
/*                s^C~O: C                                 */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : StatusType  CAN_E_OK:SleepݒL                       */
/*                          CAN_E_NG:Sleepݒ薳                       */
/*****************************************************************************/
static StatusType ChkAppSlpReq(void)
{
    /************ ĕϐ ************/
    StatusType m_result = CAN_E_NG;

    /************ ۸ ************/
    if(N_ECUSts.req_slp == CAN_ON)
    {
        m_result = CAN_E_OK;
    }

    return m_result;
}

/*****************************************************************************/
/*  Function name : static void ShiftNMLimpHomeMode(void)                    */
/*---------------------------------------------------------------------------*/
/*  Description : NMLimpHomeԂւ̑J                                     */
/*                s^C~O: NMLimpHomeԈڍs                       */
/*                ӎF߂l`FbN̕Kv֐voidLXggp */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void ShiftNMLimpHomeMode(void)
{
    /************ ۸ ************/
    NMSndQue.wr_ptr = (UINT8)CAN_CLR;
    NMSndQue.rd_ptr = (UINT8)(CAN_NM_NUM_SNDQUE - 1);
    N_NMSts.sndstop = CAN_ON;
    N_NMSts.rcvstop = CAN_ON;

    if(N_NetSts.bit.StatusBusError == CAN_ON)
    {
        (void)FncDisCANWkupInt();
        (void)FncChgModCAN(CAN_DRV_CAN_RESET);
        /* CAN۰ׂ̍쓮 */
        if(FncChgModCAN(CAN_DRV_CAN_RUN) == CAN_E_OK)
        {
            (void)FncEnCANRcvInt();
            (void)FncEnCANSndInt();
            (void)FncEnCANErrInt();
        }
        else/* if(ChgModCAN(CAN_DRV_CAN_RUN) == CAN_E_NG) */
        {
            (void)FncDisCANWkupInt();
            (void)FncDisCANRcvInt();
            (void)FncDisCANSndInt();
            (void)FncDisCANErrInt();
        }
    }
    else
    {
        FncAbtNMSndMsgDRV();
    }
    N_NetSts.bit.StatusLimpHome = CAN_ON;
    N_NetSts.bit.StatusRingStable = CAN_OFF;

    N_CtlSts.bit.dis_ring = CAN_OFF;
    N_CtlSts.bit.cnt_ring = CAN_OFF;
}

/*****************************************************************************/
/*  Function name : static void ShiftNMBusSleepMode(void)                    */
/*---------------------------------------------------------------------------*/
/*  Description : NMBusSleepԑJڏ                                     */
/*                s^C~O: NMBusSleepԈڍs                       */
/*                ӎF߂l`FbN̕Kv֐voidLXggp */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void ShiftNMBusSleepMode(void)
{
    /************ ۸ ************/
    (void)FncDisCANRcvInt();
    (void)FncDisCANSndInt();
    (void)FncDisCANErrInt();
    (void)FncChgModCAN(CAN_DRV_CAN_SLEEP);
    (void)FncEnCANWkupInt();

    N_NMSts.sndstop = CAN_OFF;
    N_NMSts.rcvstop = CAN_OFF;
    N_NMSts.dummy = CAN_CLR;
}

/*****************************************************************************/
/*  Function name : static void StrWkupSeq(void)                             */
/*---------------------------------------------------------------------------*/
/*  Description : WakeUpݽJn                                        */
/*                s^C~O: NMTwbsNormalSleepڍsݽ       */
/*                                NMBusSleepWakeUpv             */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void StrWkupSeq(void)
{
    /************ ۸ ************/
    N_LogScs = CAN_ALL_MYSELF;

    NMSndQue.wr_ptr = (UINT8)CAN_CLR;
    NMSndQue.rd_ptr = (UINT8)(CAN_NM_NUM_SNDQUE - 1);

    N_CtlSts.bit.wkup_seq = CAN_ON;
}

/*****************************************************************************/
/*  Function name : static void GetRcvDataNMQue(void)                        */
/*---------------------------------------------------------------------------*/
/*  Description : MүނMǂݏo                            */
/*                s^C~O: C                                 */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void GetRcvDataNMQue(void)
{
    /************ ĕϐ ************/
    UINT8 lp_que;
    UINT8 m_rd_ptr = NMRcvQue.rd_ptr;
    NMModeStsType m_mode_buf = N_ModeSts;  /* ԑJڔpޯ̧ */
    UINT8 m_snd_sts = CAN_DRV_WAIT;        /* MԎ擾p      */
    
    /************ ۸ ************/
    for(lp_que = 0; lp_que < CAN_NM_NUM_RCVQUE; lp_que++)
    {
        m_rd_ptr = NMRcvQue.rd_ptr;
        m_rd_ptr++;
        if(m_rd_ptr >= CAN_NM_NUM_RCVQUE)
        {
            m_rd_ptr = (UINT8)CAN_CLR;
        }
        if((NMRcvQue.wr_ptr == m_rd_ptr) || (m_mode_buf != N_ModeSts))
        {
            /* MႵ͏ԑJڔ */
            if(lp_que != 0)
            {
                FncGetNMSndStsDRV(&m_snd_sts);
                if(m_snd_sts == CAN_DRV_COMP)
                {
                    N_CtlSts.bit.dis_ring = CAN_OFF;
                }
                break;
            }
        }
        else
        {
            /* Mޯ̧Ɋi[łް */
            if(((NMRcvQue.msg[m_rd_ptr].dlc <= CAN_NM_DLC_MAX) 
                            && (NMRcvQue.msg[m_rd_ptr].dlc >= CAN_NM_DLC_MIN))
             && (((NMRcvQue.msg[m_rd_ptr].data.byte[CAN_NM_OPCODE]
                                               & CAN_M_OPCODE) == CAN_ALIVEMSG)
             || ((NMRcvQue.msg[m_rd_ptr].data.byte[CAN_NM_OPCODE]
                                                & CAN_M_OPCODE) == CAN_RINGMSG)
             || ((NMRcvQue.msg[m_rd_ptr].data.byte[CAN_NM_OPCODE]
                                            & CAN_M_OPCODE) == CAN_LIMPHOMEMSG)))
            {

                /* MްOpCode */
                if((NMRcvQue.msg[m_rd_ptr].can_id & CAN_NM_SOURCE_ID_MASK)
                                                             == CAN_ALL_MYSELF)
                {
                    if((NMRcvQue.msg[m_rd_ptr].data.byte[CAN_NM_OPCODE]
                                               & CAN_M_OPCODE) == CAN_RINGMSG)
                    {
                        N_CtlSts.bit.dis_ring = CAN_OFF;
                        /* RingMsgM̂Ttyp~ATmaxض */
                        if((N_ModeSts == CAN_NMNormal)
                        || (N_ModeSts == CAN_NMNormalPrepBusSleep))
                        {
                            CancelAlarm(CAN_NM_TTYP);
                            CancelAlarm(CAN_NM_TMAX);
                            SetAlarm(CAN_NM_TMAX);
                        }
                    }
                }
                else
                {
                    N_RcvDataBuf.canid = NMRcvQue.msg[m_rd_ptr].can_id;
                    N_RcvDataBuf.destid = NMRcvQue.msg[m_rd_ptr].data.byte[0];
                    N_RcvDataBuf.opcode.byte = NMRcvQue.msg[m_rd_ptr].data.byte[1];
                    N_CtlSts.bit.rcv_comp = CAN_ON;
                    N_NMSts.rcvstop = CAN_OFF;

                }
            }
            NMRcvQue.rd_ptr = m_rd_ptr;
        }

        /* Sleep/֎~ */
        if(ChkAppSlpReq() == CAN_E_OK)
        {
            N_SndDataBuf.opcode.bit.sleepind = CAN_ON;
        }
        else
        {
            N_SndDataBuf.opcode.bit.sleepind = CAN_OFF;
            N_SndDataBuf.opcode.bit.sleepack = CAN_OFF;

            N_NetSts.bit.StatusBusSleepInd = CAN_OFF;
            N_NetSts.bit.StatusWaitBusSleep = CAN_OFF;
        }
        TrnsNMMode();
    }
}

/*****************************************************************************/
/*  Function name : static void ChkRcvNMMsg(void)                            */
/*---------------------------------------------------------------------------*/
/*  Description : Mүނ̎ޖ̏                                   */
/*                s^C~O: NMNormal,NMNormalPrepBusSleepԎ    */
/*                ӎF߂l`FbN̕Kv֐voidLXggp */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*---------------------------------------------------------------------------*/
/*  Note : \()̓q(lXeBO)15𒴂Ă邽߁A          */
/*         vWFNg֗pۂ́Aĕ]Kv                        */
/*****************************************************************************/
static void ChkRcvNMMsg(void)
{
    /************ ĕϐ ************/
    UINT8 m_source_id;
    
    /************ ۸ ************/
    m_source_id = (UINT8)(N_RcvDataBuf.canid & CAN_NM_SOURCE_ID_MASK);

    if(N_RcvDataBuf.opcode.bit.limphome == CAN_ON)
    {
        (void)SetConfig(CAN_LimpHome, m_source_id);
    }
    else if(N_RcvDataBuf.opcode.bit.alive == CAN_ON)
    {
        SetLogScs();
        (void)SetConfig(CAN_Normal, m_source_id);
        N_NetSts.bit.StatusRingStable = CAN_OFF;
        (void)BldLogRingNet();
    }
    else if(N_RcvDataBuf.opcode.bit.ring == CAN_ON)
    {
        SetLogScs();
        (void)SetConfig(CAN_Normal, m_source_id);
        /* OSEK-RingMsgM΍ */
        if(N_CtlSts.bit.dis_ring == CAN_OFF)
        {
            if(N_NetSts.bit.StatusRingStable == CAN_ON)
            {
                /* ȯܰ肩RingMsgċ */
                if(N_CtlSts.bit.cnt_ring == CAN_ON)
                {
                    N_CntRcvRingMsg++;
                    if(N_CntRcvRingMsg > CAN_ECU_NUM_NODE)
                    {
                        N_CntRcvRingMsg = (UINT8)CAN_CLR;
                        N_NetSts.bit.StatusRingStable = CAN_OFF;
                        N_CtlSts.bit.cnt_ring = CAN_OFF;
                    }
                }
            }
            else
            {
                N_CntRcvRingMsg = (UINT8)CAN_CLR;
                if(BldLogRingNet() == CAN_E_OK)
                {
                    N_NetSts.bit.StatusRingStable = CAN_ON;
                } /* ȯܰ̔̂ */
            }
            CancelAlarm(CAN_NM_TTYP);
            CancelAlarm(CAN_NM_TMAX);

            if(N_RcvDataBuf.destid == CAN_ALL_MYSELF)
            {
                SetAlarm(CAN_NM_TTYP);
                /* sleep.ind */
                if((N_NetSts.bit.StatusBusSleepInd == CAN_ON)
                && (N_RcvDataBuf.opcode.bit.sleepind == CAN_ON))
                {
                    N_SndDataBuf.opcode.bit.sleepack = CAN_ON;
                }
            }
            else if(N_RcvDataBuf.destid == m_source_id)
            {
                SetAlarm(CAN_NM_TTYP);
            }
            else
            {
                SetAlarm(CAN_NM_TMAX);
                /* ɰ޽ߌo */
                if(SkipOwnNode() == CAN_E_NG)
                {
                    N_NetSts.bit.StatusRingStable = CAN_OFF;
                    N_CtlSts.bit.cnt_ring = CAN_OFF;

                    if(N_txcount <= CAN_NM_TX_LIMIT)
                    {
                        /* Mޯ̧ްi[ */
                        if(SetSndBufNMMsg(CAN_ALIVEMSG) == CAN_E_OK)
                        {
                            if(N_txcount < CAN_LIMIT8)
                            {
                                N_txcount++;
                            }
                            SetSndQueNMMsg();
                        } /* Mޯ̧Ɋi[ްL̂ */
                    }
                    else /* if(N_txcount > CAN_NM_TX_LIMIT) */
                    {
                        N_NMSts.sndstop = CAN_ON;
                        ShiftNMLimpHomeMode();
                    }
                } /* ɰ޽ߖo͉Ȃ */
            }
        } /* RingMsg͉Ȃ */
    }
    else
    {
        
    }
}

/*****************************************************************************/
/*  Function name : static void ChkRcvSlpMark(void)                          */
/*---------------------------------------------------------------------------*/
/*  Description : MүނSleep/֎~                             */
/*                s^C~O: NMүގMSleepݒL        */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void ChkRcvSlpMark(void)
{
    /************ ۸ ************/
    if(N_RcvDataBuf.opcode.bit.sleepind == CAN_OFF)
    {
        if(N_RcvDataBuf.opcode.bit.sleepack == CAN_OFF)
        {
            N_SndDataBuf.opcode.bit.sleepack = CAN_OFF;

            N_NetSts.bit.StatusWaitBusSleep = CAN_OFF;
            N_NetSts.bit.StatusBusSleepInd = CAN_OFF;
        }
        else
        {
            if(N_NetSts.bit.StatusWaitBusSleep == CAN_ON)
            {
                N_SndDataBuf.opcode.bit.sleepack = CAN_OFF;

                N_NetSts.bit.StatusWaitBusSleep = CAN_OFF;
                N_NetSts.bit.StatusBusSleepInd = CAN_OFF;
            }
            else
            {
                if((N_NetSts.bit.StatusLimpHome == CAN_ON)
                || (N_RcvDataBuf.opcode.bit.ring == CAN_ON))
                {
                    N_NetSts.bit.StatusBusSleepInd = CAN_OFF;
                    N_NetSts.bit.StatusWaitBusSleep = CAN_ON;
                    N_NetSts.bit.StatusRingStable = CAN_OFF;
                    N_CtlSts.bit.cnt_ring = CAN_OFF;
                }
            }
        }
    }
    else if(N_RcvDataBuf.opcode.bit.sleepack == CAN_ON)
    {
        if((N_NetSts.bit.StatusLimpHome == CAN_ON)
        || (N_RcvDataBuf.opcode.bit.ring == CAN_ON))
        {
            N_NetSts.bit.StatusBusSleepInd = CAN_OFF;
            N_NetSts.bit.StatusWaitBusSleep = CAN_ON;
            N_NetSts.bit.StatusRingStable = CAN_OFF;
            N_CtlSts.bit.cnt_ring = CAN_OFF;
        }
    }
    else
    {
        /* sleep.ind=ON/sleep.ack=OFFM͉Ȃ */
        /*    (NMNormalԎ̹ChkRcvNMMsg()Ŏ{) */
    }
}

/*****************************************************************************/
/*  Function name : static StatusType SetSndBufNMMsg(UINT8 in_m_snd_msg)     */
/*---------------------------------------------------------------------------*/
/*  Description : Mүނ𑗐Mޯ̧Ɋi[                            */
/*                s^C~O: M                                     */
/*---------------------------------------------------------------------------*/
/*  parameter : UINT8 in_m_snd_msg                                           */
/*  result    : StatusType  CAN_E_OK:i[                                */
/*                          CAN_E_NG:үނ̎                      */
/*****************************************************************************/
static StatusType SetSndBufNMMsg(UINT8 in_m_snd_msg)
{
    /************ ĕϐ ************/
    StatusType m_result = CAN_E_OK;

    /************ ۸ ************/
    /* Mүނ̎ނI */
    switch(in_m_snd_msg)
    {
        case(CAN_RINGMSG):
            N_SndDataBuf.opcode.bit.alive = CAN_OFF;
            N_SndDataBuf.opcode.bit.ring = CAN_ON;
            N_SndDataBuf.opcode.bit.limphome = CAN_OFF;
            break;

        case(CAN_ALIVEMSG):
            N_SndDataBuf.opcode.bit.alive = CAN_ON;
            N_SndDataBuf.opcode.bit.ring = CAN_OFF;
            N_SndDataBuf.opcode.bit.limphome = CAN_OFF;
            break;

        case(CAN_LIMPHOMEMSG):
            N_SndDataBuf.opcode.bit.alive = CAN_OFF;
            N_SndDataBuf.opcode.bit.ring = CAN_OFF;
            N_SndDataBuf.opcode.bit.limphome = CAN_ON;
            break;

        default:
            m_result = CAN_E_NG;
            break;
    }

    if(m_result == CAN_E_OK)
    {
        N_SndDataBuf.canid = CAN_NM_MY_CAN_ID;
        N_SndDataBuf.destid = N_LogScs;
    }
    return m_result;
}

/*****************************************************************************/
/*  Function name : static void SetSndQueNMMsg(void)                         */
/*---------------------------------------------------------------------------*/
/*  Description : Mүނ𑗐MɊi[                              */
/*                s^C~O: NMүޑM                             */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void SetSndQueNMMsg(void)
{
    /************ ۸ ************/
    if(NMSndQue.wr_ptr != NMSndQue.rd_ptr)      /* M̋󔻒 */
    {
        NMSndQue.msg[NMSndQue.wr_ptr].can_id = N_SndDataBuf.canid;
        NMSndQue.msg[NMSndQue.wr_ptr].dlc = CAN_NM_NUM_DLC;
        NMSndQue.msg[NMSndQue.wr_ptr].data.byte[0] = N_SndDataBuf.destid;
        NMSndQue.msg[NMSndQue.wr_ptr].data.byte[1] = N_SndDataBuf.opcode.byte;
        NMSndQue.msg[NMSndQue.wr_ptr].data.byte[2] = (UINT8)CAN_CLR;
        NMSndQue.msg[NMSndQue.wr_ptr].data.byte[3] = (UINT8)CAN_CLR;
        NMSndQue.msg[NMSndQue.wr_ptr].data.byte[4] = (UINT8)CAN_CLR;
        NMSndQue.msg[NMSndQue.wr_ptr].data.byte[5] = (UINT8)CAN_CLR;
        NMSndQue.msg[NMSndQue.wr_ptr].data.byte[6] = (UINT8)CAN_CLR;
        NMSndQue.msg[NMSndQue.wr_ptr].data.byte[7] = (UINT8)CAN_CLR;

        NMSndQue.wr_ptr++;
        if(NMSndQue.wr_ptr >= CAN_NM_NUM_SNDQUE)
        {
            NMSndQue.wr_ptr = (UINT8)CAN_CLR;
        }
    } /* Mt̏ꍇMޯ̧̓ej */
}

/*****************************************************************************/
/*  Function name : static void SetDRVNMMsg(void)                            */
/*---------------------------------------------------------------------------*/
/*  Description : MްDRVɓn                                   */
/*                s^C~O: C                                 */
/*                ӎ: ǐ̂ϼޯްgp                     */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void SetDRVNMMsg(void)
{
    /************ ĕϐ ************/
    UINT8   m_sndsts = CAN_DRV_WAIT;
    UINT8 m_rd_ptr = NMSndQue.rd_ptr;

    /************ ۸ ************/
    m_rd_ptr++;
    if(m_rd_ptr >= CAN_NM_NUM_SNDQUE)
    {
        m_rd_ptr = (UINT8)CAN_CLR;
    }

    if(NMSndQue.wr_ptr != m_rd_ptr)
    {
        FncGetNMSndStsDRV(&m_sndsts);
        if((m_sndsts == CAN_DRV_COMP) || (m_sndsts == CAN_DRV_EMPTY))
        {
            if(FncWrNMMsgDRV((UINT32)(NMSndQue.msg[m_rd_ptr].can_id), NMSndQue.msg[m_rd_ptr].dlc, 
                           NMSndQue.msg[m_rd_ptr].data.byte) == CAN_E_OK)
            {
                N_SndMsg.can_id = NMSndQue.msg[m_rd_ptr].can_id;
                N_SndMsg.dlc = NMSndQue.msg[m_rd_ptr].dlc;
                N_SndMsg.data.word[0] = NMSndQue.msg[m_rd_ptr].data.word[0];
                N_SndMsg.data.word[1] = NMSndQue.msg[m_rd_ptr].data.word[1];
                N_SndMsg.data.word[2] = NMSndQue.msg[m_rd_ptr].data.word[2];
                N_SndMsg.data.word[3] = NMSndQue.msg[m_rd_ptr].data.word[3];

                /* MvI */
                if(N_SndDataBuf.opcode.bit.ring == CAN_ON)
                {
                    N_CtlSts.bit.dis_ring = CAN_ON;
                }
                NMSndQue.rd_ptr = m_rd_ptr;
            }
        }
        else
        {
            /* M̏ꍇAȂ */
        }
    }
}

/*****************************************************************************/
/*  Function name : static void SetLogScs(void)                              */
/*---------------------------------------------------------------------------*/
/*  Description : Mүނɘ_̔s                       */
/*                s^C~O: AliveMsg,RingMsgM                     */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
static void SetLogScs(void)
{
    /************ ĕϐ ************/
    UINT8 m_source_id;
    
    /************ ۸ ************/
    m_source_id = (UINT8)(N_RcvDataBuf.canid & CAN_NM_SOURCE_ID_MASK);
    

    if(N_LogScs == CAN_ALL_MYSELF)
    {
        N_LogScs = m_source_id;
    }
    else
    {
        if(N_LogScs < CAN_ALL_MYSELF)
        {
            if(m_source_id < N_LogScs)
            {
                N_LogScs = m_source_id;
            }
            else if(m_source_id > CAN_ALL_MYSELF)
            {
                N_LogScs = m_source_id;
            }
            else
            {
                /* ̏𖞂ȂꍇA_͍XVȂ */
            }
        }
        else if((m_source_id < N_LogScs)
             && (m_source_id > CAN_ALL_MYSELF))
        {
                N_LogScs = m_source_id;
        }
        else
        {
            /* ̏𖞂ȂꍇA_͍XVȂ */
        }
    }
}

/*****************************************************************************/
/*  Function name : static StatusType SkipOwnNode(void)                      */
/*---------------------------------------------------------------------------*/
/*  Description : RingMsgMɎɰ޽ߌos                       */
/*                s^C~O: NMNormal                                 */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : StatusType  CAN_E_OK:ɰ޽߂Ȃ                         */
/*                          CAN_E_NG:ɰ޽߂                         */
/*****************************************************************************/
static StatusType SkipOwnNode(void)
{
    /************ ĕϐ ************/
    StatusType m_result = CAN_E_NG;
    UINT8 m_source_id;
    
    /************ ۸ ************/
    m_source_id = (UINT8)(N_RcvDataBuf.canid & CAN_NM_SOURCE_ID_MASK);
    
    if(N_RcvDataBuf.destid < CAN_ALL_MYSELF)
    {
        if((m_source_id > N_RcvDataBuf.destid)
        && (m_source_id < CAN_ALL_MYSELF))
        {
            m_result = CAN_E_NG;
        }
        else
        {
            m_result = CAN_E_OK;
        }
    }
    else if(N_RcvDataBuf.destid > CAN_ALL_MYSELF)
    {
        if((m_source_id < N_RcvDataBuf.destid)
        && (m_source_id > CAN_ALL_MYSELF))
        {
            m_result = CAN_E_OK;
        }
        else
        {
            m_result = CAN_E_NG;
        }
    }
    else
    {
        m_result = CAN_E_OK;
    }

    return m_result;
}

/*****************************************************************************/
/*  Function name : static StatusType ChkRingNetStable(void)                 */
/*---------------------------------------------------------------------------*/
/*  Description : _ݸȯܰ̈/smF                            */
/*                s^C~O: NMNormal                                 */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : StatusType  CAN_E_OK:_ݸȯ͈ܰ                    */
/*                          CAN_E_NG:_ݸȯ͕ܰs                  */
/*****************************************************************************/
static StatusType ChkRingNetStable(void)
{
    /************ ĕϐ ************/
    StatusType m_result = CAN_E_NG;

    /************ ۸ ************/
    /* _ݸȯܰ莞ɖo^IDRingMsgMꂽꍇ */
    /*                         ɰRingMsgMɕsƔ */
    if(N_CntRcvRingMsg == N_CntLogRingNode)
    {
        m_result = CAN_E_OK;
    }
    else
    {
        N_CntLogRingNode = (UINT8)CAN_CLR;
        m_result = CAN_E_NG;
    }
    N_CntRcvRingMsg = (UINT8)CAN_CLR;

    return m_result;
}

/*****************************************************************************/
/*  Function name : static StatusType BldLogRingNet(void)                    */
/*---------------------------------------------------------------------------*/
/*  Description : _ݸȯܰ̍\z󋵊mF                               */
/*                s^C~O: AliveMsg,RingMsgM                     */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : StatusType  CAN_E_OK:_ݸȯ͈ܰ                    */
/*                          CAN_E_NG:_ݸȯ͕ܰs                  */
/*****************************************************************************/
static StatusType BldLogRingNet(void)
{
    /************ ĕϐ ************/
    StatusType m_result = CAN_E_NG;
    UINT8   lp_chk;
    UINT8 m_source_id;
    
    /************ ۸ ************/
    m_source_id = (UINT8)(N_RcvDataBuf.canid & CAN_NM_SOURCE_ID_MASK);
    
    /* _ݸȯܰsȂ̂Ř_ݸލ\ðقXV */
    for(lp_chk = 0;lp_chk < N_CntLogRingNode;lp_chk++)
    {
        if(N_LogRingNodeTbl[lp_chk] == m_source_id)
        {
            m_result = CAN_E_OK;
            break;
        }
    }
    if(m_result == CAN_E_OK)
    {
        N_CntRcvNumNode++;
        if(N_CntRcvNumNode == N_CntLogRingNode)
        {
            N_CntRcvNumNode = (UINT8)CAN_CLR;
        }
        else
        {
            m_result = CAN_E_NG;
        }
    }
    else
    {
        N_LogRingNodeTbl[N_CntLogRingNode] = m_source_id;
        N_CntLogRingNode++;
        if(N_CntLogRingNode >= CAN_ECU_NUM_NODE)
        {
            N_CntLogRingNode = (UINT8)CAN_CLR;
            m_result = CAN_E_NG;
        }
    }
    return m_result;
}

/*****************************************************************************/
/*  Function name : void FncAfterSlpNM(void)                                 */
/*---------------------------------------------------------------------------*/
/*  Description : Wakeup֐                                             */
/*                s^C~O: WakeUp                       */
/*                ӎF߂l`FbN̕Kv֐voidLXggp */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
void FncAfterSlpNM(void)
{
    /************ ۸ ************/
    (void)FncDisCANWkupInt();
    if(N_NetSts.bit.StatusBusSleep == CAN_OFF)
    {
        if(FncChgModCAN(CAN_DRV_CAN_RUN) == CAN_E_OK)
        {
            (void)FncEnCANRcvInt();
            (void)FncEnCANSndInt();
            (void)FncEnCANErrInt();
        }
    }
    N_CtlSts.bit.wkup_fct = CAN_ON;
}

/*****************************************************************************/
/*  Function name : void FncBeforeSlpNM(void)                                */
/*---------------------------------------------------------------------------*/
/*  Description : ECUSleepڍsO                                         */
/*                s^C~O: ECUSleep                                 */
/*                ӎF߂l`FbN̕Kv֐voidLXggp */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
void FncBeforeSlpNM(void)
{
    /************ ۸ ************/
    (void)FncEnCANWkupInt();
}

/*****************************************************************************/
/*  Function name : StatusType GetWkupStsNM(void)                            */
/*---------------------------------------------------------------------------*/
/*  Description : WakeUp荞݌o                                     */
/*                s^C~O: ECUWakeUp                                */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : StatusType CAN_E_OK: WakeUp荞ݔ                      */
/*                         CAN_E_NG: WakeUp荞ݖ                    */
/*****************************************************************************/
StatusType GetWkupStsNM(void)
{
    /************ ĕϐ ************/
    StatusType m_result = CAN_E_NG;

    /************ ۸ ************/
    if(N_CtlSts.bit.wkup_fct == CAN_ON)
    {
        m_result = CAN_E_OK;
    }

    return m_result;
}

/*****************************************************************************/
/*  Function name : StatusType GetStatus(NetStsType *out_ptr_sts)            */
/*---------------------------------------------------------------------------*/
/*  Description : NMȯܰðԂ                                        */
/*                s^C~O: ECUSleepOAC                       */
/*---------------------------------------------------------------------------*/
/*  parameter : NMStsType *out_ptr_sts                                       */
/*  result    : StatusType CAN_E_OK: I                                */
/*                         CAN_E_NG: ُI                                */
/*****************************************************************************/
StatusType GetStatus(NetStsType *out_ptr_sts)
{
    /************ ĕϐ ************/
    StatusType m_result = CAN_E_NG;

    /************ ۸ ************/
    /* NMȯܰðɖȂ             */
    /* قȂԂ׸ނĂĂꍇNGԂ */
    if(((N_NetSts.byte & CAN_NM_INVAL1) == CAN_NM_INVAL1)
    || ((N_NetSts.byte & CAN_NM_INVAL2) == CAN_NM_INVAL2)
    || ((N_NetSts.byte & CAN_NM_INVAL3) == CAN_NM_INVAL3)
    || ((N_NetSts.byte & CAN_NM_INVAL4) == CAN_NM_INVAL4)
    || ((N_NetSts.byte & CAN_NM_INVAL5) == CAN_NM_INVAL5)
    || ((N_NetSts.byte & CAN_NM_INVAL6) == CAN_NM_INVAL6)
    || ((N_NetSts.byte & CAN_NM_INVAL7) == CAN_NM_INVAL7)
    || ((N_NetSts.byte & CAN_NM_INVAL8) == CAN_NM_INVAL8)
    || ((N_NetSts.byte & CAN_NM_INVAL9) == CAN_NM_INVAL9))
    {
        m_result = CAN_E_NG;
    }
    else
    {
        out_ptr_sts->bit.StatusRingStable = N_NetSts.bit.StatusRingStable;
        out_ptr_sts->bit.StatusBusError = N_NetSts.bit.StatusBusError;
        out_ptr_sts->bit.StatusNMActive = N_NetSts.bit.StatusNMActive;
        out_ptr_sts->bit.StatusLimpHome = N_NetSts.bit.StatusLimpHome;
        out_ptr_sts->bit.StatusBusSleep = N_NetSts.bit.StatusBusSleep;
        out_ptr_sts->bit.StatusWaitBusSleep = N_NetSts.bit.StatusWaitBusSleep;
        out_ptr_sts->bit.StatusTxRingDataNotAllowed
                                     = N_NetSts.bit.StatusTxRingDataNotAllowed;
        out_ptr_sts->bit.StatusBusSleepInd = N_NetSts.bit.StatusBusSleepInd;

        m_result = CAN_E_OK;
    }
    return m_result;
}

/*****************************************************************************/
/*  Function name : StatusType GetConfig                                     */
/*                  (CfgKndName in_cfg_knd ,CfgRefType **out_ptr_adr)        */
/*---------------------------------------------------------------------------*/
/*  Description : ݂ǫ̇ܰڰ݂i[                          */
/*                s^C~O: C                                       */
/*---------------------------------------------------------------------------*/
/*  parameter : CfgKndName in_cfg_knd:   ̨ڰðق̎w              */
/*              CfgRefType **out_pr_adr: ̨ڰðق̐擪ڽi[   */
/*  result    : StatusType CAN_E_OK: i[                                */
/*                         CAN_E_NG: i[s                                */
/*****************************************************************************/
StatusType GetConfig(CfgKndName in_cfg_knd ,CfgRefType **out_ptr_adr)
{
    /************ ĕϐ ************/
    StatusType  m_result = CAN_E_OK;

    /************ ۸ ************/
    if(in_cfg_knd == CAN_Normal)
    {
        *out_ptr_adr = &N_Cfg_Prsnt[0];
    }
    else if(in_cfg_knd == CAN_LimpHome)
    {
        *out_ptr_adr = &N_Cfg_LmpHm[0];
    }
    else
    {
        m_result = CAN_E_NG;
    }
    return m_result;
}

/*****************************************************************************/
/*  Function name : static StatusType SetConfig                              */
/*                         (CfgKndName in_cfg_knd, UINT8 in_src_id)          */
/*---------------------------------------------------------------------------*/
/*  Description : ǫ̇ܰڰ݂ݒ肷                                */
/*                s^C~O: AliveMsg,RingMsgM                     */
/*---------------------------------------------------------------------------*/
/*  parameter : CfgKndName in_cfg_knd: ݒ肷̨ڰ݂̎w             */
/*              UINT8 in_src_id: MүSourceID                          */
/*  result    : StatusType CAN_E_OK: i[                                */
/*                         CAN_E_NG: i[s                                */
/*****************************************************************************/
static StatusType SetConfig(CfgKndName in_cfg_knd, UINT8 in_src_id)
{
    /************ ĕϐ ************/
    StatusType  m_result = CAN_E_OK;
    
    /************ ۸ ************/
    if(in_src_id <= (UINT8)CAN_NM_SOURCE_ID_MASK)
    {
        /* NMSourceID͈͓łǫ̇ܰڰ݂Ă */
        if(in_cfg_knd == CAN_Normal)
        {
            N_Cfg_Prsnt[(in_src_id >> CAN_NM_DIV8)]
                  |= ((UINT8)(0x01 << (in_src_id & CAN_NM_RST8)));
        }
        else if(in_cfg_knd == CAN_LimpHome)
        {
            N_Cfg_LmpHm[(in_src_id >> CAN_NM_DIV8)]
                  |= ((UINT8)(0x01 << (in_src_id & CAN_NM_RST8)));
        }
        else
        {
            m_result = CAN_E_NG;
        }
    }
    else
    {
        m_result = CAN_E_NG;
    }
    return m_result;
}

/*****************************************************************************/
/*  Function name : static void InitConfig(CfgKndName m_cfg_knd)             */
/*---------------------------------------------------------------------------*/
/*  Description : ǫ̇ܰڰ݂                              */
/*                s^C~O: NMInit,NMReset                     */
/*---------------------------------------------------------------------------*/
/*  parameter : CfgKndName N_Normal  :Config.present                 */
/*                         N_LimpHome:Config.limphome                */
/*  result    : none                                                         */
/*****************************************************************************/
static void InitConfig(CfgKndName m_cfg_knd)
{
    /************ ĕϐ ************/
    UINT8 lp_tbl;
    UINT8 m_tbl_max;

    /************ ۸ ************/
    m_tbl_max = ((UINT8)CAN_NM_SOURCE_ID_MASK >> CAN_NM_DIV8) + 1;

    if(m_cfg_knd == CAN_Normal)
    {
        for(lp_tbl = 0; lp_tbl < m_tbl_max; lp_tbl++)
        {
            N_Cfg_Prsnt[lp_tbl] = (UINT8)CAN_CLR;
        }
        N_Cfg_Prsnt[(CAN_ALL_MYSELF >> CAN_NM_DIV8)]
         = ((UINT8)(0x01 << (CAN_ALL_MYSELF & CAN_NM_RST8)));
    }
    else /* if(m_cfg_knd == CAN_LimpHome) */
    {
        for(lp_tbl = 0; lp_tbl < m_tbl_max; lp_tbl++)
        {
            N_Cfg_LmpHm[lp_tbl] = (UINT8)CAN_CLR;
        }
    }
}

/*****************************************************************************/
/*  Function name : StatusType GetForm                                       */
/*                             (UINT8 **out_ptr_adr ,UINT8 **out_ptr_num)    */
/*---------------------------------------------------------------------------*/
/*  Description : ݘ_ݸȯܰɎQĂɰނ̐AIDi[     */
/*                s^C~O: C                                       */
/*---------------------------------------------------------------------------*/
/*  parameter : UINT8 **out_pr_adr: _ݸލ\IDðق̐擪ڽi[     */
/*                    **out_pr_num: _ݸލ\ɰސi[                 */
/*  result    : StatusType CAN_E_OK: i[                                */
/*                         CAN_E_NG: i[s                                */
/*****************************************************************************/
StatusType GetForm(UINT8 **out_ptr_adr ,UINT8 **out_ptr_num)
{
    /************ ĕϐ ************/
    StatusType  m_result = CAN_E_NG;

    /************ ۸ ************/
    if(N_NetSts.bit.StatusRingStable == CAN_ON)
    {
        *out_ptr_adr = &N_LogRingNodeTbl[0];
        *out_ptr_num = &N_CntLogRingNode;
        m_result = CAN_E_OK;
    }
    else
    {
        m_result = CAN_E_NG;
    }
    return m_result;
}

/*****************************************************************************/
/*  Function name : StatusType GetStsNM(NMStsType *out_ptr_sts)              */
/*---------------------------------------------------------------------------*/
/*  Description : NMM󋵂i[                                     */
/*                s^C~O: C                                       */
/*---------------------------------------------------------------------------*/
/*  parameter : NMStsType *out_ptr_sts                                       */
/*  result    : StatusType CAN_E_OK:i[                                 */
/*                         CAN_E_NG:i[ُ                                 */
/*****************************************************************************/
StatusType GetStsNM(NMStsType *out_ptr_sts)
{
    /************ ĕϐ ************/
    StatusType  m_result = CAN_E_NG;

    /************ ۸ ************/
    out_ptr_sts->sndstop = N_NMSts.sndstop;
    out_ptr_sts->rcvstop = N_NMSts.rcvstop;
    out_ptr_sts->dummy = CAN_CLR;
    m_result = CAN_E_OK;

    return m_result;
}

/*****************************************************************************/
/*  Function name : StatusType GetCOMCtrlStsNM(NMCOMStsType *out_ptr_com_sts)*/
/*---------------------------------------------------------------------------*/
/*  Description : COM̑M󋵂i[                                  */
/*                s^C~O: C                                       */
/*---------------------------------------------------------------------------*/
/*  parameter : NMCOMStsType *out_ptr_com_sts                                */
/*  result    : StatusType   CAN_E_OK:i[                               */
/*                           CAN_E_NG:i[ُ                               */
/*****************************************************************************/
StatusType GetCOMCtrlStsNM(NMCOMStsType *out_ptr_com_sts)
{
    /************ ĕϐ ************/
    StatusType  m_result = CAN_E_NG;

    /************ ۸ ************/
    out_ptr_com_sts->bit.en_sndque = N_COMSts.bit.en_sndque;
    out_ptr_com_sts->bit.en_snd    = N_COMSts.bit.en_snd;
    out_ptr_com_sts->bit.en_rcvque = N_COMSts.bit.en_rcvque;
    out_ptr_com_sts->bit.en_rcv    = N_COMSts.bit.en_rcv;

    m_result = CAN_E_OK;

    return m_result;
}

/*****************************************************************************/
/*  Function name : StatusType GoToMode(UINT8 in_m_req)                      */
/*---------------------------------------------------------------------------*/
/*  Description : NMSleep/֎~ޯĂ̐                             */
/*                s^C~O: 荞݊֐ȊO                           */
/*---------------------------------------------------------------------------*/
/*  parameter : UINT8 CAN_NM_BUS_SLEEP :Sleep                            */
/*                    CAN_NM_AWAKE     :Sleep֎~                            */
/*  result    : StatusType CAN_E_OK:ύX                                 */
/*                         CAN_E_NG:ύXُ                                 */
/*****************************************************************************/
StatusType GoToMode(UINT8 in_m_req)
{
    /************ ĕϐ ************/
    StatusType  m_result = CAN_E_NG;

    /************ ۸ ************/
    if(in_m_req == CAN_NM_BUS_SLEEP)
    {
        N_ECUSts.req_slp = CAN_ON;
        m_result = CAN_E_OK;
    }
    else if(in_m_req == CAN_NM_AWAKE)
    {
        N_ECUSts.req_slp = CAN_OFF;
        m_result = CAN_E_OK;
    }
    else
    {
        m_result = CAN_E_NG;
    }
    N_ECUSts.dummy = CAN_CLR;

    return m_result;
}

/*****************************************************************************/
/*  Function name : void CallNMRcvMsgDRV                                     */
/*                  (UINT32 can_id, UINT8 dlc, const UINT8 *buff)            */
/*---------------------------------------------------------------------------*/
/*  Description : Mf[^󂯓n                                         */
/*                s^C~O: f[^M荞ݓ                   */
/*                ӎ : ǐ̈׃}WbNiogp                  */
/*---------------------------------------------------------------------------*/
/*  parameter : UINT32 can_id: CAN-ID                                        */
/*              UINT8  dlc   : DLC                                           */
/*              UINT8  *buff : Mf[^i[obt@                        */
/*  result    : none                                                         */
/*****************************************************************************/
void CallNMRcvMsgDRV(UINT32 can_id, UINT8 dlc, const UINT8 *buff)
{
    /* ----- ϐ ----- */
    UINT8 lp_cnt;
    
    /* ----- ----- */
    if( NMRcvQue.rd_ptr != NMRcvQue.wr_ptr  )
    {
        NMRcvQue.msg[NMRcvQue.wr_ptr].can_id = (UINT16)can_id;
        NMRcvQue.msg[NMRcvQue.wr_ptr].dlc = dlc ;
        NMRcvQue.msg[NMRcvQue.wr_ptr].data.byte[0] = buff[0];
        NMRcvQue.msg[NMRcvQue.wr_ptr].data.byte[1] = buff[1];
        NMRcvQue.msg[NMRcvQue.wr_ptr].data.byte[2] = buff[2];
        NMRcvQue.msg[NMRcvQue.wr_ptr].data.byte[3] = buff[3];
        NMRcvQue.msg[NMRcvQue.wr_ptr].data.byte[4] = buff[4];
        NMRcvQue.msg[NMRcvQue.wr_ptr].data.byte[5] = buff[5];
        NMRcvQue.msg[NMRcvQue.wr_ptr].data.byte[6] = buff[6];
        NMRcvQue.msg[NMRcvQue.wr_ptr].data.byte[7] = buff[7];
        
        NMRcvQue.wr_ptr++;
        /* NMML[݃|C^MAXȂNA */
        if(NMRcvQue.wr_ptr >= CAN_NM_NUM_RCVQUE)
        {
            NMRcvQue.wr_ptr = (UINT8)CAN_CLR;
        }
        else
        {
            /* Ȃ */
        }
    }/* NMML[͈t */
}

/*****************************************************************************/
/*  Function name : void CallNMSndMsgDRV(void)                               */
/*---------------------------------------------------------------------------*/
/*  Description : MbZ[WNMML[ɏ                 */
/*                s^C~O: f[^M荞ݓ                   */
/*---------------------------------------------------------------------------*/
/*  parameter : none                                                         */
/*  result    : none                                                         */
/*****************************************************************************/
void CallNMSndMsgDRV(void)
{
    CallNMRcvMsgDRV((UINT32)(N_SndMsg.can_id), N_SndMsg.dlc, N_SndMsg.data.byte);
}
/*-------------------------------- END OF FILE ------------------------------*/
