/*
 *  can_com_table.c
 *  Fri Oct 26 17:41:59 2007
 *  SG Version 2.11
 *  directnm_sg.exe directNM_canmw.oil -I ../sg/impl_oil -lj -directnm_canmw
 */
#include "can_cmn.h"
#include "can_com_def.h"
#include "can_com_ext.h"

/* CANIDƃf[^ID֘Ae[u */
const CANIDType CANID_TABLE[CAN_COM_NUM_CANID] = {
	{ 0x210, CAN_COM_DATAID_IS_CANID },
	{ 0x220, CAN_COM_DATAID_IS_CANID },
	{ 0x230, CAN_COM_DATAID_IS_CANID },
	{ 0x240, CAN_COM_DATAID_IS_CANID },
	{ 0x110, CAN_COM_DATAID_IS_CANID },
	{ 0x120, CAN_COM_DATAID_IS_CANID },
	{ 0x130, CAN_COM_DATAID_IS_CANID },
	{ 0x140, CAN_COM_DATAID_IS_CANID }
};

/* Mf[^֘Ae[u */
const CANRcvDataType CANRCVDATA_TABLE[CAN_COM_NUM_RCVDATA] = {
	{ 0x210, 8, 1000, 1000,
		CAN_COM_GET_DATA_8BYTE, CAN_COM_GET_DATA_AND_0,
		{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }
	},
	{ 0x220, 8, 1000, 1000,
		CAN_COM_GET_DATA_8BYTE, CAN_COM_GET_DATA_AND_0,
		{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }
	},
	{ 0x230, 8, 1000, 1000,
		CAN_COM_GET_DATA_8BYTE, CAN_COM_GET_DATA_AND_0,
		{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }
	},
	{ 0x240, 8, 1000, 1000,
		CAN_COM_GET_DATA_8BYTE, CAN_COM_GET_DATA_AND_0,
		{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }
	}
};

/* Mf[^֘Ae[u */
const CANSndDataType CANSNDDATA_TABLE[CAN_COM_NUM_SNDDATA] = {
	{ 0x110, 0x110, CAN_COM_PERIODIC_MODE, CAN_FALSE,
		8, 200, 200,
		{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }
	},
	{ 0x120, 0x120, CAN_COM_EVENT_MODE, CAN_FALSE,
		8, 0, 0,
		{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }
	},
	{ 0x130, 0x130, CAN_COM_EVENT_PERIODIC_MODE, CAN_FALSE,
		8, 200, 100,
		{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }
	},
	{ 0x140, 0x140, CAN_COM_CHGSND_PERIODIC_MODE, CAN_FALSE,
		8, 200, 100,
		{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }
	}
};


