/********************************************************************************
 *
 *	FILE NAME	:	clg3_io.h
 *	CREATE		:	2007.10.26
 *	MCU			:	M32/C 85
 *	VERSION		:	1.00
 *	DESCRIPTION	:	
 *
 *==history======================================================================
 *
 ********************************************************************************/

#ifndef ___CLG3_IO_HEADER___
#define ___CLG3_IO_HEADER___

/********************************************************************************
 *		definition Section														*
 ********************************************************************************/
/* ACCESS */
#define CLG3_SW_LO		(unsigned char)(0x0F)
#define CLG3_SW_HI		(unsigned char)(0xF0)
#define CLG3_PUSH_ALL	(unsigned char)(0xF0)

#define CLG3_SW_OLD		(0)
#define CLG3_SW_NOW		(1)
#define CLG3_SW_TRG		(2)

/* MASK */
#define CLG3_DIP_SW1	(unsigned char)(0x01)
#define CLG3_DIP_SW2	(unsigned char)(0x02)
#define CLG3_DIP_SW3	(unsigned char)(0x04)
#define CLG3_DIP_SW4	(unsigned char)(0x08)
#define CLG3_DIP_SW5	(unsigned char)(0x10)
#define CLG3_DIP_SW6	(unsigned char)(0x20)
#define CLG3_DIP_SW7	(unsigned char)(0x40)
#define CLG3_DIP_SW8	(unsigned char)(0x80)
#define CLG3_PUSH_K10	(unsigned char)(0x10)
#define CLG3_PUSH_K11	(unsigned char)(0x20)
#define CLG3_PUSH_K12	(unsigned char)(0x40)
#define CLG3_PUSH_K13	(unsigned char)(0x80)

/********************************************************************************
 *		Extern Section															*
 ********************************************************************************/
extern unsigned char clg3InitIo(void);
extern unsigned char clg3InputIo(void);
extern unsigned char clg3GetPush(unsigned char,unsigned char);
extern unsigned char clg3GetDip(unsigned char sts);
extern unsigned char clg3SetDig(unsigned char,unsigned char,unsigned char);
extern unsigned char clg3DispDig(void);

#endif	/* ___CLG_IO_HEADER___ */

