/*
 *	TOPPERS NonOS CAN Middleware
 *		Toyohashi Open Platform for Embedded Real-Time Systems
 *		NonOS CAN Middleware
 * 
 *	Copyright (C) 2007 Sunny Giken Inc.
 * 
 *	L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *	ɂČ\Ă GNU General Public License  Version 2 ɋL
 *	qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *	ς̂܂ށDȉjgpEEρEĔzziȉC
 *	pƌĂԁj邱Ƃ𖳏ŋD
 *	(1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *		\C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *		XR[hɊ܂܂Ă邱ƁD
 *	(2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *		pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *		҃}jAȂǁjɁCL̒쌠\C̗pщL
 *		̖ۏ؋Kfڂ邱ƁD
 *	(3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *		płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *		ƁD
 *	  (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *		  쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *	  (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *		  񍐂邱ƁD
 *	(4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *		QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *	{\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *	TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *	܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *	ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */
/*
 *@Version 1.00  2007.10.26
 */

#ifndef __CAN_COM_H_INCLUDE__
#define __CAN_COM_H_INCLUDE__

/*---------------------------------------------------------------------------*/
/* ft@C`                                                            */
/*---------------------------------------------------------------------------*/
/* Mr⎞ */
#define CAN_COM_SNDITVCNT_DEFDATA   ((UINT16)(CAN_COM_TIME_SNDSTOP/CAN_COM_MAIN_CYCLE))

/* COM샂[h */
#define CAN_COM_SNDMODE_MASK        ((UINT8)(0x07))   /* COMe[uM[ĥݎ擾       */
#define CAN_COM_STOPINF_MASK        ((UINT8)(0x30))   /* COMXe[^XMr̂݌o */
#define CAN_COM_MODE_MASK           ((UINT8)(0x0F))   /* COMXe[^XM̂݌o */

/* CANbZ[W */
#define CAN_COM_MSG_ID              ((UINT8)(0))      /* bZ[WID̈        */
#define CAN_COM_DATA_2              ((UINT8)(1))      /* bZ[WDATA2̈     */
#define CAN_COM_DATA_3              ((UINT8)(2))      /* bZ[WDATA3̈     */
#define CAN_COM_DATA_4              ((UINT8)(3))      /* bZ[WDATA4̈     */
#define CAN_COM_DATA_5              ((UINT8)(4))      /* bZ[WDATA5̈     */
#define CAN_COM_DATA_6              ((UINT8)(5))      /* bZ[WDATA6̈     */
#define CAN_COM_DATA_7              ((UINT8)(6))      /* bZ[WDATA7̈     */
#define CAN_COM_DATA_8              ((UINT8)(7))      /* bZ[WDATA8̈     */
#define CAN_COM_DLC_SIZE            ((UINT8)(8))      /* CANbZ[WDLC      */
#define CAN_COM_DLC_1               ((UINT8)(1))      /* COMbZ[WMsg-ID̈ */

/* oCxg */
#define CAN_COM_NO_EVENT            ((UINT8)(0))      /* Cxgo                          */
#define CAN_COM_ON_EVENT            ((UINT8)(1))      /* ONCxg(Cxg+M(^Cv2))  */
#define CAN_COM_OFF_EVENT           ((UINT8)(2))      /* OFFCxg(Cxg+M(^Cv2)) */
#define CAN_COM_CNG_EVENT           ((UINT8)(3))      /* ChangeCxg                          */

/* UpdtSndIDStsCOM(),UpdtRcvIDStsCOM(),UpdtDrvSndStsCOM()̈ */
#define CAN_COM_POWERON_INIT        ((UINT8)(0))      /* N               */
#define CAN_COM_INIT                ((UINT8)(1))      /* ʏ평                 */
#define CAN_COM_RFSH                ((UINT8)(2))      /* tbV               */
#define CAN_COM_SNDSTP              ((UINT8)(3))      /* Mr⎞                   */
#define CAN_COM_SNDQUE              ((UINT8)(4))      /* bZ[WML[i[   */
#define CAN_COM_BKUP                ((UINT8)(5))      /* bZ[WobNAbvi[ */
#define CAN_COM_LIMIT               ((UINT8)(6))      /* bZ[Wi[s\         */
#define CAN_COM_SND_OK              ((UINT8)(7))      /* M                   */
#define CAN_COM_SND_NG              ((UINT8)(8))      /* Ms                   */
#define CAN_COM_RCV_OK              ((UINT8)(9))      /* 탁bZ[WM         */
#define CAN_COM_RCV_NG              ((UINT8)(10))     /* ُ탁bZ[WM         */
#define CAN_COM_OVR                 ((UINT8)(11))     /* I[o[bZ[WM */
#define CAN_COM_RCVSTP              ((UINT8)(12))     /* Mr⎞                   */
#define CAN_COM_EVENT               ((UINT8)(13))     /* CxgbZ[WM     */
#define CAN_COM_PERI                ((UINT8)(14))     /* MbZ[WM     */
#define CAN_COM_IDLE                ((UINT8)(15))     /* MACh               */
#define CAN_COM_SND                 ((UINT8)(16))     /* M                     */

/* SetRcvMsgBufCOM()̖߂l */
#define CAN_E_COM_OKRCV             (0)               /* OKf[^M                 */
#define CAN_E_COM_NGRCV             (1)               /* NGf[^M                 */
#define CAN_E_COM_NORCV             (2)               /* f[^M                 */

/* Mf[^IDXe[^XXVl */
#define CAN_COM_SNDSTS_PWON_INIT    ((UINT8)(0x01))   /* N               */
#define CAN_COM_SNDSTS_INIT_MASK    ((UINT8)(0x20))   /* }XN               */
#define CAN_COM_SNDSTS_INIT         ((UINT8)(0x01))   /*                      */
#define CAN_COM_SNDSTS_RFSH_MASK    ((UINT8)(0x60))   /* tbV}XN         */
#define CAN_COM_SNDSTS_RFSH         ((UINT8)(0x01))   /* tbV               */
#define CAN_COM_SNDSTS_SNDSTP       ((UINT8)(0x61))   /* Mr⎞                   */
#define CAN_COM_SNDSTS_MASK         ((UINT8)(0x71))   /* bZ[Wi[ԃ}XN     */
#define CAN_COM_SNDSTS_SNDQUE       ((UINT8)(0x02))   /* bZ[WML[i[   */
#define CAN_COM_SNDSTS_BKUP         ((UINT8)(0x04))   /* bZ[WobNAbvi[ */
#define CAN_COM_SNDSTS_LIMIT        ((UINT8)(0x0C))   /* bZ[Wi[s\         */
#define CAN_COM_SNDSTS_SND_OK       ((UINT8)(0xEF))   /* M                   */
#define CAN_COM_SNDSTS_SND_NG       ((UINT8)(0x10))   /* Ms                   */

/* Mf[^IDXe[^XXVl */
#define CAN_COM_RCVSTS_INIT         ((UINT8)(0x10))   /*                      */
#define CAN_COM_RCVSTS_RFSH         ((UINT8)(0x11))   /* tbV               */
#define CAN_COM_RCVSTS_RCV_OK       ((UINT8)(0x03))   /* 탁bZ[WM         */
#define CAN_COM_RCVSTS_RCV_NG       ((UINT8)(0x08))   /* ُ탁bZ[WM         */
#define CAN_COM_RCVSTS_RCVSTP       ((UINT8)(0x04))   /* Mr⎞                   */

/* hCoMXe[^XXVl */
#define CAN_COM_DRVSNDSTS_MASK      ((UINT8)(7))      /* Xe[^X}XNl               */
#define CAN_COM_DRVSNDSTS_EVENT     ((UINT8)(1))      /* CxgbZ[WM         */
#define CAN_COM_DRVSNDSTS_PERI      ((UINT8)(2))      /* MbZ[WM         */
#define CAN_COM_DRVSNDSTS_IDLE      ((UINT8)(4))      /* MACh(MԊuۏ؊m) */
#define CAN_COM_DRVSNDSTS_SND       ((UINT8)(3))      /* M                         */

/* Mf[^Ԓ萔 */
#define CAN_E_COM_OK                ((UINT8)(1))      /* 푗M                     */
#define CAN_E_COM_NG                ((UINT8)(4))      /* ̑vɂAMs   */

#define CAN_COM_NO_MODE                 ((UINT8)(0))  /* MȂ            */
#define CAN_COM_EVENT_MODE              ((UINT8)(1))  /* CxgM        */
#define CAN_COM_PERIODIC_MODE           ((UINT8)(2))  /* M            */
#define CAN_COM_EVENT_PERIODIC_MODE     ((UINT8)(3))  /* CxgM    */
#define CAN_COM_CHGSND_PERIODIC_MODE    ((UINT8)(4))  /* CxgM    */

/*---------------------------------------------------------------------------*/
/* ^`                                                                    */
/*---------------------------------------------------------------------------*/
/* Mf[^Xe[^X */
typedef struct{
    CANAPIDataStsType   sts;    /* Xe[^X                             */
    DataType    backup;         /* Mf[^obNAbv̈             */
    UINT8       pri;            /* MvCIeB                     */
    UINT16      pre_time;       /* O񑗐M                           */
    UINT8       chgsndperi:1;   /* Cxg+M(^Cv2)MtO */
    UINT8       keep_intv:1;    /* MԊuۏؒtO                   */
    UINT8       dummy:6;
}COMSndDataStsType;

/* hCoMXe[^X */
typedef union{
    struct{
        UINT8       event:1;        /* OCxgMtO */
        UINT8       peri:1;         /* OMtO     */
        UINT8       idle:1;         /* MAChtO     */
        UINT8       dummy:5;
    }bit;
    UINT8   byte;
}COMSndDRVStsType;

/* COMML[ */
typedef struct{
    UINT8 rd_ptr;                       /* ǂݍ݃|C^                 */
    UINT8 wr_ptr;                       /* ݃|C^                 */
    CANMsgType  msg[CAN_COM_NUM_RCVQUE];/* CANMbZ[W                */
}COMRcvQueType;

/* COMML[ */
typedef struct{
    CANMsgType  msg;                    /* CANMbZ[W                */
    UINT16      snd_time;               /* M\莞                     */
    UINT8       pri;                    /* MvCIeB               */
    UINT8       own_node:1;             /* OWN_NODEtO                   */
    UINT8       dummy:7;
}COMSndQueType;

#endif /* __CAN_COM_H_INCLUDE__ */
