/*
 *  can_com_api.h
 *  Fri Oct 26 17:41:55 2007
 *  SG Version 2.11
 *  directnm_sg.exe directNM_canmw.oil -I ../sg/impl_oil -lj -directnm_canmw
 */
#ifndef CAN_COM_API_H
#define CAN_COM_API_H


/* Mf[^p̒` */
union APIDataType {
	struct {
		UINT8	RCVDATA1_1:8;
		UINT8	RCVDATA1_2:8;
		UINT8	RCVDATA1_3:8;
		UINT8	RCVDATA1_4:8;
		UINT8	RCVDATA1_5:8;
		UINT8	RCVDATA1_6:8;
		UINT8	RCVDATA1_7:8;
		UINT8	RCVDATA1_8:8;
	} RCVDATA1_def;
	struct {
		UINT8	RCVDATA2_1:8;
		UINT8	RCVDATA2_2:8;
		UINT8	RCVDATA2_3:8;
		UINT8	RCVDATA2_4:8;
		UINT8	RCVDATA2_5:8;
		UINT8	RCVDATA2_6:8;
		UINT8	RCVDATA2_7:8;
		UINT8	RCVDATA2_8:8;
	} RCVDATA2_def;
	struct {
		UINT8	RCVDATA3_1:8;
		UINT8	RCVDATA3_2:8;
		UINT8	RCVDATA3_3:8;
		UINT8	RCVDATA3_4:8;
		UINT8	RCVDATA3_5:8;
		UINT8	RCVDATA3_6:8;
		UINT8	RCVDATA3_7:8;
		UINT8	RCVDATA3_8:8;
	} RCVDATA3_def;
	struct {
		UINT8	RCVDATA4_1:8;
		UINT8	RCVDATA4_2:8;
		UINT8	RCVDATA4_3:8;
		UINT8	RCVDATA4_4:8;
		UINT8	RCVDATA4_5:8;
		UINT8	RCVDATA4_6:8;
		UINT8	RCVDATA4_7:8;
		UINT8	RCVDATA4_8:8;
	} RCVDATA4_def;
	struct {
		UINT8	SNDDATA1_1:8;
		UINT8	SNDDATA1_2:8;
		UINT8	SNDDATA1_3:8;
		UINT8	SNDDATA1_4:8;
		UINT8	SNDDATA1_5:8;
		UINT8	SNDDATA1_6:8;
		UINT8	SNDDATA1_7:8;
		UINT8	SNDDATA1_8:8;
	} SNDDATA1_def;
	struct {
		UINT8	SNDDATA2_1:8;
		UINT8	SNDDATA2_2:8;
		UINT8	SNDDATA2_3:8;
		UINT8	SNDDATA2_4:8;
		UINT8	SNDDATA2_5:8;
		UINT8	SNDDATA2_6:8;
		UINT8	SNDDATA2_7:8;
		UINT8	SNDDATA2_8:8;
	} SNDDATA2_def;
	struct {
		UINT8	SNDDATA3_1:8;
		UINT8	SNDDATA3_2:8;
		UINT8	SNDDATA3_3:8;
		UINT8	SNDDATA3_4:8;
		UINT8	SNDDATA3_5:8;
		UINT8	SNDDATA3_6:8;
		UINT8	SNDDATA3_7:8;
		UINT8	SNDDATA3_8:8;
	} SNDDATA3_def;
	struct {
		UINT8	SNDDATA4_1:8;
		UINT8	SNDDATA4_2:8;
		UINT8	SNDDATA4_3:8;
		UINT8	SNDDATA4_4:8;
		UINT8	SNDDATA4_5:8;
		UINT8	SNDDATA4_6:8;
		UINT8	SNDDATA4_7:8;
		UINT8	SNDDATA4_8:8;
	} SNDDATA4_def;
	UINT8 byte[8];
	UINT16 word[4];
};

/* APIobt@OQ */
extern union APIDataType  api_rcvdata[CAN_COM_NUM_RCVDATA];
extern union APIDataType  api_snddata[CAN_COM_NUM_SNDDATA];

/* [UANZXp}N */
#define  RCVDATA1_1	api_rcvdata[0].RCVDATA1_def.RCVDATA1_1
#define  RCVDATA1_2	api_rcvdata[0].RCVDATA1_def.RCVDATA1_2
#define  RCVDATA1_3	api_rcvdata[0].RCVDATA1_def.RCVDATA1_3
#define  RCVDATA1_4	api_rcvdata[0].RCVDATA1_def.RCVDATA1_4
#define  RCVDATA1_5	api_rcvdata[0].RCVDATA1_def.RCVDATA1_5
#define  RCVDATA1_6	api_rcvdata[0].RCVDATA1_def.RCVDATA1_6
#define  RCVDATA1_7	api_rcvdata[0].RCVDATA1_def.RCVDATA1_7
#define  RCVDATA1_8	api_rcvdata[0].RCVDATA1_def.RCVDATA1_8
#define  RCVDATA2_1	api_rcvdata[1].RCVDATA2_def.RCVDATA2_1
#define  RCVDATA2_2	api_rcvdata[1].RCVDATA2_def.RCVDATA2_2
#define  RCVDATA2_3	api_rcvdata[1].RCVDATA2_def.RCVDATA2_3
#define  RCVDATA2_4	api_rcvdata[1].RCVDATA2_def.RCVDATA2_4
#define  RCVDATA2_5	api_rcvdata[1].RCVDATA2_def.RCVDATA2_5
#define  RCVDATA2_6	api_rcvdata[1].RCVDATA2_def.RCVDATA2_6
#define  RCVDATA2_7	api_rcvdata[1].RCVDATA2_def.RCVDATA2_7
#define  RCVDATA2_8	api_rcvdata[1].RCVDATA2_def.RCVDATA2_8
#define  RCVDATA3_1	api_rcvdata[2].RCVDATA3_def.RCVDATA3_1
#define  RCVDATA3_2	api_rcvdata[2].RCVDATA3_def.RCVDATA3_2
#define  RCVDATA3_3	api_rcvdata[2].RCVDATA3_def.RCVDATA3_3
#define  RCVDATA3_4	api_rcvdata[2].RCVDATA3_def.RCVDATA3_4
#define  RCVDATA3_5	api_rcvdata[2].RCVDATA3_def.RCVDATA3_5
#define  RCVDATA3_6	api_rcvdata[2].RCVDATA3_def.RCVDATA3_6
#define  RCVDATA3_7	api_rcvdata[2].RCVDATA3_def.RCVDATA3_7
#define  RCVDATA3_8	api_rcvdata[2].RCVDATA3_def.RCVDATA3_8
#define  RCVDATA4_1	api_rcvdata[3].RCVDATA4_def.RCVDATA4_1
#define  RCVDATA4_2	api_rcvdata[3].RCVDATA4_def.RCVDATA4_2
#define  RCVDATA4_3	api_rcvdata[3].RCVDATA4_def.RCVDATA4_3
#define  RCVDATA4_4	api_rcvdata[3].RCVDATA4_def.RCVDATA4_4
#define  RCVDATA4_5	api_rcvdata[3].RCVDATA4_def.RCVDATA4_5
#define  RCVDATA4_6	api_rcvdata[3].RCVDATA4_def.RCVDATA4_6
#define  RCVDATA4_7	api_rcvdata[3].RCVDATA4_def.RCVDATA4_7
#define  RCVDATA4_8	api_rcvdata[3].RCVDATA4_def.RCVDATA4_8
#define  SNDDATA1_1	api_snddata[0].SNDDATA1_def.SNDDATA1_1
#define  SNDDATA1_2	api_snddata[0].SNDDATA1_def.SNDDATA1_2
#define  SNDDATA1_3	api_snddata[0].SNDDATA1_def.SNDDATA1_3
#define  SNDDATA1_4	api_snddata[0].SNDDATA1_def.SNDDATA1_4
#define  SNDDATA1_5	api_snddata[0].SNDDATA1_def.SNDDATA1_5
#define  SNDDATA1_6	api_snddata[0].SNDDATA1_def.SNDDATA1_6
#define  SNDDATA1_7	api_snddata[0].SNDDATA1_def.SNDDATA1_7
#define  SNDDATA1_8	api_snddata[0].SNDDATA1_def.SNDDATA1_8
#define  SNDDATA2_1	api_snddata[1].SNDDATA2_def.SNDDATA2_1
#define  SNDDATA2_2	api_snddata[1].SNDDATA2_def.SNDDATA2_2
#define  SNDDATA2_3	api_snddata[1].SNDDATA2_def.SNDDATA2_3
#define  SNDDATA2_4	api_snddata[1].SNDDATA2_def.SNDDATA2_4
#define  SNDDATA2_5	api_snddata[1].SNDDATA2_def.SNDDATA2_5
#define  SNDDATA2_6	api_snddata[1].SNDDATA2_def.SNDDATA2_6
#define  SNDDATA2_7	api_snddata[1].SNDDATA2_def.SNDDATA2_7
#define  SNDDATA2_8	api_snddata[1].SNDDATA2_def.SNDDATA2_8
#define  SNDDATA3_1	api_snddata[2].SNDDATA3_def.SNDDATA3_1
#define  SNDDATA3_2	api_snddata[2].SNDDATA3_def.SNDDATA3_2
#define  SNDDATA3_3	api_snddata[2].SNDDATA3_def.SNDDATA3_3
#define  SNDDATA3_4	api_snddata[2].SNDDATA3_def.SNDDATA3_4
#define  SNDDATA3_5	api_snddata[2].SNDDATA3_def.SNDDATA3_5
#define  SNDDATA3_6	api_snddata[2].SNDDATA3_def.SNDDATA3_6
#define  SNDDATA3_7	api_snddata[2].SNDDATA3_def.SNDDATA3_7
#define  SNDDATA3_8	api_snddata[2].SNDDATA3_def.SNDDATA3_8
#define  SNDDATA4_1	api_snddata[3].SNDDATA4_def.SNDDATA4_1
#define  SNDDATA4_2	api_snddata[3].SNDDATA4_def.SNDDATA4_2
#define  SNDDATA4_3	api_snddata[3].SNDDATA4_def.SNDDATA4_3
#define  SNDDATA4_4	api_snddata[3].SNDDATA4_def.SNDDATA4_4
#define  SNDDATA4_5	api_snddata[3].SNDDATA4_def.SNDDATA4_5
#define  SNDDATA4_6	api_snddata[3].SNDDATA4_def.SNDDATA4_6
#define  SNDDATA4_7	api_snddata[3].SNDDATA4_def.SNDDATA4_7
#define  SNDDATA4_8	api_snddata[3].SNDDATA4_def.SNDDATA4_8

#endif	/* ! CAN_COM_API_H */

